function Downloader(source, destination, oncomplete, onerror, onprogress) {
	this.source = source;
	this.destination = destination;
	this.fileTransfer = new FileTransfer();
	this.oncomplete = oncomplete;
	this.onerror = onerror;
	this.fileTransfer.onprogress = function (progress) {
		progress.loaded += $this.progress0;
		progress.total += $this.progress0;
		onprogress(progress);
	};
	var $this = this;
}

Downloader.prototype.start = function () {
	var $this = this;
	this.getProgress(function (progress) {
		$this.progress0 = progress;
		$this.fileTransfer.download(
			$this.source,
			$this.destination,
			$this.oncomplete,
			function (error) {
				if (error.code != FileTransferError.ABORT_ERR)
					$this.onerror(error);
			},
			true,
			{
				headers: {
					'Range': "bytes=" + progress + '-',
					'Authorization': "Bearer " + localStorage.token
				}
			}
		);
	}, onerror);
};

Downloader.prototype.pause = function () {
	this.fileTransfer.abort();
};

Downloader.prototype.reset = function (onsucceed, onerror) {
	resolveLocalFileSystemURL(this.destination, function (entry) {
		entry.remove(onsucceed, onerror);
	}, function (error) {
		if (error.code != FileError.NOT_FOUND_ERR)
			onerror(error);
	});
};

Downloader.prototype.getProgress = function (onsucceed, onerror) {
	resolveLocalFileSystemURL(this.destination, function (entry) {
		entry.getMetadata(function (metadata) {
			onsucceed(metadata.size);
		}, onerror);
	}, function (error) {
		if (error.code == FileError.NOT_FOUND_ERR)
			onsucceed(0);
		else
			onerror();
	});
};
