window.positionService = new PositionService();
if (ionic.Platform.isWebView())
	document.addEventListener('deviceready', function () {
		window.positionService.posite();
	});
else
	window.positionService.posite();
function PositionService() {
	var $this = this;
	this.position = null;
	this.posite = posite;
	function posite() {
		if (window.app)
			cordova.plugins.permissions.requestPermission(cordova.plugins.permissions.ACCESS_FINE_LOCATION, function (status) {
			if (!status.hasPermission) {
				console.log("position permission denied");
				return;
			}
			geolocation.watchPosition(function (position) {
				$this.position = position;
				$this.onchange(position);
			}, {
				provider: 'network',
				minTime: 2000,
				minDistance: 10
			}),
			geolocation.watchPosition(function (position) {
				$this.position = position;
				$this.onchange(position);
			}, {
				provider: 'gps',
				minTime: 2000,
				minDistance: 10
			});
			}, function () {
				console.log("position permission denied");
			});
		else
			navigator.geolocation.watchPosition(function (position) {
				$this.position = position.coords;
				$this.onchange(position.coords);
			}, undefined, {
				enableHighAccuracy: true
			});
	}
	function setAddress(position) {
		var injector = angular.element(document.body).injector();
		var cityService = injector.get('cityService');
		cityService.geocode({
			lat: position.latitude,
			lng: position.longitude
		}).then(function (result) {
			window.positionService.address = result;
		});
	}
	var listener = [];
	this.listener = listener;
	this.onchange = function (position) {
		for (var i in listener)
			setTimeout(function () {
				listener[i](position);
			}, 0);
	};
	listener['geocode'] = setAddress;
}
