// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
var app = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
if ( app ) {
    isDeviceReady = false;
} else {
    isDeviceReady = true;
}
document.addEventListener('deviceready', function onDeviceReady() {
  isDeviceReady = true;
  navigator.splashscreen.hide();
}, false);

angular.module('starter.controllers', [])
angular.module('starter.services', [])
angular.module('starter.directives', [])
angular.module('starter.filters', [])
angular.module('starter', ['ionic', 'ngAnimate', 'ngSanitize', 'btford.markdown', 'starter.controllers', 'starter.services', 'starter.directives', 'starter.filters', 'ngCordova', 'ngCordova.plugins.camera', 'ion-alpha-scroll', 'simple-sprite', 'carousel', 'angular-cssx', 'contenteditable', 'ngTextFill', 'ngWaterfall','ng-sortable'])
.run(function($q, $until, $http, $ionicPlatform, $state, $stateParams, $rootScope, loginService, pullingService,collectionCache,geobrowseService, activity, $ionicHistory) {
	if(localStorage.guideVideo == undefined && location.protocol == "file:") {
		window.location.href = '#/app/guide-video';
		var guideVideo = $rootScope.$on('$ionicView.leave', function () {
			if ($ionicHistory.backView().stateId == 'app.guide-video') {
				activity.showActivity();
			};
			guideVideo();
		})
	} else {
		activity.showActivity();
	}
	$ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
    if(ionic.Platform.device().platform == 'browser') {
      ionic.Platform.fullScreen();
    }
  });
  $rootScope.user = localStorage.user;
	$rootScope.userType = localStorage.userType;
  	$rootScope.geobrowse = geobrowseService.geobrowse;
  	$rootScope.$state = $state;
  	$rootScope.$stateParams = $stateParams;
  	if (new Date() > +localStorage["token.expiry"])
  		loginService.logout();
  	if (localStorage.userType == 0 || localStorage.userType > 1)
		pullingService.start();
	collectionCache.category()
	.then(function (categories) {
		$rootScope.categories = window.categories = Array.index(categories, 'name');
	});
	$http.post('/youbanban/open_app')
})
.config(function($ionicConfigProvider, $sceDelegateProvider) {
  $ionicConfigProvider.navBar.alignTitle('center');
  $ionicConfigProvider.views.forwardCache(true);
  $sceDelegateProvider.resourceUrlWhitelist(['**']);
});
