Array.index = function (array, index) {
	if (!index) index = 'id';
	var x = {};
	for (var i in array)
		x[array[i][index]] = array[i];
	return x;
};
//snippet from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/find
if (!Array.prototype.find) {
	Object.defineProperty(Array.prototype, 'find', {
		value: function (predicate) {
			'use strict';
			if (this == null) {
				throw new TypeError('Array.prototype.find called on null or undefined');
			}
			if (typeof predicate !== 'function') {
				throw new TypeError('predicate must be a function');
			}
			var list = Object(this);
			var length = list.length >>> 0;
			var thisArg = arguments[1];
			var value;

			for (var i = 0; i < length; i++) {
				value = list[i];
				if (predicate.call(thisArg, value, i, list)) {
					return value;
				}
			}
			return undefined;
		}
	});
}
Object.defineProperty(Array.prototype, 'partition', {
	value: function (predicate) {
		var a = [], b = [];
		for (var i in this) {
			var element = this[i];
			if (predicate(element))
				a.push(element);
			else
				b.push(element);
		}
		return [a, b];
	}
});
Object.defineProperty(Array.prototype, 'groupBy', {
	value: function (grouper) {
		var groups = {};
		for (var i in this) {
			var element = this[i];
			var key = grouper(element);
			if (!groups[key])
				groups[key] = [];
			groups[key].push(element);
		}
		return groups;
	}
});
Object.defineProperty(Array.prototype, 'includes', {
	value: function (value) {
		return this.indexOf(value) != -1;
	}
});
Object.defineProperty(String.prototype, 'includes', {
	value: function (value) {
		return this.indexOf(value) != -1;
	}
});
if (!Array.prototype.last) {
	Object.defineProperty(Array.prototype, "last", {
		get: function () {
			return this[this.length - 1];
		}
	});
}
//polyfill from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/endsWith
if (!String.prototype.endsWith) {
	String.prototype.endsWith = function (searchString, position) {
		var subjectString = this.toString();
		if (typeof position !== 'number' || !isFinite(position) || Math.floor(position) !== position || position > subjectString.length) {
			position = subjectString.length;
		}
		position -= searchString.length;
		var lastIndex = subjectString.lastIndexOf(searchString, position);
		return lastIndex !== -1 && lastIndex === position;
	};
}