angular.module('starter.controllers')
.controller('AppCtrl', function($scope, $state,$q,$window,$ionicHistory,$ionicPopup,$http,$rootScope,$location,loginService,$ionicModal) {

  // With the new view caching in Ionic, Controllers are only called
  // when they are recreated or on app start, instead of every page change.
  // To listen for when this page is active (for example, to refresh data),
  // listen for the $ionicView.enter event:
  // $scope.$on('$ionicView.enter', function(e) {
  // });

  $scope.loginout = function() {
  	$ionicPopup.show({
        title: '确认退出？',
        buttons: [{
            text: '取消'
        },{
            text: '确认',
            type: 'button-positive',
            onTap:function () {
            	loginService.logout();
							$ionicHistory.clearCache();
							$ionicHistory.nextViewOptions({
								disableBack: true
							});
							window.location.href = '#/app/home';
            }
        }]
    });
  };
  $scope.NotLoggedIn = function () {
  	if (!window.app && ionic.Platform.isWebView()) {
  		return $ionicModal.fromTemplateUrl('templates/external.html', {
			scope: $scope,
			animation: 'slide-in-up'
  		}).then(function (modal) {
			$scope.externalmodal = modal;
			modal.wait();
  		});
  	}
  	return $ionicPopup.confirm({
  		title: '您尚未登录，登录后您可以使用更多功能…',
  		okText: '登录',
  		cancelText: '不了'
  	}).then(function (ok) {
  		return ok ?
			$state.call("app.login") :
			$q.reject();
  	}).then(function () {
		if($ionicHistory.currentView().url.indexOf('/app/user/') == 0) {
			$state.go('app.user', {id: localStorage.user}, {location: 'replace'});
		}
	});
  };
  $scope.requireLogin = function () {
  	return $state.call("app.login");
  };
  $rootScope.requireApp = function () {
	  return $ionicModal.fromTemplateUrl('templates/external.html', {
		  scope: $scope,
		  animation: 'slide-in-up'
	  }).then(function (modal) {
		  $scope.externalmodal = modal;
		  modal.wait();
	  });
  };
  $rootScope.NotLoggedIn = $scope.NotLoggedIn;
  $rootScope.requireLogin = $scope.requireLogin;
	  $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams) {
		  if(fromState.name == "app.home"&&toState.name == "app.guide-video") {
	  		if(localStorage['guideVideo'] == 'false') {
	  			event.preventDefault();
		  		window.location.href = '#/app/home';
		  		return false;
		  	}
		  }
	  })
  $scope.$on("login", function () {
  	if (localStorage.userType == 1) return;
  	if (localStorage.soundEnabled == 'true')
  		Sound.succeed.play();
  });
  $scope.$on("user.follow", function () {
  	if (localStorage.soundEnabled == 'true')
  		Sound.succeed.play();
  });

  $scope.$on("$ionicView.leave", function () {
  	if (localStorage.soundEnabled == 'true')
  		Sound.transit.play();
  });
	$rootScope.poiDiv = {
		slideup: function () {
			this.isOpen = true;
			setTimeout(function () {
				$this.isMaskOpen = true;
				$rootScope.$apply();
			}, 100);
			if (localStorage.soundEnabled == 'true')
				Sound.transit.play();
			var $this = this;
			this.stateChange = $rootScope.$on('$stateChangeStart', function () {
				$this.slidedown();
				$this.stateChange();
			});
		},
		slidedown: function () {
			this.isOpen = false;
			this.isMaskOpen = false;
		}
	};
})
