angular.module('starter.controllers')
.controller('bindPhoneCtrl', function($scope,$state, $ionicHistory,$ionicPopup,$http,loginService,$ionicLoading,$ionicModal) {
	sessionStorage.phone = "";
	$scope.data = {
		phone: "",
		code: "",
		password: ""
	};
	$scope.submit = function () {
		if (!$scope.isExistingUser&&!loginService.checkPassword($scope.data.password)) {
			$ionicPopup.alert({template:'密码必须为6-16位字母，数字或英文符号，不包含空格'});
		} else{
		$ionicLoading.show({ template: '<ion-spinner/>' });
		loginService.checkVericode({ user: $scope.data.phone, vericode: $scope.data.vericode }).then(function (response) {
			$ionicLoading.hide();
			if(response.data)
				$state.resolve({phone: $scope.data.phone, password: $scope.data.password});
			else
				$ionicPopup.alert({ template: '验证码错误' });
		}, function () {
			$ionicLoading.hide();
			$ionicPopup.alert({ template: '请求失败' });
		});
		}
	};
	//用户协议modal
	$scope.openAgreement = function () {
		$ionicModal.fromTemplateUrl('templates/agreement.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function (modal) {
			$scope.$broadcast('turnWhite');
			modal.wait();
		});
	};

	$scope.sendCode = function () {
		if($scope.counting) return;
		if(!(/^\d+$/g.test($scope.data.phone))){
			$ionicPopup.alert({template:'手机号码错误'});
		} else {
			$ionicLoading.show({ template: "<ion-spinner/>" });
			loginService.sendmsg($scope.data.phone,$scope.countryCode).then(function (response) {
				$ionicLoading.hide();
				$ionicPopup.alert({template:'验证码发送成功，请接收'})
				$scope.vericode.count();
			}).catch(function (errMsg) {
				$ionicPopup.alert({template:'验证码发送失败'});
				$ionicLoading.hide();
			})
			loginService.checkUserName($scope.data.phone).then(function (response) {
				var exist = response.data;
				$scope.isExistingUser = exist;
				if (exist)
					delete $scope.data.password;
			});
		}
	}

	$scope.countryCode = 86;
	$scope.countryName = '中国';

	$scope.selectAreaCode = function () {
		$ionicModal.fromTemplateUrl('templates/select-area-code.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function (modal) {
			modal.wait()
				.then(function (value) {
					$scope.countryName = value.name;
					$scope.countryCode = value.code;
				})
				.finally(function () {
					setTimeout(function () {
						modal.remove()
					}, 1000);
				})
		});
	}
})
