angular.module('starter.controllers')
.controller('ChangepasswordCtrl', function ($scope,$state, $http, $ionicPopup, $ionicLoading,loginService,$rootScope) {
	$scope.pass = {
		old: '',
		new: '',
		again: ''
	};
	var changeFlag = true;
	$scope.change = function () {
		if (!changeFlag) return;
		changeFlag = false;
		if ($scope.pass.again == $scope.pass.new) {
			if (!loginService.checkPassword($scope.pass.new)) {
				$ionicPopup.show({
					title: '密码必须为6-16位字母，数字或英文符号，不包含空格',
					buttons: [{
						text: '确认',
						type: 'button-positive'
					}]
				});
				changeFlag = true;
			} else {
				$ionicLoading.show({ template: '<ion-spinner></ion-spinner>' });
				$http({
					method: 'post',
					url: '/youbanban/auth/modify_password',
					data: {
						password: $scope.pass.old,
						newPassword: $scope.pass.new
					}
				}).then(function () {
					$ionicLoading.hide();
					$scope.pass = {
						old: '',
						new: '',
						again: ''
					};
					$ionicPopup.show({
						title: '密码修改成功',
						buttons: [{
							text: '确认',
							type: 'button-positive'
						}]
					}).then(function () {
						$scope.$emit('modal.resolve');
					});
					changeFlag = true;
				}, function (response) {
					$ionicLoading.hide();
					if (response.status == 403)
						switch (response.data.code) {
							case "wrong-password":
								$ionicPopup.alert({ template: "密码错误" });
								break;
							default:
								$ionicPopup.alert({ template: "请求错误" });
						}
					else
						$ionicPopup.alert({ template: "请求错误" });
					changeFlag = true;
				})
			}
		}
	}
	$scope.forget = function () {
		$state.call("app.forget")
			.then(function () {
				$state.call("app.login");
			});
	};
})
