angular.module('starter.controllers')
.controller('FriendCtrl', function ($scope, $http, $ionicLoading,$rootScope ,$location) {
	$scope.user = {};
	$scope.type = 'followee';
	$scope.currentUser = localStorage.user;
	var url = $location.absUrl().split('/');
	$scope.currentView = url[url.length - 1];
	if ($scope.currentUser != $scope.currentView) {
		$http.get('/youbanban/user/' + $scope.currentView)
		.then(function (response) {
			$scope.nickName = response.data.nickName;
		});
	}
	$scope.$on('load', function (event, response) {
	    var value = response.data;
		$http.get("/youbanban/user/stats", {
			params: {
				query: JSON.stringify(
					value.content.map(function (friend) {
						return friend.id;
					}))
			}
		}).then(function (response) {
			for (var i in value.content) {
				var friend = value.content[i];
				friend.stats = response.data[friend.id];
			}
		});
		$scope.$broadcast('scroll.refreshComplete');
	});

	$scope.remove = function (friend) {
		$ionicLoading.show({ template: "<ion-spinner/>" });
		$http.delete("/youbanban/user/" + friend.id + "/followby").then(function () {
			$ionicLoading.hide();
			var fan = $scope.user.fan;
			fan.splice(fan.indexOf(friend), 1);
			$scope.user.fan.totalElements--;
			$rootScope.$broadcast('user.remove' , friend.id);
		});
	};

	$scope.unfollow = function (friend) {
		$ionicLoading.show({ template: "<ion-spinner/>" });
		$http.delete("/youbanban/user/" + friend.id + "/follow").then(function () {
			$ionicLoading.hide();
			var followee = $scope.user.followee;
			followee.splice(followee.indexOf(friend), 1);
			$scope.user.followee.totalElements--;
			if ($scope.user.fan) {
				var follower = $scope.user.fan.content;
				var user = follower.find(function (user) { return user.id == friend.id; });
				if (user)
					user.stats.following = false;
			}
			$rootScope.$broadcast('user.unfollow' , friend.id);
		});
	};

	$scope.follow = function (friend) {
		$ionicLoading.show({ template: "<ion-spinner/>" });
		$http.post("/youbanban/user/" + friend.id + "/follow").then(function () {
			$ionicLoading.hide();
			$rootScope.$broadcast('user.follow', friend.id);
			friend.stats.following = true;
			$scope.user.followee.totalElements++;
			if ($scope.user.followee.totalElements <= 10)
				$scope.user.followee.content.push(friend);
		});
	};
})
