angular.module('starter.controllers')
	.controller('heatRankCtrl', function ($scope, $http, $rest, $ionicLoading, $q, $ionicSlideBoxDelegate, $relay, $state) {
		$scope.type = 'weekly';
		$scope.toWeekRank = function () {
			if ($scope.type == 'week') return;
			$scope.type = 'weekly';
			$ionicSlideBoxDelegate.slide(0);
		};
		$scope.toTotalRank = function () {
			if ($scope.type == 'all') return;
			$scope.type = 'total';
			$ionicSlideBoxDelegate.slide(1);
		};

		$scope.toggleType = function () {
			if ($ionicSlideBoxDelegate.currentIndex() == 0) {
				$scope.type = 'weekly';
			} else if ($ionicSlideBoxDelegate.currentIndex() == 1) {
				$scope.type = 'total';
			}
		};

		$scope.toUser = function (id) {
			if (!id) return;
			$scope.$emit('modal.resolve');
			$state.go('app.user', {id: id})
		};

		function getWeekRank() {
			return $http.get('/youbanban/user/rank/week')
				.then(function (response) {
					$relay.query(response.data, [{userId: ''}])
						.then(function () {
							var length = response.data.length;
							for( var i = 0; i < 3-length; i++) {
								response.data.push({
									userId: {
										avatar: 'img/user/touxiang@3x.png'
									}
								});
							}
							$scope.weeklyRank = response.data;
						})
				})
		}

		function getTotalRank() {
			return $http.get('/youbanban/user/rank')
				.then(function (response) {
					$relay.query(response.data, [{userId: ''}])
						.then(function () {
							$scope.totalRank = response.data;
						})
				})
		}

		$scope.refresh = function () {
			$q.all([getWeekRank(), getTotalRank()]).then(function () {
				$scope.$broadcast('scroll.refreshComplete');
			}, function () {
				$ionicLoading.show({template: "请求失败", duration: 2000});
				$scope.$broadcast('scroll.refreshComplete');
			})
		}

		function loading() {
			$ionicLoading.show({template: "<ion-spinner/>"});
			$q.all([getWeekRank(), getTotalRank()]).then(function () {
				$ionicLoading.hide();
			}, function () {
				$ionicLoading.show({template: "请求失败", duration: 2000});
			})
		}

		loading();
	});
