angular.module('starter.controllers')
.controller('InviteCodeCtrl', function ($scope,$ionicLoading,$ionicPopup){
	$scope.copyContact = function (text) {
		cordova.plugins.clipboard.copy(text);
		$ionicLoading.show({
			template: "复制成功",
			duration: 2000
		});
	}
	$scope.share = function (destination) {
		var refcode = $scope.user.refcode;
		var text = "我正在使用游伴伴APP，下载并输入我的邀请码 x 一起领取免费流量等福利吧！".replace('x', refcode);
		var url = environment.host;
		switch(destination){
			case 'weixin':
				Wechat.share({
					message: {
						title: "游伴伴",
						description: text,
						media: {
							type: Wechat.Type.WEBPAGE,
							webpageUrl: url
						}
					},
					scene: Wechat.Scene.TIMELINE
				}, function () {
					$ionicPopup.alert({ template: "分享成功" })
				}, onerror);
				break;
			case 'qq':
				var args = {
					title: "游伴伴",
					description: text,
					url: url,
					appName: "游伴伴"
				};
				YCQQ.shareToQQ(function () {
					$ionicPopup.alert({ template: "分享成功" })
				}, onerror, args);
				break;
			case 'weibo':
				var args = {
					url: url,
					title: "游伴伴",
					description: text
				};
				YCWeibo.shareToWeibo(function () {
					$ionicPopup.alert({ template: "分享成功" })
				}, onerror, args);
				break;
			case 'weixinf':
				Wechat.share({
					message: {
						title: "游伴伴",
						description: text,
						media: {
							type: Wechat.Type.WEBPAGE,
							webpageUrl: url
						}
					},
					scene: Wechat.Scene.SESSION
				}, function () {
					$ionicPopup.alert({ template: "分享成功" })
				}, onerror);
				break;
			case 'qzone':
				var args = {
					title: "游伴伴",
					description: text,
					url: url,
					appName: "游伴伴"
				};
				YCQQ.shareToQzone(function () {
					$ionicPopup.alert({ template: "分享成功" })
				}, onerror, args);
				break;
		}
	}
	function onerror(reason) {
		if (!(reason.includes('cancel') || reason.includes('取消')))
			$ionicPopup.alert({ template: '分享失败：' + reason })
	}
})
