angular.module('starter.controllers')
.controller('MapCtrl', function ($request, $scope, $rootScope, $state, $cache, $ionicLoading, $ionicModal, poiService, Searcher, cityService, toastService, geobrowseService, offlineService, $ionicPlatform, $ionicHistory, IONIC_BACK_PRIORITY, poisearchConfig) {
	var deregister;
	$scope.$on("$ionicView.enter", function () {
		if (!maps.m)
			$ionicLoading.show({ template: "<ion-spinner></ion-spinner><div>正在加载地图</div>" })
				.then(function () {
					deregister = $ionicPlatform.registerBackButtonAction(onHardwareBackButton, IONIC_BACK_PRIORITY.loading);
				});
	});
	function onHardwareBackButton() {
		$state.go("app.home");
	}
	$scope.$on("$ionicView.leave", function () {
		if (!maps.m) {
			deregister();
			$ionicLoading.hide();
		}
	});
	until(function () { return maps.gmap || maps.bmap; }, function (m) {
		if (deregister) {
			deregister();
			$ionicLoading.hide();
		}
		maps.m = m;
		var map = new m.Map($("#map-view .map-container")[0]);

		$ionicLoading.show({ template: "<ion-spinner></ion-spinner><div>正在获取您的位置</div>" });
		until(function () { return window.positionService.position; }, function () {
			$ionicLoading.hide();
			var latlng = {
				lat: positionService.position.latitude,
				lng: positionService.position.longitude
			};
			if (maps.m == maps.gmap)
				latlng = eviltransform.wgs2gcj(latlng.lat, latlng.lng);
			else if (maps.m == maps.bmap)
				latlng = eviltransform.wgs2bd(latlng.lat, latlng.lng);
			map.centerAndZoom(m.Location(latlng), 16);
			if (!window.positionService.position.accuracy || window.positionService.position.accuracy > 200)
				toastService.push("当前获取到的位置非常粗略，可能和您的实际位置有较大差别。");
		}, 2000, 3, function () {
			$ionicLoading.hide();
			toastService.push("暂时没有获取您的位置,您可以之后使用定位按钮。");
			map.centerAndZoom(m.Location({ lat: 31.2, lng: 121.5 }), 16);
		});

		var positor = new Positor(map);
		positor.posite();

		$scope.posite = function () {
			if (positor.position) {
				var location = {
					lat: positor.position.latitude,
					lng: positor.position.longitude
				};
				if (maps.m == maps.gmap)
					location = eviltransform.wgs2gcj(location.lat, location.lng);
				else if (maps.m == maps.bmap)
					location = eviltransform.wgs2bd(location.lat, location.lng);
				map.panTo(m.Location(location));
			} else
				$ionicLoading.show({ template: "还没有取得你的位置", duration: 2000 });
		}

		$scope.zoomIn = function () { map.zoomIn(); }
		$scope.zoomOut = function () { map.zoomOut(); }
		map.addEventListener(m == maps.gmap ? 'zoom_changed' : 'zoomend', function () {
			$("#map-view .map-container").attr('zoom', map.getZoom());
		});

		var filter = {};
		until(function () { return window.categories; }, function () {
		for (var category in window.categories)
			filter[category] = true;
		Object.defineProperty(filter, 'all', {
			value: function () {
				for (var category in filter)
					if (!filter[category]) return false;
				return true;
			}
		});
		$scope.filter = filter;
		$scope.filterexpand = false;
		}, 2000, 6);

		var searcher = new Searcher();
		$scope.searcher = searcher;
		function setResults(results) {
			if ($scope.results)
				for (var i in $scope.results) {
					var result = $scope.results[i];
					map.removeOverlay(result.marker);
				}
			$scope.results = results;
			$scope.$apply();
			for (var i in results) {
				var result = results[i];
				var marker = BaiduMarker(result);
				map.addOverlay(marker);
				marker.poi = result;
				marker.index = +i;
				result.marker = marker;
			}
			setViewport(results);
			$scope.selection = null;
		}
		function BaiduMarker(poi) {
			var location = { lat: poi.location.lat, lng: poi.location.lon };
			if (maps.m == maps.gmap)
				location = eviltransform.wgs2gcj(location.lat, location.lng);
			else
				location = eviltransform.wgs2bd(location.lat, location.lng);
			var marker = new m.Marker({ position: m.Location(location), map: map });
			marker.addEventListener('click', function () {
				if ($scope.selection) $scope.selection.deactivate();
				marker.activate();
				$("#map-view .search-result-div .list>*").get(marker.index + 1).scrollIntoView(false);
				$scope.selection = marker;
				$scope.$apply();
			});
			return marker;
		}

		searcher.onsearch = function () {
			$scope.loading = false;
			$ionicLoading.hide();
		};
		searcher.onresult = function (results) {
			$scope.slideup();
			setResults(results);
			$("#map-view .search-result-div .popup-body")[0].scrollTop = 0;
		};
		searcher.onpage = function () {
			$scope.paging = null;
		};
		searcher.onerror = function (e) {
			$scope.loading = false;
			$scope.paging = null;
			$ionicLoading.show({ template: "请求失败", duration: 2000 });
		};
		$scope.search = function () {
			if (!$scope.city) {
				$ionicLoading.show({ template: "当前位置没有城市", duration: 2000 });
				return;
			}
			$scope.loading = true;
			$ionicLoading.show({ template: "<ion-spinner></ion-spinner><div>正在搜索</div>" });
			searcher.city = $scope.city;
			searcher.country = $scope.country;
			searcher.category = Object.keys(window.categories).filter(function (category) { return filter[category]; });
			searcher.search();
		};
		function setViewport(results) {
			map.panToLocations(
				results.map(function (result) {
					var location = {
						lat: result.location.lat,
						lng: result.location.lon
					};
					if (maps.m == maps.gmap)
						location = eviltransform.wgs2gcj(location.lat, location.lng);
					else
						location = eviltransform.wgs2bd(location.lat, location.lng);
					return m.Location(location);
				})
            );
		}
		$scope.beginSearch = function () {
			ybbLayer.disable();
			if (searcher.city == $scope.city && $scope.results) {
				$scope.slideup();
				setViewport($scope.results);
			}
			for (var i in $scope.results) {
				var result = $scope.results[i];
				map.addOverlay(result.marker);
			}
		};
		$scope.endSearch = function () {
			$scope.slidedown();
			ybbLayer.enable();
			for (var i in $scope.results) {
				var result = $scope.results[i];
				map.removeOverlay(result.marker);
			}
      $scope.results =undefined;
      $scope.searcher.keyword='';
		};
		$scope.slidedown = function () {
			$('#map-view').removeAttr('search-result');
			$("#map-view .search-result-div").animate({ bottom: "-240px" });
			bottomNav.slideup();
		};
		$scope.slideup = function () {
			$('#map-view').attr('search-result', "");
			$("#map-view .search-result-div").animate({ bottom: 0 });
			bottomNav.slidedown();
		};
		$scope.$on("$ionicView.enter", function () {
			if ($('#map-view').attr('search-result') != undefined || $('#map-view').attr('poi-div') != undefined)
				bottomNav.slidedown();
		});
		$scope.$on("$ionicView.beforeLeave", function () {
			if ($('#map-view').attr('search-result') != undefined || $('#map-view').attr('poi-div') != undefined)
				bottomNav.slideup();
		});
		$scope.toggleslide = function () {
			var bottom = $("#map-view .search-result-div").css('bottom');
			if (bottom == 0 || bottom == "0px")
				$scope.slidedown();
			else
				$scope.slideup();
		};
		$scope.pageup = function () {
			$scope.paging = 'up';
			searcher.pageup();
		};
		$scope.pagedown = function () {
			$scope.paging = 'down';
			searcher.pagedown();
		};
		$scope.activate = function (poi) {
			if ($scope.selection)
				$scope.selection.deactivate();
			if (!map.getBounds().containsPoint(poi.point))
				map.panTo(poi.point);
			poi.marker.activate();
			$("#map-view .search-result-div .list>*").get(poi.marker.index + 1).scrollIntoView(false);
			$scope.selection = poi.marker;
		};
		$scope.go = function (poi) {
			$state.go("app.poi", { id: poi.id });
		};
		var bottomNav = {
			slidedown: function () {
				//hack: translate breaks z-index, *maybe* related to http://stackoverflow.com/questions/7764859/moz-transform-z-index-bug
				$("#bottom-nav").css({ transform: "translateY(63px)", zIndex: 1 });
				setTimeout(function () {
					$("#bottom-nav").css({ display: "none" });
				}, 400);
			},
			slideup: function () {
				$("#bottom-nav").css({ display: "" });
				setTimeout(function () {
					$("#bottom-nav").css({ transform: "", zIndex: "" });
				}, 0);
			}
		};

		map.addEventListener(m == maps.gmap ? 'bounds_changed' : 'moveend', geocode);
		function geocode() {
			var center = map.getCenter();
			center = maps.normalize(center);
			cityService.geocode(center).then(function (result) {
				$scope.city = result.city;
				$scope.province = result.province;
				$scope.country = result.country;
			});
		}

		var ybbLayer = YbbLayer(map, poiService);
		ybbLayer.onerror = function () {
			var n = 0;
			return function () {
				toastService.push("请求失败");
				if (n++ > 0)
					ybbLayer.onerror = function () { };
			}.debounce(200);
		}();
		ybbLayer.onclick = function (poi) {
			$rootScope.poi = poi;
			$rootScope.poiDiv.slideup();
			$scope.$apply();
			$(function () {
				var eventid = $cache.$get('poi-event',poi.id);
				for (var i=0;i<eventid.length;i++) {
					if (eventid[i].type=="虚拟物展示") {
						$request.get('event',eventid[i].id)
							.then(function (response) {
								poi.ARpicture=response.picture;
							})
						break;
					}else{
						poi.ARpicture='';
					}
				}
				if(eventid==undefined||eventid.length==0){poi.ARpicture='';}
			})
		};
		ybbLayer.tag = filter;
		$scope.ybbLayer = ybbLayer;

		$scope.$on("$ionicView.enter", function () {
			citySource = 'city';
			showHotCity = true;
			showGlobal = false;
			$ionicModal.fromTemplateUrl('templates/city.html', {
				scope: $scope.$new(),	//needed for $ionicScrollDelegate.$getByHandle to work in modals, see https://github.com/driftyco/ionic/issues/4795
				animation: 'slide-in-up'
			}).then(function (modal) {
				$scope.cityModal = modal;
			});
		});

		$scope.$on('$ionicView.leave', function () {
			$scope.cityModal.remove();
		});

		$scope.selectCity = function () {
			$scope.cityModal.wait()
				.then(onselectcity);
		};
		$scope.nearby = function () {
			if (!positor.position) {
				$ionicLoading.show({ template: "还没有取得你的位置", duration: 2000 });
				return;
			}
			poisearchConfig.setter({
				lat: maps.normalize(map.getCenter()).lat,
				lng: maps.normalize(map.getCenter()).lng,
				lat1: positor.position.latitude,
				lng1: positor.position.longitude,
				from: 'lbs',
				city: $scope.city,
				country: $scope.country,
				fujin: true,
				order: null
			});
			$state.go('app.poi-search');
		};
		function onselectcity(message) {
			if (message.city != $scope.city) {
				if(maps.m == maps.gmap)
				map.fitBounds(new google.maps.LatLngBounds(
					message.viewport.southwest,
					message.viewport.northeast
				));
				else
				map.setViewport([
					toPoint(message.viewport.southwest),
					toPoint(message.viewport.northeast)
				]);
				$scope.city = message.city;
			}
		}
		function toPoint(point) {
			return new BMap.Point(point.lng, point.lat);
		}
		$scope.gotoPoi = function (poi) {
			map.panTo(new BMap.Point(poi.location.lon, poi.location.lat));
		};
		$scope.$cache = $cache;
	}, 1000);
	$scope.offline = function () {
		if (!window.app && ionic.Platform.isWebView()) {
			$scope.requireApp();
			return;
		}
		offlineService.getModal().then(function () {
			$rootScope.$broadcast("download",normalizeCityName($scope.city));
		})
	};
})
