angular.module('starter.controllers')
.controller('MessageCtrl', function ($scope, $http, $request, $rest, messageService, $q, $ionicLoading, $rootScope) {
	$scope.page = {
		message: 0,
		notif: 0
	};
	$scope.Math = Math;
	$scope.type = 'message';
	$scope.onclick = function (message) {
		if (!message.keyId) return;
		var type = $rest.getType(message.keyId);
		if (type == 'mood')
			document.location.href = "#/app/mood/" + message.keyId;
		else if (type == 'comment') {
			$ionicLoading.show({ template: "<ion-spinner/>" });
			$request.get('comment', message.keyId)
				.then(function (comment) {
					$ionicLoading.hide();
					document.location.href = "#/app/mood/" + comment.keyId;
				}, function () {
					$ionicLoading.show({ template: "请求失败", duration: 2000 });
				});
		}
	};
	$scope.delete = function (message, type) {
		$rootScope.messages[type].splice($rootScope.messages[type].indexOf(message), 1);
		messageService.db.remove(type, message.id);
	};
	$scope.clear = function (type) {
		$rootScope.messages[type] = [];
		messageService.db.clear(type);
	};
	$scope.$watch('type', function (value, oldValue) {
		if (value == oldValue) return;
		messageService.read(oldValue);
		var messages = $rootScope.messages[oldValue];
		for (var i in messages)
			delete messages[i].unread;
	});
	$scope.$watch(function () {
		return (
		  !$rootScope.messages.message.find(function (message) { return message.unread; })
		  &&
		  !$rootScope.messages.notif.find(function (message) { return message.unread; })
		);
	}, function (value) {
		if (value)
			$rootScope.messageRead = true;
	});
  $scope.$watch(function () {
    return (
      $rootScope.messages.message.filter(function (message) { return message.unread; }).length
    );
  }, function (value) {
      $scope.messageDot = value;
  });
  $scope.$watch(function () {
    return (
      $rootScope.messages.notif.filter(function (message) { return message.unread; }).length
    );
  }, function (value) {
    $scope.notifDot = value;
  });
  $scope.$on("$ionicView.beforeLeave",function(){
    messageService.read($scope.type);
    var messages = $rootScope.messages[$scope.type];
    for (var i in messages)
      delete messages[i].unread;
  });
  	$scope.coupons = function (url) {
		cordova.InAppBrowser.open(url, '_system', 'location=yes');
	}
  	$scope.copyContact = function (text) {
		cordova.plugins.clipboard.copy(text);
		$ionicLoading.show({
			template: "复制成功",
			duration: 2000
		});
	}
});
