angular.module('starter.controllers')
.controller('MoodCtrl', function ($scope, $stateParams, $ionicPopup, $http,$ionicActionSheet,$ionicHistory,$rest,$storage, $ionicLoading, $location,$request,$relay, $ionicModal,$rootScope,imagePreviewService) {
	$scope.id = $stateParams.id;
	$scope.oneselfid = localStorage.user;
	$scope.show=false;
	$scope.$on('$ionicView.beforeEnter', function () {
		$scope.showBackButton = !!$ionicHistory.backView();
	});
	$ionicLoading.show({ template: "<ion-spinner/>" });
	$rest.get('mood', $scope.id).then(function (response) {
		$scope.mood = response.data;
		$http.get('/youbanban/mood/'+response.data.id +'/poi')
			.then($rest.join.any())
			.then($rest.embeds.stats())
			.then(function (response) {
				$scope.mood.pois = response.data.content;
			})
	}).then(function(){
		$rest.get('mood', $stateParams.id, 'stats').then(function (response) {
			$scope.mood.stats = response.data;
			$scope.userid = $scope.mood.userId;
			$ionicLoading.hide();
		}).then(function(){
			$scope.switch = function(){
				$ionicLoading.show({ template: "<ion-spinner/>" });
				$http({
					url:'/youbanban/mood/'+ $scope.id +'/privacy',
					method:'PUT',
					data:1-$scope.mood.privacy
				}).success(function(response){
					$scope.mood.privacy =1-$scope.mood.privacy;
					$ionicLoading.show({template:$scope.mood.privacy?"已公开":'已关闭',duration:2000});
				}).error(function(){
					$ionicLoading.show({template:"个人分享公开收藏失败！",duration:2000});
				});
			}
			if (localStorage.user == $scope.mood.userId)
				$scope.show = true;
			else {
				$ionicLoading.show({ template: "<ion-spinner/>" });
				$rest.get("user",$scope.mood.userId).then(function (response) {
					$scope.user = response.data;
					$ionicLoading.hide();
					$scope.show = true;
					$rest.get('user', $scope.mood.userId, 'stats').then(function (response) {
						$scope.user.stats = response.data;
					});
				})
			}
			$scope.hash = $location.hash();
			if($scope.hash == "comment"){
				$(".comment-bar input").focus();
			}
		})
		$request.get.s()
		$rest.post('mood', $stateParams.id, 'read').then(function () {
			$rootScope.$broadcast('content.read');
		});
	})
	.catch(function (e) {
		$ionicLoading.hide();
		if (e.status == -1)
			$ionicLoading.show({ template: "无法访问网络或请求超时，请稍候再试。"});
		else
			$ionicLoading.show({template: "请求失败"});
	});
	$scope.$on('load', function (event, response) {
		var content = response.data.content;
		$http.get("/youbanban/comment/stats", {
			params: {
				query: JSON.stringify(content.map(function (comment) { return comment.id; }))
			}
		}).then(function (response) {
			for (var i in content) {
				var comment = content[i];
				comment.stats = response.data[comment.id];
			}
		});
	});
	$scope.isExpand = false;
	$scope.modifyExpand = function (flag) {
		$scope.isExpand = flag;
	}
	$scope.openEdit = function () {
		var list;
		if ($scope.oneselfid != $scope.userid) {
			list = [
				{ text: '吐槽' },
				{ text: '取消' }
			];
		} else {
			list = [
				{ text: '删除' },
				{ text: '取消' }
			]
		}
		var hideSheet = $ionicActionSheet.show({
			buttons: list,
			buttonClicked: function (index) {
				switch (list[index].text) {
					case '删除':
						$ionicPopup.confirm({
							template: '确认删除？'
						}).then(function (res) {
							if (res) {
								$http.delete('/youbanban/mood/' + $scope.mood.id)
									.then(function (response) {
										if(response.data.status)throw response;
										$ionicLoading.show({ template: "删除成功", duration: 2000 });
										$rootScope.$broadcast('mood.delete', $scope.id);
										$ionicHistory.clearCache(['app.mood_id=' + $scope.id]);
										$storage.remove('mood', $scope.id);
										$ionicHistory.goBack();
									})
									.catch(function () { $ionicLoading.show({ template: "删除失败", duration: 2000 }); })
							}
						});
						break;
					case '吐槽':
						localStorage.userType == 1 ?$scope.NotLoggedIn() :location.href = '#/app/feedback/'+ $scope.id;
				}
				return true;
			}
		});
	}

	$scope.fullscreen = function (index) {
		if ($scope.mood.rich) {
			var component = index;
			var components = $scope.mood.richContent.filter(function (component) {
				return component.type == 'picture';
			});
			var urls = components.map(function (component) {
				return component.value;
			});
			var index = components.indexOf(component);
			imagePreviewService.show(urls, index);
		} else
			imagePreviewService.show($scope.mood.pictures, index);
	};
	//关注
	$scope.guanzhu = function() {
		if (localStorage['userType'] == 1) {
			$scope.NotLoggedIn();
		} else {
			$ionicLoading.show({
				template: "<ion-spinner/>"
			});
			if($scope.user.stats.following) {
				$http.delete('/youbanban/user/' + $scope.user.id + "/follow").then(function(response) {
					$scope.user.stats.following = !$scope.user.stats.following;
					$rootScope.$broadcast('user.unfollow', $scope.user.id);
					$ionicLoading.hide();
				}, function(err) {
					$ionicLoading.show({
						template: "取消关注失败",
						duration: 1000
					});
				});

			} else {
				$http.post('/youbanban/user/' + $scope.user.id + "/follow").then(function(response) {
					$scope.user.stats.following = !$scope.user.stats.following;
					$rootScope.$broadcast('user.follow', $scope.user.id);
					$ionicLoading.hide();
				}, function(err) {
					$ionicLoading.show({
						template: "关注失败",
						duration: 1000
					});
				});
			}
		}
	};
})
