angular.module('starter.controllers')
.controller('MoodDraftCtrl', function ($scope, $state, $stateParams, $rootScope, $http, $rest, $storage, moodService, $ionicHistory, $ionicPopup, $ionicLoading) {
	$scope.id = $stateParams.id;
	$scope.edit = function (mood) {
		$state.call("app.mood-edit.content", { mood: mood });
	};
	$scope.delete = function (mood) {
		$ionicPopup.confirm({
			template: "确定要删除吗？"
		}).then(function (response) {
			if (!response) return;
			$ionicLoading.show({ template: "<ion-spinner/>" });
			$http.delete('/youbanban/mood/' + mood.id)
				.then(function (response) {
					if (response.data.status) throw response;
					$ionicLoading.show({ template: "删除成功" });
					$rootScope.$broadcast('mood.delete', mood.id);
					$ionicHistory.clearCache(['app.mood_id=' + mood.id]);
					$storage.remove('mood', mood.id);
					$scope.mood.splice(
						$scope.mood.indexOf(mood),
						1
					);
				})
				.catch(function () {
					$ionicLoading.show({ template: "删除失败" });
				});
		});
	};
});