angular.module('starter.controllers')
	.controller('MoodsCtrl', function ($scope,$q,$rest,$ionicModal,$ionicPopup,$state,collectionCache) {
		var orderConfig = {
			name: '排序',
			option: [
				{ value: 'recent', name: '最新', text: '按时间排序' },
				{ value: 'hot', name: '最热', text: '按热度排序' },
				{ value: 'comment', name: '热议', text: '按评论排序' }
			]
		};
		$scope.order=orderConfig.option[0];
		var filterConfig = {
			name: '条件',
			option: [
				{ value: '', name: '全部', text: '全部' },
				{ value: 'following', name: '关注', text: '我关注的人的足迹' },
				{ value: 'nearby', name: '本地', text: '我所在地的足迹' }
			]
		};
		$scope.filter=filterConfig.option[0];
		var position = window.positionService.position;
		$scope.lon= position && position.longitude;
		$scope.lat= position && position.latitude;
		//弹窗
		var scope = $scope.$new();
		$ionicModal.fromTemplateUrl('templates/select.html', {
			scope: scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.selectModal = modal;
		});
		$scope.optionClick = function (name) {
			scope.config = {
				条件: filterConfig,
				排序: orderConfig
			}[name];
			$scope.selectModal.wait()
				.then({
					条件: filterSelect,
					排序: orderSelect
				}[name]);
		};
		//点击多选框选择
		function orderSelect(item) {
			$scope.order=item;
		}
		function filterSelect(item) {
			var select = $q.resolve();
			if(item.value=='following'){
				if (localStorage['userType'] == 1)
					select = $scope.NotLoggedIn();
			}else if(item.value=='nearby'){
				if(!position){
					$ionicPopup.alert({ template: "当前没有获取到你的位置" });
					select = $q.reject();
				}else if(!position.accuracy || position.accuracy>=1999)
					$ionicPopup.alert({ template:"当前的位置比较粗略，搜索结果可能会不符合你的要求"});
			}
			select.then(function () {
				$scope.filter = item;
			});
		}

		//搜索
		$scope.keyword={value:''};
		$scope.moodSearch = function ($event) {
			if($event.keyCode == 13) {
				$scope.keywords = $scope.keyword.value;
			}
		};
		$scope.$watch('moods', function () {
			$('#moods-view ion-content').scrollTop(0);
		});
		$scope.create = function () {
			if (localStorage['userType'] == 1) {
				$scope.NotLoggedIn();
				return;
			}
			$state.call("app.mood-create");
		};
		//加载
		$scope.page;
        $scope.loadMore = function() {
        	$scope.page++;
        	$scope.text = ''
        };
        $scope.$on("load",function(){
        	$scope.$broadcast('scroll.infiniteScrollComplete')
        	$scope.text = '上拉加载更多';
        })
		$scope.$on('load', function (event, response) {
			$rest.embeds.stats()(response)
			iconReady.then(function () {
				$rest.embeds('poi', 'promotedId', 'promoted')(response)
					.then(function (response) {
						var content = response.data.content;
						content.forEach(function (mood) {
							if (mood.promoted.topic) {
								mood.poiIcon = mood.promoted.tags.find(function (tag) {
									return $scope.poiIcon[tag];
								});
								if (!mood.poiIcon) {
									mood.poiIcon = mood.promoted.categories[0];
								}
							}
						});
						return response;
					})
					.then(function (response) {
						$scope.$broadcast('scroll.refreshComplete');
					});
			})
		});

		$scope.poiIcon = {};
		var iconReady = $q.all([collectionCache.category(), collectionCache.topics()])
			.then(function (result) {
				result[0].forEach(function (icon) {
					$scope.poiIcon[icon.name] = {};
					$scope.poiIcon[icon.name]['url'] = icon.icon;
					$scope.poiIcon[icon.name]['type'] = 'category';
					if(icon.children.length != 0) {
						icon.children.forEach(function (child) {
							$scope.poiIcon[child] = {};
							$scope.poiIcon[child]['url'] = icon.icon;
							$scope.poiIcon[child]['type'] = 'category';
						})
					}
				});
				result[1].forEach(function (icon) {
					$scope.poiIcon[icon.name] = {};
					$scope.poiIcon[icon.name]['url'] = icon.icon;
					$scope.poiIcon[icon.name]['type'] = 'tags';
				});
				console.log($scope.poiIcon);
			})
	})
