angular.module('starter.controllers')
.controller('OfflineCtrl', function ($scope, $cordovaFile, $file, $q, $location, collectionCache, offlineService, $address, $ionicPopup,$window,$rootScope) {
	var create = $scope.create;
	if (create)
		var create = normalizeCityName(create);
	var offlinePrefix = environment.host + "/imgs/svc/point/download";
	var items, cities;
  var isWifi;
  var networkState = navigator.connection.type;
  if (networkState == Connection.WIFI){
    isWifi=true;
  }
	collectionCache.offline()
		.then(function ($items) {
			items = $items;
			offlineService.getCities()
				.then(function ($cities) {
					cities = $cities;
					$scope.items = cities.map(function (city) {
						return Item(city);
					});
					if ($window.localStorage['page.offline.wifi'] == 'true' && isWifi)
						setTimeout(checkForUpdate, 1000);
					$rootScope.$on('download',function (event,message) {
						if (!cities.includes(message)) {
							var item = Item(message);
							if (!item) {
								$ionicPopup.alert({ template: "没有" + message + "的离线数据" });
								return;
							}
							$ionicPopup.alert({ template: "开始下载" + message + "的离线数据" });
							cities.push(message);
							$scope.items.push(item);
							item.downloader.start();
							item.downloader.running = true;
						} else
							$ionicPopup.alert({ template: "已经下载过" + message + "的离线数据" })
					})
				});
			collectionCache.city()
				.then(function (city) {
					for (var i in items)
						items[i].py = city.find(function (city) {
							return normalizeCityName(city.city) == items[i].city;
						}).cityPy;
				});
			var partition = items.partition(function (city) {
				return city.country == '中国';
			});
			$scope.domestics = partition[0];
			$scope.foreigns = partition[1];
			$scope.city = items;
			collectionCache.hotCity()
				.then(function (city) {
					$scope.hot = city.borders.map(function (name) {
						return items.find(function (item) {
							return item.city == name;
						});
					}).filter(angular.isDefined);
					$scope.hot_abroad = city.abroads.map(function (name) {
						return items.find(function (item) {
							return item.city == name;
						});
					}).filter(angular.isDefined);
				});
		});
	function Item(city) {
		var item = items.find(function (item) {
			return item.city == city;
		});
		if (!item) return item;
		var source = offlinePrefix + item.file;
		var destination = cordova.file.cacheDirectory + 'poi/' + city + ".zip";
		$file.getSize(destination).then(function (size) {
			item.downloader.progress = {
				loaded: size,
				total: item.size * 1024 * 1024
			};
		}, function () {
			$cordovaFile.checkDir(cordova.file.cacheDirectory + 'poi/', city)
				.then(function () {
					item.downloader.complete = true;
				});
		});
		var downloader = new Downloader(source, destination, function () {
			downloader.running = false;
			downloader.complete = true;
			zip.unzip(destination, cordova.file.cacheDirectory + 'poi/' + city, function (status) {
				if (status)
					$ionicPopup.alert({template: "解压文件失败"});
				$cordovaFile.removeFile(cordova.file.cacheDirectory + "poi", city + ".zip")
					.then(function () {
						index(city);
						localStorage["offline." + city] = item.deltaTime;
					});
			});
			$scope.$apply();
		}, function (e) {
			downloader.running = false;
			$ionicPopup.alert({ template: "下载文件失败" });
			console.log("下载文件失败");
			console.log(e);
			$scope.$apply();
		}, function (progress) {
			downloader.progress = progress;
			$scope.$apply();
		}.throttle(100))
		item.downloader = downloader;
		return item;
	}
	$scope.delete = function (item) {
		var remove =
			item.downloader.complete ?
				$cordovaFile.removeRecursively(cordova.file.cacheDirectory + "poi", item.city) :
				$cordovaFile.removeFile(cordova.file.cacheDirectory + "poi", item.city + ".zip");
		remove.then(function () {
			delete localStorage["offline." + item.city];
			delete item.downloader;
			$scope.items.splice(
				$scope.items.indexOf(item),
				1
			);
			cities.splice(cities.indexOf(item.city),1);
		}, function (e) {
			$ionicPopup.alert({ template: "删除文件失败" });
			console.log(e);
		});
	};
	function index(city) {
		$file.getFiles("cdvfile://localhost/cache/poi/" + city + "/offlinedata/poi")
			.then(function (files) {
				var indexed = {};
				for (var i in files) {
					var file = files[i];
					offlineService.db.put('poi', getFileNameWithoutExtension(file.name), city);
				}
			})
	}
	function checkForUpdate() {
		var expired = [];
		for (var i in cities) {
			var city = cities[i];
			var item = items.find(function (item) {
				return item.city == city;
			});
			if (+localStorage["offline." + city] < item.deltaTime)
				expired.push(item);
		}
		if (!expired.length) return;
		$ionicPopup.alert({ template: "发现{{n}}个城市有更新".replace("{{n}}", expired.length) });
		for (var i in expired) {
			var item = expired[i];
			item.downloader.start();
			item.downloader.running = true;
			item.downloader.complete = false;
		};
	}
	$scope.tab = 0;
	$scope.foreigns = [];
	$scope.domestics = [];
	$scope.city;
	$scope.self = $scope;
	$scope.runningItem = function () {
		return $scope.items.filter(function (item) {
			return !item.downloader.complete;
		});
	};
	$scope.completeItem = function () {
		return $scope.items.filter(function (item) {
			return item.downloader.complete;
		});
	};
	$scope.$on('modal.shown', function () {
		$address().then(function (address) {
			$scope.current = normalizeCityName(address.city);
		});
	});
	$scope.citytab = 0;
	$scope.searchCity = '';

  if(localStorage['page.offline.wifi']){
    $scope.wifiChecked=JSON.parse(localStorage['page.offline.wifi']);
  }
  $scope.wifi = function(){
    $scope.wifiChecked = !$scope.wifiChecked;
    $window.localStorage['page.offline.wifi'] =JSON.stringify($scope.wifiChecked);
    if ($scope.wifiChecked && isWifi)
      checkForUpdate();
  };
});
angular.module('starter')
.run(function ($rootScope) {
	$rootScope.$on('logout', function () {
		localStorage.removeItem('page.offline.wifi');
	});
});
