angular.module('starter.controllers')
.controller('PoiExternalCtrl', function ($scope, $stateParams, $http, $ionicLoading,$location,$ionicScrollDelegate,$state,$ionicModal,$until,zoomService, $ionicHistory) {
	$scope.id = encodeURIComponent(($stateParams.id).replace(/\//g, '@'));
	$scope.$on('$ionicView.beforeEnter', function () {
		$scope.showBackButton = !!($ionicHistory.backView());
	});
	$scope.urlexternal=$state.current.name=='app.poi-external';
	$scope.index = 0;
	$scope.open = function () {
		var scope = $scope.$new();
		$ionicModal.fromTemplateUrl('templates/external.html', {
			scope:scope,
			animation: 'slide-in-up'
		}).then(function (modal) {
			modal.show();
		});
	};
	$scope.select = function (i) {
		if (i>=3) {
			$scope.open();
		} else{
			return $scope.index = i;
		}
	}
	$scope.position = window.positionService.position;
	//判断类型为poi、知识卡片
	$http({
		method: 'GET',
		url: '/oyoubanban/es/p/'+ $scope.id +'/d'
	}).success(function (response) {
		$ionicLoading.hide();
		$scope.unlockid = response;
		$scope.isKard = !$scope.unlockid.indexOf('poi') == 0;
			var type = $scope.unlockid.indexOf('poi') == 0 ? 'p' : 'k';
		$scope.type = type;
		$scope.show = false;
		//获取卡片详情
		$http({
			method: 'GET',
			url: '/oyoubanban/es/'+$scope.type+'/'+$scope.id
		}).success(function (response) {
			$scope.show = true;
			$ionicLoading.hide();
			$scope.poi = response;
			$scope.poi.text = $scope.poi.text.replace(/<img src="/g,'<img src="'+ environment.imagePrefixEncrypted+'/');
			$http.get('/oyoubanban/es/u/' + $scope.poi.userId)
				.then(function (response) {
					$scope.poi.user = $scope.user = response.data;
				});
			$scope.tabs = ['poi-details', 'poi-relateds', 'poi-searches', 'poi-moods', 'poi-comments'];
			if (type != 'poi' || !$scope.poi.poiId)
				$scope.tabs.splice(2, 0);
			$scope.index = 0;
			$scope.haveSearches = true;
			if($scope.type == 'kn_cark' || $scope.type == 'k') {
				$http.get('/oyoubanban/es/p/'+ $scope.poi.poiId +'/n').catch(function () {
					$scope.haveSearches = false;
				})
			}
			if (!localStorage.token) return;
			$http.get('/oyoubanban/es/' + $scope.type + '/' + $scope.id + '/s')
				.then(function (response) {
					$scope.poi.stats = response.data;
				});
			$scope.$on('load', function (event, response) {
				var response0 = response;
				var ids = [];
				for( var k in response.data.content) {
					ids.push(encodeURIComponent(response.data.content[k].id));
				}
				$http({
					method: 'GET',
					url: '/oyoubanban/es/'+ $scope.type +'/s?query=' + JSON.stringify(ids)
				}).then(function (response) {
					for (var i in response0.data.content)
						response0.data.content[i].stats = response.data[i];
				});
			});
		});

		//阅读量
		$http({
			method: 'POST',
			url: '/oyoubanban/es/' + $scope.type + '/' + $scope.id + '/r'
		}).success(function (response) {
			response;
		}).error(function (response) {
			response;
		})
	});

	$scope.title = {
		0: '详情',
		1: '关联',
		2: '周边',
		3: '足迹',
		4: '评论'
	};

	var scrolling = false;
	$scope.scroll = function (anchor) {
		$location.hash($scope.poi.id + '-' + anchor);
		//see http://stackoverflow.com/questions/37961173/dynamic-value-with-ionic-scroll-delegate/38023914#38023914
		var instance = $ionicScrollDelegate._instances.find(function (instance) {
			return instance.$element[0].id == $scope.poi.id;
		});
		$scope.index = $scope.tabs.indexOf(anchor);
		scrolling = true;
		setTimeout(function () {
			scrolling =false;
		}, 1000);
		instance.anchorScroll();
		instance.scrollBy(0, -86);
		$scope.outOfRange = true;
	}


	$scope.onScroll = function () {
		if (scrolling) return;
	    var h = {}
		h[0] = $("#poi-view[nav-view=\"active\"] .icon-card").height();
		h[1] = h[0] + $('#poi-view[nav-view=\"active\"] .tab1').height();
		h[2] = h[1] + $('#poi-view[nav-view=\"active\"] .tab2').height();
		h[3] = h[2] + ($('#poi-view[nav-view=\"active\"] .tab3').height()||0);
		h[4] = h[3] + $('#poi-view[nav-view=\"active\"] .tab4').height();
	    var top = $ionicScrollDelegate.$getByHandle('poiScroll').getScrollPosition().top;
	    var range = $("ion-view[nav-view='active'] .icon-card").outerHeight() - 46;
	    if (top >= range) {
	    	$scope.outOfRange = true;
	    } else {
	    	$('#poi-view[nav-view=\"active\"] ion-content').css('top', '0px');
	    	$scope.outOfRange = false;
		}

	    if (top > h[0]) {
	    	$scope.icons = true;
	    } else {
	    	$scope.icons = false;
	    }

	    if (top < h[1]) {
	        $scope.index = 0;
	    } else if (top >= h[1] && top < h[2]) {
	        $scope.index = 1;
	    } else if (top >= h[2] && top < h[3]) {
	        $scope.index = 2;
	    } else if (top >= h[3] && top < h[4]) {
	        $scope.index = 3;
	    } else {
	        $scope.index = 4;
	    }
	    isBottom();
	    $scope.$apply();
	};

	function isBottom() {
		var id = $scope.poi.id;
		var element = document.getElementById(id);
		var clientHeight = $(element).height();
		var scrollHeight = $(element).find('.tabs').height() + $(element).find('.icon-card').height() + $(element).find('.poi-details').height();
		var instance = $ionicScrollDelegate._instances.find(function (instance) {
			return instance.$element[0].id == $scope.poi.id;
		});
		if (instance.getScrollPosition().top == Math.floor(scrollHeight - clientHeight)) {
			$scope.index = 3;
		}
	}
	//弹窗
	$ionicModal.fromTemplateUrl('templates/external.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function (modal) {
		$scope.externalmodal = modal;
	});
	$scope.open = function () {
		$scope.externalmodal.show();
	};
	//外部分享弹窗
	$scope.wailian = function () {
		var browser = {
		    versions: function () {
		        var u = navigator.userAgent.toLowerCase();
		        return {
		            android: u.includes('android') || u.includes('linux'),
		            iPhone: u.includes('iphone') || u.includes('ipad')
		        };
		    } (),
		    language: (navigator.browserLanguage || navigator.language).toLowerCase()
		}
		if (browser.versions.iPhone) {
		    window.location.href = "jingshuoqiyuan://";
		    setTimeout(function(){
				window.location.href = "https://itunes.apple.com/us/app/jing-shuo-qi-yuan/id1157330565?l=zh&ls=1&mt=8";
			}, 500);
		} else if (browser.versions.android) {
		    window.location.href = "jsqy://android";
			setTimeout(function(){
				window.location.href = "https://jsqy.youbanban.com/app/home#page3";
			}, 500);
		} else {
		    window.location.href = "https://jsqy.youbanban.com/app/home#page3";
		}
	};

	$http.post(
		"/oyoubanban/es/weixinsign", undefined,
		{
			params: {
				url: location.origin + location.pathname + location.search
			}
		}
	).then(function (response) {
		var data = response.data;
		$until(function () { return wx; }, 1000).then(function () {
		wx.config({
			debug: false,
			appId: "wxfec10a2b36295665",
			timestamp: data.time,
			nonceStr: data.nonce,
			signature: data.signature,
			jsApiList: ['onMenuShareTimeline', 'onMenuShareAppMessage']
		});
		wx.ready(function () {
			$until(function () { return $scope.poi; }, 1000).then(function () {
			decode($scope.poi.picture).then(function (picture) {
			wx.onMenuShareTimeline({
				title: $scope.poi.name,
				link: window.location.href,
				imgUrl: thumbnail(picture)
			});
			wx.onMenuShareAppMessage({
				title: $scope.poi.name,
				link: window.location.href,
				imgUrl: thumbnail(picture)
			});
			});
			});
		});
		})
	});
	function decode(url) {
		url = encodeURI(url.replace('/', '@'));
		return $http.get("/oyoubanban/es/p/" + url + "d/")
			.then(function (response) {
				return response.data;
			});
	}
	function thumbnail(url) {
		return environment.host + "/imgs/zoom/" + zoomService(url, 'small') + url;
	}
})
