angular.module('starter.controllers')
.controller('PoiSearchCtrl', function ($scope, $ionicModal, $rest, collectionCache, $geocode, poisearchConfig) {
	var categories = collectionCache.category().then(function (categories) {
		$scope.categories = categories;
		$scope.category = { category: $scope.categories[0] };
	});
	var topics = collectionCache.topics().then(function (topic) {
		$scope.topics = topic;
	});

	var topicConfig = {
		name: '专题',
		option: []
	};
	topics.then(function () {
		topicConfig.option = $scope.topics;
		for (var i = 0; i < $scope.topics.length; i++) {
			topicConfig.option[i].text = $scope.topics[i].name;
		}
	});
	$scope.topic = topicConfig.option[0];

	var orderConfig = {
		name: '排序',
		option: [
			{ value: 'zuire',  text: '最热' },
			{ value: 'zuizan',  text: '最赞' },
			{ value: 'zuiai',  text: '最爱' },
			{ value: 'reyi',  text: '热议' }
		]
	};
	$scope.order = orderConfig.option[0];
	$scope.orders = orderConfig.option;


	//周边
	$scope.$on("$ionicView.beforeEnter", function () {
		var search = poisearchConfig.getter();
		$scope.city = search.city;
		$scope.sorry = false;
		$scope.keyword = { data: '', input: '' };
		if (search.from == 'lbs') {
			$scope.fujin = search.fujin;
			$scope.lat = search.lat;
			$scope.lng = search.lng;
			$scope.lat1 = search.lat1;
			$scope.lng1 = search.lng1;
			if($scope.fujin && orderConfig.option[0].text != '附近') orderConfig.option.unshift({value: 'fujin', text: '附近'});
			$scope.order = search.order || orderConfig.option[0];
			var position = eviltransform.wgs2gcj(search.lat1, search.lng1);
			$geocode({
				lat: position.lat,
				lng: position.lng
			}).then(function (result) {
				$scope.street = result[0].formatted_address.split(' ')[0];
			})
			categories;
		} else if (search.from == 'home') {
			if(orderConfig.option[0].text=='附近'){
				orderConfig.option.splice(0, 1);
			}
			$scope.order = search.order || orderConfig.option[0];
			$scope.country = search.country;
			topics.then(function () {
				$scope.topic = $scope.topics.find(function (topic) {
					return search.tag == topic.name;
				});
			});
		}
		$scope.from = search.from;
	});
	//搜索
	$scope.poiSearch = function () {
		if (event.keyCode == 13) {
			$scope.sorry = true;
			$scope.keyword.data = $scope.keyword.input;
			event.target.blur();
		}
	};
	$scope.clickcancel = function ($event) {
		$scope.sorry = false;
		$scope.keyword = { data: '', input: '' };
	}
	//选择城市
	$scope.$on("$ionicView.enter", function () {
		citySource = 'city';
		showHotCity = true;
		showGlobal = true;
		$ionicModal.fromTemplateUrl('templates/city.html', {
			scope: $scope.$new(),
			animation: 'slide-in-up'
		}).then(function (modal) {
			$scope.cityModal = modal;
		});
	});

	$scope.$on('$ionicView.leave', function () {
		$scope.cityModal.remove();
	});

	$scope.selectCity = function () {
		$scope.cityModal.wait()
			.then(onselectcity);
	};

	function onselectcity(message) {
		$scope.fujin = false;
		$scope.sorry = false;
		$scope.city = message.city;
		$scope.country = message.country;
		poisearchConfig.setter({
			city: message.city,
			country: message.country,
			fujin: false
		});
		if ($scope.order.text == "附近") {
			orderConfig.option.splice(0, 1);
			$scope.order = orderConfig.option[0];
			poisearchConfig.setter({
				order: null
			})
		};
	};

	//选择专题
	$ionicModal.fromTemplateUrl('select-category.html', {
		scope: $scope.$new(),
		animation: 'slide-in-up'
	}).then(function (modal) {
		$scope.categoryModal = modal;
	});
	$scope.selectCategory = function () {
		$scope.categoryModal.wait()
			.then(function (item) {
				$scope.category = item;
			});
	};

	//弹窗
	var scope = $scope.$new();
	$ionicModal.fromTemplateUrl('templates/select.html', {
		scope: scope,
		animation: 'slide-in-up'
	}).then(function (modal) {
		$scope.selectModal = modal;
	});
	$scope.selectTopic = function () {
		scope.config = topicConfig;
		$scope.selectModal.wait()
			.then(function (item) {
				$scope.topic = item;
				poisearchConfig.setter({
					tag: item.name
				})
			});
	};
	$scope.selectOrder = function () {
		scope.config = orderConfig;
		$scope.selectModal.wait()
			.then(function (item) {
				$scope.order = item;
				poisearchConfig.setter({order: item})
			});
	};

	//载入更多
	$scope.loadMore = function (name) {
		$scope.sorry = false;
		if (name == 'n') {
			$scope.order = orderConfig.option[0];
		} else {
			$scope.order = orderConfig.option[1];
		}
	}
	$scope.$on('load', function (event, response) {
		$scope.$broadcast('scroll.refreshComplete');
		$rest.embeds.stats()(response);
	});
});
//TODO: use ui-router params instead of service
angular.module('starter.services')
	.service('poisearchConfig', function () {
		var poisearchConifg = {};

		function setter(data) {
			angular.extend(poisearchConifg, data)
		}

		function getter() {
			return poisearchConifg;
		}

		return {
			setter: setter,
			getter: getter
		}
	});
