angular.module('starter.controllers')
.controller('PoiCtrl', function ($scope, $state, $rootScope, $ionicHistory, $stateParams, $http, $rest, $request, poiService, $ionicModal, $ionicPopup, $ionicLoading, $location, $ionicScrollDelegate, browsehistory, $ionicActionSheet) {
	$scope.back = function(){
		$ionicHistory.goBack()
	};
	$scope.$on('$ionicView.beforeEnter', function () {
		$scope.showBackButton = !!($ionicHistory.backView());
	});
    $scope.id = $stateParams.id;
    $scope.isKard = !$scope.id.indexOf('poi') == 0;
    var poiScroll = $ionicScrollDelegate.$getByHandle('poiScroll');
	var type = $scope.id.indexOf('poi') == 0 ? 'poi' : 'kn_card';
	$scope.type = type;
	$scope.show = false;
	$scope.error = false;
	$scope.index = 0;
	$scope.title = {
		0: '详情',
		1: '关联',
		2: '周边',
		3: '足迹',
		4: '评论'
	};
	$scope.icons = false;
	var scrolling = false;
	getPoi();
	$scope.getPoi = getPoi;
	function getPoi() {
		$ionicLoading.show({ template: "<ion-spinner/>" });
		//todo: merge poiService functionality into $request, to leverage offline data
		poiService.get($stateParams.id)
		.then(function (data) {
			return type == 'kn_card' && data.poiId ?
				$rest.embed('poi')({ data: data }).catch(function () { return data; }) :
				data
		}).then(function (data) {
			//hack: poiService returns bare poi object, while $rest.embed returns response object.
			if (data.data) data = data.data;
			$scope.show = true;
			$ionicLoading.hide();
			$scope.poi = data;
			$scope.commentObj = data;
			$scope.haveSearches = true;
			if (!($scope.poi.poi || $scope.type == 'poi' || $scope.type == 'p')) {
				$scope.haveSearches = false;
			}
			$scope.poi.text = $scope.poi.text.replace(/<img src="/g, '<img src="' + environment.imagePrefix);
			$request.get('user', data.userId).then(function (response) {
				$scope.poi.user = $scope.user = response;
			});
			$rest.get(type, $stateParams.id, 'stats').then(function (response) {
				$scope.poi.stats = response.data;
			})
			$scope.$watch('comments', function (value) {
				if (!value) return;
				$scope.poi.comment = value;
			});
			$rest.post(type, $stateParams.id, 'read').then(function () {
				$rootScope.$broadcast('content.read');
			});
			browsehistory.add(new Date().valueOf(), $stateParams.id);
			$scope.tabs = ['poi-details', 'poi-relateds', 'poi-searches', 'poi-moods', 'poi-comments'];
			if (type != 'poi' || !$scope.poi.poiId)
				$scope.tabs.splice(2, 0);
			$scope.index = 0;
		}).catch(function (e) {
			$ionicLoading.show({ template: "请求失败", duration: 2000 });
			$scope.error = true;
		})
	}

	$scope.position = window.positionService.position;

	$scope.$on('load', function (event, response) {
		var content = response.data.content;
		$http.get("/youbanban/any/stats", {
			params: {
				query: JSON.stringify(content.map(function (comment) { return comment.id; }))
			}
		}).then(function (response) {
			for (var i in content) {
				var comment = content[i];
				comment.stats = response.data[comment.id];
			}
		}).catch(function (e) {
		    $ionicLoading.show({ template: "请求失败", duration: 2000 });
		});
	});

	$scope.scroll = function (anchor) {
		var height = $("#poi-view[nav-view=\"active\"] .icon-card").height();
		if (!($scope.poi.poiId || $scope.type == 'poi' || $scope.type == 'p')&&anchor=='poi-searches') {
			return;
		};
		$location.hash($scope.poi.id + '-' + anchor);
		//see http://stackoverflow.com/questions/37961173/dynamic-value-with-ionic-scroll-delegate/38023914#38023914
		var instance = $ionicScrollDelegate._instances.find(function (instance) {
			return instance.$element[0].id == $scope.poi.id;
		});
		$scope.index = $scope.tabs.indexOf(anchor);
		scrolling = true;
		setTimeout(function () {
			scrolling =false;
		}, 1000);
		instance.anchorScroll();
		instance.scrollBy(0, -86);
		setTimeout(function () {
			if (instance.getScrollPosition().top >= height)
				$scope.icons = true;
		}, 100);
		$scope.outOfRange = true;
	}


	$scope.onScroll = function () {
		if (scrolling) return;
	    var h = {};
	    h[0] = $("#poi-view[nav-view=\"active\"] .icon-card").height();
	    h[1] = h[0] + $('#poi-view[nav-view=\"active\"] .tab1').height();
	    h[2] = h[1] + $('#poi-view[nav-view=\"active\"] .tab2').height();
	    h[3] = h[2] + ($('#poi-view[nav-view=\"active\"] .tab3').height()||0);
		h[4] = h[3] + $('#poi-view[nav-view=\"active\"] .tab4').height();
	    var top = $ionicScrollDelegate.$getByHandle('poiScroll').getScrollPosition().top;
	    var range = $("ion-view[nav-view='active'] .icon-card").outerHeight() - 46;
	    if (top >= range) {
	    	$scope.outOfRange = true;
	    }else {
			$scope.outOfRange = false;
	    }

	    if (top > h[0]) {
	    	$scope.icons = true;
	    } else {
	    	$scope.icons = false;
	    }

	    if (top < h[1]) {
	    	$scope.index = 0;
	    } else if (top >= h[1] && top < h[2]) {
	    	$scope.index = 1;
	    } else if (top >= h[2] && top < h[3]) {
	    	$scope.index = 2;
	    } else if (top >= h[3] && top < h[4]) {
			$scope.index = 3;
		} else {
	        $scope.index = 4;
	    }
	    isBottom();
	    $scope.$apply();
	};

	function isBottom() {
		var id = '#'+ $scope.poi.id.replace('.', '\\.');
		var clientHeight = $(id).height();
		var scrollHeight = $(id).find('.tabs').height() + $(id).find('.icon-card').height() +　$(id).find('.poi-details').height() ;
		var instance = $ionicScrollDelegate._instances.find(function (instance) {
			return instance.$element[0].id == $scope.poi.id;
		});
		if (instance.getScrollPosition().top == Math.floor(scrollHeight - clientHeight)) {
			$scope.index = 3;
		}
	}

	$scope.openFeedBack = function () {
		 $ionicActionSheet.show({
			buttons: [
				{ text: '<img src="img/poi/poi_shouye@2x.png" height="25" />首页'},
				{ text: '<img src="img/poi/poi_tucao@2x.png" height="25" />吐槽' },
				{ text: '取消' },
			],
			buttonClicked: function (index) {
				switch (index) {
					case 0:
						location.href = '#/app/home';
						break;
					case 1:
						localStorage.userType == 1 ?$scope.NotLoggedIn() :location.href = '#/app/feedback/' + $scope.id;
						break;
				}
				return true;
			}
		});
	}

	$scope.$on('mood', function (event,data) {
		$scope.commentObj = data;
		$('.comment-bar .textarea').focus();
		$('#poi-view[nav-view=\"active\"] ion-content')[0].addEventListener('click', function f() {
			$('.comment-bar .textarea').blur();
			$scope.commentObj = $scope.poi;
			this.removeEventListener('click',f,true);
		}, true);
	});
	$scope.$on('openCreateSheet', function () {
		if (localStorage['userType'] == 1) {
			$scope.NotLoggedIn();
		} else {
			$ionicActionSheet.show({
				buttons: [
					{ text: '创建足迹'},
					{ text: '取消' }
				],
				buttonClicked: function (index) {
					switch (index) {
						case 0:
							openShareCreate();
							break;
					}
					return true;
				}
			});
		}
	});

	 function openShareCreate () {
		var scope = $scope.$new();
		var content = $('#poi-view[nav-view=\"active\"] .comment-bar *[contenteditable]').html();
		var content = content.replace(/<div>/g, '\n').replace(/<\/div>/g, '');
		scope.content = content;
		$state.call("app.mood-create");
	}
});
