angular.module('starter.controllers')
.controller('RegisterCtrl', function($scope,$http,$ionicModal,$ionicPopup,$ionicLoading,loginService) {
	$scope.registerData = {};
	$scope.$on("modal.resolve",clearTimer);
	$scope.$on("modal.reject",clearTimer);
	function clearTimer() {
		//todo: stop vericode
	}
	$scope.doRegister = function() {
		if (!loginService.checkPassword($scope.registerData.password)) {
			$ionicPopup.alert({template:'密码必须为6-16位字母，数字或英文符号，不包含空格'});
		} else {
			$ionicLoading.show({template: '<ion-spinner></ion-spinner>'});
			loginService.register($scope.registerData).then(function(response) {
				$ionicLoading.hide();
				$ionicPopup.alert({template:'注册成功'});
				$scope.$emit('modal.resolve', { user: $scope.registerData.user, password: $scope.registerData.password });
			},function(response){
				$ionicLoading.hide();
				if (response.status == 403)
					switch (response.data.code) {
						case 'user-exist':
							$ionicPopup.alert({ template: "注册失败：用户已存在" });
							break;
						case 'wrong-vericode':
							$ionicPopup.alert({ template: "注册失败：验证码错误" });
							break;
						default:
							$ionicPopup.alert({ template: "注册失败" });
							break;
					}
				else
					$ionicPopup.alert({ template: "请求失败" });
			})
		}

  };

   $scope.sendCode = function () {
   	if($scope.counting) return;
      if(!(/^\d+$/g.test($scope.registerData.user))){
        $ionicPopup.alert({template:'手机号码错误'});
      } else {
        $ionicLoading.show({ template: "<ion-spinner/>" });
        loginService.checkUserName($scope.registerData.user).then(function (response) {
          $ionicLoading.hide();
          if (response.data) {
          	$ionicPopup.alert({ template: "这个手机号已经注册过"});
          } else {
            loginService.sendmsg($scope.registerData.user,$scope.countryCode).then(function (response) {
                $ionicPopup.alert({template:'验证码发送成功，请接收'})
                $scope.vericode.count();
            }).catch(function (errMsg) {
              $ionicPopup.alert({template:'验证码发送失败'});
              $ionicLoading.hide();
            })
          }
        })
      }
    }

   $scope.openAgreement = function () {
   	$ionicModal.fromTemplateUrl('templates/agreement.html', {
   		scope: $scope,
   		animation: 'slide-in-up'
   	}).then(function (modal) {
   		$scope.$broadcast('turnWhite');
   		modal.wait();
   	});
   };

   $scope.countryCode = 86;
   $scope.countryName = '中国';

   $scope.selectAreaCode = function () {
	   $ionicModal.fromTemplateUrl('templates/select-area-code.html', {
		   scope: $scope,
		   animation: 'slide-in-up'
	   }).then(function (modal) {
		   modal.wait()
			   .then(function (value) {
					$scope.countryName = value.name;
				   	$scope.countryCode = value.code;
			   })
			   .finally(function () {
			   		setTimeout(function () {
					   modal.remove()
				   }, 1000);
			   });
	   });
   }

})
