angular.module('starter.controllers')
.controller('SettingCtrl', function($scope,$stateParams,$http,$rest,$ionicModal,$ionicLoading,cacheService, $ionicPlatform) {
	$scope.settings = {
		notificationEnabled: localStorage.notificationEnabled == 'true',
		soundEnabled: localStorage.soundEnabled == 'true'
	};
	$scope.$watch('settings.notificationEnabled', function (value) {
		localStorage.notificationEnabled = value;
	});
	$scope.$watch('settings.soundEnabled', function (value) {
		localStorage.soundEnabled = value;
	});
	$scope.checked={moodshare:'',collectshare:''};
	$rest.get("user", $stateParams.id).then(function(response) {
		$scope.user = response.data;
		$scope.user.settings.moodShared==0?$scope.checked.moodshare=false:$scope.checked.moodshare=true;
		$scope.user.settings.collectShared==0?$scope.checked.collectshare=false:$scope.checked.collectshare=true;
	});
	$scope.version = environment.version;
	var mood;
	var collect;
	$scope.openmoods = function (name,value) {
		$scope.checked.collectshare?collect=1:collect=0;
		$scope.checked.moodshare?mood=1:mood=0;
		$http({
			url:'/youbanban/user/settings',
			method:'PUT',
			data: {moodShared:mood,collectShared:collect}
		}).error(function(response) {
			if (name=='mood') {
				$scope.checked.moodshare=!value;
			} else{
				$scope.checked.collectshare=!value;
			}
		    $ionicLoading.show({ template: "修改失败", duration: 2000 });
		});
	}
	//版本更新
	$scope.update = function () {
		$ionicLoading.show({ template: "正在检查更新...<br><ion-spinner/>"});
		$http({
			url:'/oyoubanban/config/last_app_version',
			method:'GET',
			params: {
				os:'android',
				version:environment.version,
				device:''
			}
		}).success(function (response) {
			if (compareVersion(response.version, environment.version) <= 0) {
				$ionicLoading.show({ template: "已经是最新版本啦",duration: 1000 });
			} else {
				$ionicLoading.hide();
				$ionicModal.fromTemplateUrl('templates/update.html').then(function (modal) {
					modal.wait().finally(function () {
						setTimeout(function () {
							modal.remove()
						}, 1000);
					});
				})
			}
		}).error(function (response) {
			$ionicLoading.show({ template: "检查失败",duration: 1000 });
		})
	}
	$scope.$on("logout", function () {
		$scope.$emit("modal.resolve");
	});
	$scope.clearCache = function () {
		$ionicLoading.show({ template: "<ion-spinner></ion-spinner><div>正在清理</div>" });
		cacheService.clearCache().then(function () {
			$ionicLoading.show({ template: "缓存已清空", duration: 2000 });
			$scope.cacheSize = 0;
		}, function () {
			$ionicLoading.show({ template: "清空缓存失败", duration: 2000 });
		});
	};
	if (ionic.Platform.isWebView())
		cacheService.getSize().then(function (size) {
			$scope.cacheSize = size;
		}, function (e) {
			alert(JSON.stringify(e));
		});
})
