angular.module('starter.controllers')
  .controller('ShareCreateCtrl', function ($scope, $state, $stateParams, $http, $file, $q, $ionicLoading, $location, photoService,$ionicModal,$ionicPopup,$rest,$rootScope,$window,$ionicPlatform,simpleSpriteDelegate,imagePreviewService) {
	  var imageAttribute;
     $scope.imageSort = {
	   animation: 150,
	   onSort: function (evt) {
	   	onsort($scope.images, evt.oldIndex, evt.newIndex);
	   	onsort(imageAttribute, evt.oldIndex, evt.newIndex);
	   	function onsort(array, i, j) {
	   		var a = array.splice(i, 1)[0];
	   		array.splice(j, 0, a);
	   	}
	   }
     };
	  var shareCreateImage=localStorage['page.shareCreate.imageAttribute'];
	  shareCreateImage=shareCreateImage?JSON.parse(shareCreateImage):undefined;
	  if(shareCreateImage==undefined){
		  imageAttribute=[];
	  }else{
		  imageAttribute = shareCreateImage;
	  }
	  $scope.takePhoto = function () {
		photoService.getPhoto(true,9-$scope.images.length)
			.then(function (urls) {
				if (!(urls instanceof Array))
					urls = [urls];
				return $q.all(urls.map(photoService.ImageInfo));
			})
			.then(function (infos) {
				$q.all(infos.map(function (info) {
					if (info.exif.Orientation && info.exif.Orientation != 1) {
						return photoService.rotateImg(info)
							.then(photoService.ImageInfo)
							.then(function (result) {
								return result;
							})
					} else {
						return info;
					}
				})).then(function (infos) {
					infos.forEach(function (info) {
						$scope.images.push(info);
						$scope.imageUrls.push(info.src);
						var image = new Image();
						image.onload = function () {
							imageAttribute.push({width: this.width, height: this.height});
						};
						image.src = info.src;
					})
				})
        });
	};
    $scope.imagePrefix = environment.imagePrefix;
	var shareCreateMood=localStorage['page.shareCreate.mood'];
	shareCreateMood=shareCreateMood?JSON.parse(shareCreateMood):undefined;
    if(shareCreateMood==undefined){
	    $scope.mood = { content: "" };
	    $scope.imageUrls=[];
	    $scope.images=[];
    }else{
	    $scope.mood = { content: shareCreateMood.content};
	    $scope.imageUrls= shareCreateMood.imageUrls;
	    $scope.images=shareCreateMood.images;
    }
    if ($stateParams.url) {
		if ($scope.images.length >= 9) {
			$ionicPopup.alert({ template: "最多选择9张照片" });
			return;
		}
    	photoService.ImageInfo($stateParams.url)
			.then(function (info) {
				$scope.images.push(info);
    			$scope.imageUrls.push($stateParams.url);
    			var image = new Image();
    			image.onload = function () {
    				imageAttribute.push({ width: this.width, height: this.height });
    			};
    			image.src = info.src;
			});
    }
	$scope.fullscreen = function ($index) {
		imagePreviewService.show($scope.imageUrls, $index, true)
			.then(function () { }, function () { }, function (i) {
				$scope.images.splice(i, 1);
				imageAttribute.splice(i, 1);
			});
	};
     var flag =localStorage['page.shareCreate.flag'];
	  flag=flag?JSON.parse(flag):undefined;
     if(flag==undefined){
	     $scope.private = false;
	     $scope.sendOriginal = false;
     }else{
	     $scope.private = flag.private;
	     $scope.sendOriginal = flag.sendOriginal;
     }
    $scope.privacy = function(){
	    $scope.private = !$scope.private;
    };
    $scope.toSendOriginal = function(){
	    $scope.sendOriginal = !$scope.sendOriginal;
    };
    $ionicModal.fromTemplateUrl('templates/share-success.html', {
      scope: $scope.$new(),
      animation: 'slide-in-up'
    }).then(function (modal) {
      $scope.shareSuccess = modal;
    });
    $scope.submit = function(){
      if (!$scope.images.length) {
        $ionicPopup.alert({ template: "至少选择一张图片"});
        return;
      }

      $ionicLoading.show({ template: "<ion-spinner/>" });
		    var local = $scope.images;
		    return submit($scope.mood.content, local)
			    .then(function (response) {
				    if(response.data.status)throw response;
				    $scope.$emit('modal.resolve');
				    $scope.moodId = response.data;
				    return $http({
					    url:'/youbanban/mood/'+ $scope.moodId +'/privacy',
						method:'PUT',
						data:$scope.private?0:1
				    }).then(function(){
					    return $rest.get('mood', response.data).then(function (response) {
						    $scope.mood = response.data;
						    $rootScope.$broadcast('mood.create', response.data);
					    });
				    })
			    }).then(function(){
				    delete localStorage['page.shareCreate.mood'] ;
				    delete localStorage['page.shareCreate.flag'] ;
				    delete localStorage['page.shareCreate.imageAttribute'] ;
				    $ionicLoading.hide();
				    $scope.shareSuccess.wait()
			    		.then(function () {
			    			$state.resolve();
			    		});
			    })
			    .catch(function (e) {
				    $ionicLoading.hide();
				    if (e.status == -1)
					    $ionicLoading.show({ template: "无法访问网络或请求超时，请稍候再试。"});
				    else
					    $ionicLoading.show({template: "很抱歉~您发送的足迹失败！"});
			    });
    };
	  function compressImage(local){
		  var exifStrs = [];
		  var compressUrl = [];
		  var values = local.map(function (v) {
			  return v.src;
		  });
		  return $q.all(
			  //通过url获取图片dataUrl
			  values.map(photoService.getDataUrl)
		  ).then(function (dataUrl) {
			  //提取exif信息保存到exifStrs
			  exifStrs = dataUrl.map(function (v) {
				  var exifObj = piexif.load(v);
				  return piexif.dump(exifObj);
			  });
			  //压缩图片
			  return photoService.compress(values)
		  }).then(function (values) {
			  //将压缩图片url保存下来
			  compressUrl = values;
			  //获取压缩图片的dataUrl
			  return $q.all(values.map(photoService.getDataUrl));
		  }).then(function (dataUrl) {
			  return $q.all(dataUrl.map(function (v, i) {
					  //写入exif
					  var data = piexif.insert(exifStrs[i], v);
					  return photoService.writeImg(data, compressUrl[i]);
				  })
			  )
		  }).then(function () {
			  var localCopy = local.map(function(image){
				  return $.extend({},image);
			  });
			  localCopy.forEach(function (v, i) {
				  v.src = compressUrl[i];
			  });
			  return localCopy;
		  })
	  }
	function submit(content, local) {
		return ($scope.sendOriginal?$q.resolve(local):compressImage(local)).then(function(local) {
			return $q.all(local.map(function (image) {
				return $file.getMetadata(image.src);
			})).then(function (metadata) {
				return local.map(function (image, i) {
					return {
						id: i + 1,
						checksum: image.md5,
						timestamp: new Date(metadata[i].modificationTime).valueOf(),
						size: metadata[i].size
					};
				});
			}).then(function (images) {
				$ionicLoading.show({template:"<ion-spinner></ion-spinner><div>正在准备上传照片</div>"});
				return $http.get("/ybbimg/check_images", {
					params: {
						query: JSON.stringify(images)
					}
				});
			}).then(function (response) {
				var pictures = response.data.map(function (picture) {
					return picture.path ? picture.path : '';
				});
				var files = response.data.filter(function (picture) {
					return !picture.path;
				}).map(function (picture) {
					return picture.id - 1;
				});
				var checksums = files.map(function (i) {
					return local[i].md5
				});
				return $q.all(files.map(function (i) {
					var image = local[i];
					return $file.readAsArrayBuffer(image.src);
				})).then(function (buffers) {
					var data = new FormData();
					var sum = 0;
					for (var i in buffers) {
						data.append('files', new Blob([buffers[i]], { type: "image/jpeg" }), "files" + i + ".jpg");
						sum += buffers[i].byteLength;
					}
					$ionicLoading.show({template:"<ion-spinner></ion-spinner><progress-bar></progress-bar><div name=\"progress\"></div>"})
					return $http.post("/youbanban/mood/", data, {
						transformRequest: angular.identity,
						params: {
							checksums: JSON.stringify(checksums),
							data: JSON.stringify({
								content: content,
								pictures: pictures
							}),
							files: ['files']
						},
						headers: {
							'Content-Type': undefined,
							__PROGRESS__: function () {
								return function (xhr) {
									xhr.upload.addEventListener("progress", function (event) {
										console.log(event.loaded + '/' + event.total);
										var progress = event.loaded / event.total;
										var percent = Math.floor(progress * 100);
										$(".loading-container .progress-bar>div").width(percent + "%");
										$(".loading-container div[name=\"progress\"]").text(percent + "%");
									});
									xhr.upload.addEventListener("load", function (event) {
										console.log("upload complete");
										$ionicLoading.show({ template: "<ion-spinner></ion-spinner><div>正在创建足迹</div>" })
									});
								};
							}
						},
						timeout: 60 * 60 * 1000
					});
				});
			});
		})

	}
    function offBackButton(){
	    saveShareCreate();
	    $ionicPlatform.offHardwareBackButton(offBackButton)
    }
	  $ionicPlatform.onHardwareBackButton(offBackButton);
   $scope.$on('modal.reject',function(){
	   saveShareCreate();
    });
	$scope.saveShareCreate=saveShareCreate;
    function saveShareCreate(){
	    $window.localStorage['page.shareCreate.mood'] =JSON.stringify({
		    content:$scope.mood.content,
		    imageUrls:$scope.imageUrls,
		    images:$scope.images
	    });
	    $window.localStorage['page.shareCreate.flag']=JSON.stringify({
		    private:$scope.private,
		    sendOriginal:$scope.sendOriginal
	    });
	    $window.localStorage['page.shareCreate.imageAttribute']=JSON.stringify(imageAttribute)
    }
  });
angular.module('starter')
.run(function ($rootScope) {
	$rootScope.$on('logout', function () {
		delete localStorage['page.shareCreate.mood'];
		delete localStorage['page.shareCreate.flag'];
	});
});
