angular.module('starter.controllers')
	.controller('translateCtrl', function ($scope, $ionicModal, $ionicPopup, translateService, $state) {
		translateService.historyPromise.then(function () {
			$scope.history = translateService.history;
		});
		$scope.language = translateService.language;
		$scope.delete = function (translation) {
			var i = $scope.history.indexOf(translation);
			$scope.history.splice(i, 1);
			translateService.db.remove('history', translation.id);
		};
		$scope.translateImage = function () {
			if (!window.app && ionic.Platform.isWebView()) {
				$scope.requireApp();
				return;
			}
			var recent = localStorage['page.translate.language.recent'];
			recent = recent ? JSON.parse(recent) : [];
			var jsonStr = [{
				token: localStorage.token,
				baseUrl: environment.host,
				sourceLanguage: $scope.language.source,
				destinationLanguage: $scope.language.destination,
				languageHistory: recent
			}];

			setTimeout(function () {
			var translate = cordova.require('cordova-plugin-youbanban-translate.translate');
			translate.openTranslate(function (response) {
				localStorage['page.translate.language.recent'] = JSON.stringify(response.languageHistory);
				$scope.language.source = response.sourceLanguage;
				$scope.language.destination = response.destinationLanguage;
			}, function (message) {
			}, jsonStr);
			}, 0);
		};
		$scope.translateSpeech = function () {
			if (!window.app && ionic.Platform.isWebView()) {
				$scope.requireApp();
				return;
			}
			$state.go('app.translate-speech')
		}
	});
