angular.module('starter.controllers').controller('UserCtrl', function ($rootScope, $scope, $state, $stateParams, $ionicModal, $rest, $request, $ionicLoading, $http, $q, $ionicSlideBoxDelegate, $ionicHistory, $ionicPopup, $window, messageService, offlineService, moodService, $storage, activity) {
	if (localStorage['page.user.mood'] == undefined && localStorage['page.user.collection'] == undefined && localStorage['page.user.creation'] == undefined) {
		$ionicLoading.show({ template: "<ion-spinner></ion-spinner>" });
	}
	$scope.goback = function () {
		$ionicHistory.goBack();
	};

	//获取系统消息
	function loadMessage() {
		return new Promise(function ($return, $error) {
			var messages;
			return $q.all([messageService.db.getAll('message'), messageService.db.getAll('notif')]).then(function ($await_10) {
				messages = $await_10;
				$rootScope.messages.message = messages[0];
				$rootScope.messages.notif = messages[1];
				$rootScope.messageRead = !$rootScope.messages.message.find(function (message) {
					return message.unread;
				}) && !$rootScope.messages.notif.find(function (message) {
					return message.unread;
				});
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	}

	$scope.id = $stateParams.id;
	$scope.userid = localStorage.user;
	$scope.index = 0;
	if ($scope.id == $scope.userid) {
		$rootScope.messages = {
			message: [],
			notif: []
		};
		loadMessage();
		$scope.$on('pull', loadMessage);
		$scope.showCollect = true;
		$scope.showMood = true;
	} else {
		$rest.get("user", $stateParams.id).then(function (response) {
			$scope.showCollect = response.data.settings.collectShared;
			$scope.showMood = response.data.settings.moodShared;
		});
	}
	if (localStorage['page.user.stats'] !== undefined) {
		$scope.user.stats = JSON.parse(localStorage['page.user.stats']);
	}
	//获取用户个人信息
	function userInformation(data) {
		$scope.user = data;
		var levelXp = data.levelXp;
		var xp = data.xp;
		$scope.levelXp = data.levelXp;
		$scope.level = xp / levelXp;
		$scope.stats = function () {
			return new Promise(function ($return, $error) {
				var response;
				return $rest.get('user', $scope.id, 'stats').then(function ($await_11) {
					response = $await_11;
					$window.localStorage['page.user.stats'] = JSON.stringify(response.data);
					$scope.user.stats = response.data;
					return $return();
				}.$asyncbind(this, $error), $error);
			}.$asyncbind(this));
		};
		$scope.stats();
		$scope.chenghao = ['初来乍到', '走马观花', '观风问俗', '流连忘返', '走南闯北', '游山玩水', '旧地重游', '饱揽河山', '周游列国', '四海为家', '浪迹天涯'];
		$scope.arr = Math.floor(data.level / 10);
		if (data.level >= 100) {
			$scope.arr = 10;
		}
	}

	$request.get("user", $stateParams.id).then(function (data) {
		userInformation(data);
	});

	function getUser() {
		return new Promise(function ($return, $error) {
			var data;
			return $http.get('/youbanban/user/' + $stateParams.id, {
				headers: {
					"Cache-Control": "no-cache"
				}
			}).then(function ($await_12) {
				data = $await_12;
				userInformation(data.data);
				data.data.$time = new Date().valueOf();
				$storage.set('user', $stateParams.id, data.data);
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	};

	$rootScope.$on('userChange', function (event, message) {
		$scope.user = message;
		$scope.stats();
	});
	$rootScope.$on('exchange', function (event, jifen) {
		$scope.user.totalScore -= jifen;
	});
	//关注
	$scope.guanzhu = function () {
		return new Promise(function ($return, $error) {
			if (localStorage['userType'] == 1) {
				$scope.NotLoggedIn();
				return $If_8.call(this);
			} else {
				$ionicLoading.show({
					template: "<ion-spinner/>"
				});
				if ($scope.user.stats.following) {
					var $Try_1_Post = function () {
						return $If_9.call(this);
					}.$asyncbind(this, $error);var $Try_1_Catch = function (e) {
						$ionicLoading.show({
							template: "取消关注失败",
							duration: 1000
						});
						return $Try_1_Post();
					}.$asyncbind(this, $error);
					try {
						return $http.delete('/youbanban/user/' + $stateParams.id + "/follow").then(function ($await_13) {
							$scope.user.stats.following = !$scope.user.stats.following;
							$ionicLoading.hide();
							$rootScope.$broadcast('user.unfollow', $stateParams.id);
							return $Try_1_Post();
						}.$asyncbind(this, $Try_1_Catch), $Try_1_Catch);
					} catch (e) {
						$Try_1_Catch(e)
					}
				} else {
					var $Try_2_Post = function () {
						return $If_9.call(this);
					}.$asyncbind(this, $error);var $Try_2_Catch = function (e) {
						$ionicLoading.show({
							template: "关注失败",
							duration: 1000
						});
						return $Try_2_Post();
					}.$asyncbind(this, $error);
					try {
						return $http.post('/youbanban/user/' + $stateParams.id + "/follow").then(function ($await_14) {
							$scope.user.stats.following = !$scope.user.stats.following;
							$rootScope.$broadcast('user.follow', $stateParams.id);
							$ionicLoading.hide();
							return $Try_2_Post();
						}.$asyncbind(this, $Try_2_Catch), $Try_2_Catch);
					} catch (e) {
						$Try_2_Catch(e)
					}
				}

				function $If_9() {
					return $If_8.call(this);
				}
			}

			function $If_8() {
				return $return();
			}
		}.$asyncbind(this));
	};
	//点击头像
	$scope.avatar = function () {
		var useravatar = $('#user-view[nav-view=\"active\"] .useravatar>div');
		var zhe = $('#user-view[nav-view=\"active\"] .zhe');
		if ($scope.userid == $scope.id) {
			zhe.toggle();
			useravatar.children('a:nth-of-type(1)').toggle(100, function () {
				useravatar.children('a:nth-of-type(2)').toggle(100, function () {
					useravatar.children('a:nth-of-type(3)').toggle(100);
				});
			});
		}
	};
	//分享
	if (localStorage['page.user.mood'] !== undefined) {
		$scope.moods = JSON.parse(localStorage['page.user.mood']);
	}

	function moodPromise() {
		return new Promise(function ($return, $error) {
			var response;
			return $http.get('/youbanban/user/' + $stateParams.id + '/mood').then($rest.join.any()).then($rest.embeds.stats()).then(function ($await_15) {
				response = $await_15;
				$window.localStorage['page.user.mood'] = JSON.stringify(response.data.content);
				$scope.moods = response.data.content;
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	}

	//草稿
	if (localStorage['page.user.draft'] !== undefined) {
		$scope.draft = JSON.parse(localStorage['page.user.draft']);
	}

	function draftPromise() {
		return new Promise(function ($return, $error) {
			var response;
			return moodService.getDraft().then(function ($await_16) {
				response = $await_16;
				response.data.content.splice(3);
				$window.localStorage['page.user.draft'] = JSON.stringify(response.data.content);
				$scope.draft = response.data.content;
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	}

	//喜欢
	if (localStorage['page.user.collection'] !== undefined) {
		$scope.collections = JSON.parse(localStorage['page.user.collection']);
	}

	function collectionPromise() {
		return new Promise(function ($return, $error) {
			var response;
			return $http.get('/youbanban/user/' + $stateParams.id + '/collection').then($rest.join.any()).then(function ($await_17) {
				response = $await_17;
				$window.localStorage['page.user.collection'] = JSON.stringify(response.data.content);
				$scope.collections = response.data.content;
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	}

	$q.all([moodPromise(), draftPromise(), collectionPromise()]).then(function () {
		$scope.loaded = true;
		$ionicLoading.hide();
	}, function (e) {
		if (e.data.code != 'forbidden') {
			$ionicLoading.show({ template: "请求失败" });
		}
	});

	function Modal(name) {
		return $ionicModal.fromTemplateUrl('templates/' + name + '.html', {
			scope: $scope,
			animation: 'slide-in-up'
		});
	}

	var getModal = Modal.memoize();
	$scope.openModal = function (name) {
		return new Promise(function ($return, $error) {
			return getModal(name).then(function ($await_18) {
				$await_18.wait();
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	};

	$scope.openShareCreate = function () {
		$state.call("app.mood-create");
	};

	//离线城市数据
	$scope.offline = function () {
		return new Promise(function ($return, $error) {
			return offlineService.getModal().then(function ($await_19) {
				$await_19.wait();
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	};

	var remove = $rootScope.$on('user.remove', function (event, id) {
		$scope.user.stats.followerCount--;
		$window.localStorage['page.user.stats'] = JSON.stringify($scope.user.stats);
	});
	var unfollow = $rootScope.$on('user.unfollow', function (event, id) {
		$scope.user.stats.followeeCount--;
		$window.localStorage['page.user.stats'] = JSON.stringify($scope.user.stats);
	});
	var follow = $rootScope.$on('user.follow', function (event, id) {
		$scope.user.stats.followeeCount++;
		$window.localStorage['page.user.stats'] = JSON.stringify($scope.user.stats);
	});
	var collect = $rootScope.$on('collect', getCollect);
	var uncollect = $rootScope.$on('uncollect', getCollect);
	var love = $rootScope.$on('love', getLove);
	var unlove = $rootScope.$on('unlove', getLove);
	var moodDelete = $rootScope.$on('mood.delete', moodPromise);
	var moodCreate = $rootScope.$on('mood.create', function () {
		moodPromise();
		getUser();
		getTaskStatus();
	});
	var draftDelete = $rootScope.$on('mood.delete', draftPromise);
	var draftCreate = $rootScope.$on('mood.create', draftPromise);
	var draftModify = $rootScope.$on('mood.modify', draftPromise);
	var contentRead = $rootScope.$on('content.read', function () {
		getUser();
		getTaskStatus();
	});
	var contentShare = $rootScope.$on('content.share', function () {
		getUser();
		getTaskStatus();
	});

	function getCollect(event, data) {
		return new Promise(function ($return, $error) {
			var response, tempMood;
			return $http.get('/youbanban/user/' + $stateParams.id + '/collection').then($rest.join.any()).then(function ($await_20) {
				response = $await_20;
				$scope.collections = response.data.content;
				$window.localStorage['page.user.collection'] = JSON.stringify(response.data.content);
				tempMood = $scope.moods.find(function (item) {
					return data.id == item.id;
				});
				if (tempMood) {
					tempMood.stats.collecting = data.stats.collecting;
					tempMood.stats.collects = data.stats.collects;
					$window.localStorage['page.user.mood'] = JSON.stringify($scope.moods);
				}
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	}

	function getLove(event, data) {
		var tempMood = $scope.moods.find(function (item) {
			return data.id == item.id;
		});
		if (tempMood) {
			tempMood.stats.loving = data.stats.loving;
			tempMood.stats.loves = data.stats.loves;
			$window.localStorage['page.user.mood'] = JSON.stringify($scope.moods);
		}
	}

	$scope.edit = function (mood) {
		$state.call("app.mood-edit.content", { mood: mood });
	};
	$scope.refresh = function () {
		return new Promise(function ($return, $error) {
			$scope.loaded = false;
			$ionicLoading.show({ template: "<ion-spinner></ion-spinner>" });
			var $Try_3_Post = function () {
				return $return();
			}.$asyncbind(this, $error);var $Try_3_Catch = function (e) {
				$scope.$broadcast('scroll.refreshComplete');
				$ionicLoading.hide();
				if (e.data.code != 'forbidden') {
					$ionicLoading.show({ template: "请求失败" });
				}
				throw e;
			}.$asyncbind(this, $error);try {
				return $q.all([moodPromise(), draftPromise(), collectionPromise(), getUser(), getTaskStatus(), getActivities()]).then(function ($await_21) {
					$scope.loaded = true;
					$ionicLoading.hide();
					$scope.$broadcast('scroll.refreshComplete');
					return $Try_3_Post();
				}.$asyncbind(this, $Try_3_Catch), $Try_3_Catch);
			} catch (e) {
				$Try_3_Catch(e)
			}
		}.$asyncbind(this));
	};

	$scope.toLogin = function () {
		return new Promise(function ($return, $error) {
			return $state.call('app.login').then(function ($await_22) {
				if ($ionicHistory.currentView().url.indexOf('/app/user/') == 0) {
					$state.go('app.user', { id: localStorage.user }, { location: 'replace' });
				}
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	};

	$scope.preventDefault = function ($event) {
		if ($event.gesture.direction == 'left' || $event.gesture.direction == 'right') $event.gesture.srcEvent.preventDefault();
	};

	function getActivities() {
		return new Promise(function ($return, $error) {
			var result, now;
			return activity.getActivities().then(function ($await_23) {
				result = $await_23;
				now = new Date().getTime();
				result.data = result.data.filter(function (activity) {
					return activity.showEndTime > now;
				});
				$scope.activities = result.data;
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	}

	getActivities();

	$scope.toActivity = function (id) {
		return new Promise(function ($return, $error) {
			var $Try_4_Finally = function ($Try_4_Exit) {
				return function ($Try_4_Value) {
					activityList = JSON.parse(localStorage.getItem('shownActivity')) || [];
					if (!activityList.includes(id)) {
						activityList.push(id);
					}
					localStorage.setItem('shownActivity', JSON.stringify(activityList));
					return $Try_4_Exit && $Try_4_Exit.call(this, $Try_4_Value);
				}.$asyncbind(this, $error);
			}.$asyncbind(this);

			var result, activityList;
			var $Try_4_Post = function () {
				return $return();
			}.$asyncbind(this, $error);var $Try_4_Catch = function ($exception_5) {
				throw $exception_5;
			}.$asyncbind(this, $Try_4_Finally($error));
			try {
				return $state.call('app.event', { id: id }).then(function ($await_24) {
					result = $await_24;
					activity.dealWithCallBack(result);
					return $Try_4_Finally($Try_4_Post)();
				}.$asyncbind(this, $Try_4_Catch), $Try_4_Catch);
			} catch ($exception_5) {
				$Try_4_Catch($exception_5)
			}
		}.$asyncbind(this));
	};

	var taskScore = [];
	var totalScore = 0;
	var TaskName = ['checkin', 'share', 'read', 'createMood'];
	$q.all([$http.get('/youbanban/user/task_status'), $http.get('/youbanban/user/task_score')]).then(function (result) {
		var taskStatus = result[0].data;
		taskScore = result[1].data;
		var dailyScore = 0;
		TaskName.forEach(function (v) {
			totalScore += taskScore[v];
			if (taskStatus[v]) {
				dailyScore += taskScore[v];
			}
		});
		$scope.score = totalScore == 0 ? 0 + '%' : Math.floor(dailyScore / totalScore * 100) + '%';
	});

	function getTaskStatus() {
		return new Promise(function ($return, $error) {
			var taskStatus, dailyScore;
			return $http.get('/youbanban/user/task_status').then(function ($await_25) {
				taskStatus = $await_25.data;
				dailyScore = 0;
				TaskName.forEach(function (v) {
					if (taskStatus[v]) {
						dailyScore += taskScore[v];
					}
				});
				$scope.score = totalScore == 0 ? 0 + '%' : Math.floor(dailyScore / totalScore * 100) + '%';
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	}

	$scope.toTask = function () {
		return new Promise(function ($return, $error) {
			var $Try_6_Finally = function ($Try_6_Exit) {
				return function ($Try_6_Value) {
					getTaskStatus();
					return $Try_6_Exit && $Try_6_Exit.call(this, $Try_6_Value);
				}.$asyncbind(this, $error);
			}.$asyncbind(this);

			var result;
			var $Try_6_Post = function () {
				return $return();
			}.$asyncbind(this, $error);var $Try_6_Catch = function ($exception_7) {
				throw $exception_7;
			}.$asyncbind(this, $Try_6_Finally($error));
			try {
				return $state.call('app.event', { url: '/funfair/task/' }).then(function ($await_26) {
					result = $await_26;
					activity.dealWithCallBack(result);
					return $Try_6_Finally($Try_6_Post)();
				}.$asyncbind(this, $Try_6_Catch), $Try_6_Catch);
			} catch ($exception_7) {
				$Try_6_Catch($exception_7)
			}
		}.$asyncbind(this));
	};

	$scope.$on('$destroy', moodDelete);
	$scope.$on('$destroy', moodCreate);
	$scope.$on('$destroy', draftDelete);
	$scope.$on('$destroy', draftCreate);
	$scope.$on('$destroy', draftModify);
	$scope.$on('$destroy', remove);
	$scope.$on('$destroy', unfollow);
	$scope.$on('$destroy', follow);
	$scope.$on('$destroy', collect);
	$scope.$on('$destroy', uncollect);
	$scope.$on('$destroy', love);
	$scope.$on('$destroy', unlove);
	$scope.$on('$destroy', contentRead);
	$scope.$on('$destroy', contentShare);
});
angular.module('starter').run(function ($rootScope) {
	$rootScope.$on('logout', function () {
		localStorage.removeItem('page.user.mood');
		localStorage.removeItem('page.user.collection');
	});
});