angular.module('starter.controllers')
.controller('UserMoodsCtrl', function ($scope, $rootScope, $state, $http,$ionicModal, $rest, $request, $q, $stateParams, $ionicLoading) {
  var month=(new Date).getMonth();
	$scope.show=false;
	$scope.showmood=true;
	$scope.index = month;
	$scope.id = $stateParams.id;
	$scope.oneselfid = localStorage.user;
	$scope.user = {};
	if (localStorage.user == $stateParams.id)
		$scope.show = true;
	else {
		$ionicLoading.show({ template: "<ion-spinner/>" });
		$rest.get("user", $stateParams.id).then(function (response) {
			$scope.nickName =  response.data.nickName;
			$scope.mood = response.data.settings.moodShared;
			$scope.mood == 0 ? $scope.showmood = false : $scope.showmood = true;
			$ionicLoading.hide();
			$scope.show = true;
		});
	}
	$http.get("/youbanban/user/" + $scope.id + "/mood/month_and_year")
		.then(function (response) {
			$scope.years = response.data;
			var year = response.data[response.data.length - 1];
			var month = year.month[year.month.length - 1];
			$scope.timeline.selection = {
				year: year.year,
				month: month
			};
		});
	$scope.index = 0;
	$scope.$on('timeline.click', function (event, message) {
		$ionicLoading.show({template:"<ion-spinner/>"});
		get(message).then(function (response) {
			$ionicLoading.hide();
			$scope.timeline.selection = message;
			var page = response.data.number;
			$scope.index = page * 10;
			//the 1st mood in page may not be of the requested month due to page alignment
			for (var i = $scope.index + 3; i < $scope.index + 13; i++) {
				var month = new Date($scope.user.mood[i].createdTime).getMonth();
				if (month + 1 == message.month)
					break;
			}
			$scope.index = i - 3;
		});
	});
	$scope.timeline = {};
	$scope.$watch('index', function (value) {
		if (value == undefined || !$scope.user.mood) return;
		var time = $scope.user.mood[value + 3].createdTime;
		var time = new Date(time);
		var time = {
			year: time.getFullYear(),
			month: time.getMonth() + 1
		};
		$scope.timeline.selection = time;
	});
	$scope.prev = function () {
		$scope.index--;
		$scope._direction = '-';
		if ($scope.index < 0)
			$scope.index = 0;
	};
	$scope.next = function () {
		$scope.index++;
		$scope._direction = '+';
		if ($scope.index + 3 >= $scope.user.mood.length)
			$scope.index--;
	};
	$scope.preventDefault = function ($event) {
		$event.gesture.srcEvent.preventDefault();
	};
	$scope.ondragend = function ($event) {
		switch ($event.gesture.direction) {
			case 'up':
				$scope.prev();
				break;
			case 'down':
				$scope.next();
				break;
		}
	};
	$scope.Math = Math;
	getAll().then(function (contents) {
		$scope.user.mood = contents;
		for (var i = 0; i < 3; i++)
			contents.unshift({ id: -i });
	})
	function getAll() {
		return $http.get("/youbanban/user/" + $scope.id + "/mood/", {
			params: {
				page: 0,
				size: 10
			}
		})
		.then(function (response) {
			var a = [];
			for (var i = 0; i < response.data.totalPages; i++)
				a.push(i);
			return $q.all(a.map(function (i) {
				return $http.get("/youbanban/user/" + $scope.id + "/mood/", {
					params: {
						page: i,
						size: 10
					}
				})
				.then($rest.join('mood'))
				.then($rest.embeds.stats());
			})).then(function (responses) {
				var contents = responses.map(function (response) {
					return response.data.content;
				});
				return [].concat.apply([], contents);
			});
		});
	}
	function get(index) {
		return $http.get("/youbanban/user/" + $scope.id + "/mood/", {
			params: typeof (index) == 'number' ? {
				page: index,
				size: 10
			} : {
				year: index.year,
				month: index.month,
				size: 10
			},
		})
		.then($rest.join('mood'))
		.then($rest.embeds.stats());
	}

	$scope.openMoodCreate = function () {
		$state.call("app.mood-create");
	}
	function refresh() {
		$http.get("/youbanban/user/" + $scope.id + "/mood/month_and_year")
			.then(function (response) {
				$scope.years = response.data;
				var year = response.data[response.data.length - 1];
				var month = year.month[year.month.length - 1];
				$scope.timeline.selection = {
					year: year.year,
					month: month
				};
			});
		getAll().then(function (contents) {
			$scope.user.mood = contents;
			for (var i = 0; i < 3; i++)
				contents.unshift({ id: -i });
			if ($scope.index + 3 >= contents.length)
				$scope.index--;
		})
	}

	var moodDelete = $rootScope.$on('mood.delete', refresh);
	var moodCreate = $rootScope.$on('mood.create', refresh);

	$scope.$on('$destroy', moodDelete);
	$scope.$on('$destroy', moodCreate);
})
