var signatureResult;
var nickNameResult;
angular.module('starter.controllers')
.controller('UserdataCtrl', function($scope, $http, $q, $stateParams, $ionicModal, $rest, $ionicLoading, $rootScope,$state, $file, $storage, photoService, socialService, $ionicPopup) {
	$scope.id = $stateParams.id;
	$scope.userid = localStorage.user;
	$scope.index = 0;
	$http.get("/youbanban/user/" + $stateParams.id, {
		headers: { "Cache-Control": "no-cache" }
	}).then(function(response) {
		$scope.user = response.data;
		signatureResult = $scope.user.signature;
		nickNameResult = $scope.user.nickName;
	});

	$ionicModal.fromTemplateUrl('templates/sex.html', {
		scope: $scope.$new(),
		animation: 'slide-in-up'
	}).then(function (modal) {
		$scope.sexModal = modal;
	});

	/*城市选择*/
	$scope.$on("$ionicView.enter", function () {
		citySource = 'city';
		showHotCity = false;
		showGlobal = false;
		$ionicModal.fromTemplateUrl('templates/city.html', {
			scope: $scope.$new(),
			animation: 'slide-in-up'
		}).then(function (modal) {
			$scope.cityModal = modal;
		});
	});

	$scope.$on('$ionicView.leave', function () {
		$scope.cityModal.remove();
	});

	$scope.selectCity = function () {
		$scope.cityModal.wait().then(function (value) {
			$scope.user.ciyt = value.city;
			$scope.user.country = value.country;
		})
	};

	$rootScope.$on('selectNickname', function (event, message) {
		$scope.user.nickName = message;
        nickNameResult = message;
	});

	$rootScope.$on('selectSignature', function (event, message) {
		$scope.user.signature = message;
        signatureResult = message;
	});
	$scope.changeBg = function() {
		photoService.getPhoto()
			.then(photoService.ImageInfo)
			.then(function (info) {
				if (info.exif.Orientation && info.exif.Orientation != 1) {
					photoService.rotateImg(info)
						.then(photoService.ImageInfo)
						.then(function (info) {
							$file.getSize(info.src).then(function (size) {
								info.size = size;
								$scope.user.background = info.src;
								$scope.bg = info;
							})
						});
					return;
				}
				$file.getSize(info.src).then(function (size) {
					info.size = size;
					$scope.user.background = info.src;
					$scope.bg = info;
				})
			})
	};
	$scope.changeHeadImg = function() {
		photoService.getPhoto()
			.then(photoService.ImageInfo)
			.then(function (info) {
				if (info.exif.Orientation && info.exif.Orientation != 1) {
					photoService.rotateImg(info)
						.then(photoService.ImageInfo)
						.then(function (info) {
							$file.getSize(info.src).then(function (size) {
								info.size = size;
								$scope.user.background = info.src;
								$scope.bg = info;
							})
						});
					return;
				}
				$file.getSize(info.src).then(function (size) {
					info.size = size;
					$scope.user.avatar = info.src;
					$scope.avatar = info;
				})
			})
	};
	function saveInfo(){
		$http({
			method: 'PUT',
			url: '/youbanban/user',
			data: {
				nickName: $scope.user.nickName,
				signature: $scope.user.signature,
				sex: $scope.user.sex,
				city: $scope.user.city,
				country: $scope.user.country,
				avatar: $scope.user.avatar,
				background: $scope.user.background
			}
		}).success(function (response) {
			$scope.user.$time = new Date().valueOf();
			$storage.set('user', $scope.user.id, $scope.user);
			$rootScope.$broadcast('userChange', $scope.user);
			$state.go("app.user",{id:localStorage.user});
			$ionicLoading.show({template:"保存成功！",duration:2000});
		}).error(function(){
			$ionicLoading.show({template:"保存失败！",duration:2000});
		});
	}
	$scope.save = function(){
		$ionicLoading.show({ template: "<ion-spinner/>" });
		var images = [];
		if ($scope.user.avatar[0] != '/')
			images.push(
				checkImage($scope.avatar).then(function (path) {
					var image = path ? $q.resolve(path) : uploadImage($scope.avatar);
					return image.then(function (url) {
						$scope.user.avatar = url;
					});
				})
			);
		if ($scope.user.background[0] != '/')
			images.push(
				checkImage($scope.bg).then(function (path) {
					var image = path ? $q.resolve(path) : uploadImage($scope.bg);
					return image.then(function (url) {
						$scope.user.background = url;
					});
				})
			);
			$q.all(images).then(function () {
				saveInfo();
			}).catch(function (e) {
				$ionicLoading.hide();
				alert(JSON.stringify(e));
			});
	};
	function checkImage(image) {
		var testImage={
			id:1,
			checksum:image.md5,
			timestamp:new Date().valueOf(),
			size:image.size
		};
		return $http.get("/ybbimg/check_images", {
			params: {
				query: JSON.stringify([testImage])
			}
		}).then(function(response){
			return response.data[0].path;
		});
	}
	function uploadImage(image){
		return $file.readAsArrayBuffer(image.src).then(function(buffer){
			var oFormData = new FormData();
			oFormData.append('files', new Blob([buffer], { type: "image/jpeg" }), "0.jpg");
			return $http({
				method: 'POST',
				url: '/ybbimg/upload_images',
				params:{
					checksums: JSON.stringify([image.md5]),
					type:'user'
				},
				data: oFormData,
				headers: {
			      	'Content-Type':undefined
			    },transformRequest:angular.identify
			}).then(function (response) {
				return response.data[0];
			});
		});
	}
	$scope.environment = environment;

	$scope.isBound = false;
	$http.get('/youbanban/user/bound').then(function (result) {
		$scope.isBound = result.data;
	});
	$scope.bindWeChat = function () {
		if (!$scope.isBound) {
			socialService.auth.weixin().then(function (auth) {
				$http.post('/youbanban/user/bind', {
					auth_code: auth.code
				}, {
					headers: {
						'Content-Type': 'application/x-www-form-urlencoded'
					},
					transformRequest: function (obj) {
						var str = [];
						for (var s in obj) {
							str.push(encodeURIComponent(s) + "=" + encodeURIComponent(obj[s]));
						}
						return str.join("&");
					}
				}).then(function () {
					$http.get('/youbanban/user/bound').then(function (result) {
						$scope.isBound = result.data;
					})
				}, function (e) {
					if (e.data.code == 'binding-exist') {
						$ionicPopup.alert({
							template:'绑定失败，该账号已绑定在其他游伴伴账号'
						});
					}
				});
			})
		}
	}
});
