angular.module('starter.directives')
	.directive('poiDistance', function () {
		return {
			restrict: 'E',
			scope: {
				ngModel: '='
			},
			controller: function ($scope) {
				$scope.$watch('ngModel',function(value){
					if(!value)return;
					$scope.isKard = $scope.ngModel.id.indexOf('kn_card') == 0;
				});
			},
			templateUrl: 'templates/poi-distance.html'
		};
	});


angular.module('starter.directives')
.directive('poiCard', function ($rest) {
	return {
		restrict: 'E',
		scope: {
			ngModel: '='
		},
		controller: function ($scope) {
			$scope.type = $rest.getType($scope.ngModel.id);
		},
		templateUrl: 'templates/poi-card.html',
		replace: true
	};
})
angular.module('starter.directives')
.directive('poiDiv', function () {
	return {
		restrict: 'E',
		scope: {
			ngModel: '='
		},
		templateUrl: 'templates/poi-div.html',
		replace: true,
		controller:function($scope,$rootScope,speechService){
			$rootScope.$watch('poi',function(){
				$('.poi-div .poi-text').scrollTop(0);
			})
			$scope.close = function () {
				if ($rootScope.speech.poi && $rootScope.speech.poi.id == $scope.ngModel.id && $rootScope.speech.audio.playing) {
					$rootScope.speech.audio.pause();
					$rootScope.speech.poi = null;
				}
				$rootScope.poiDiv.slidedown();
			};
		}
	};
})

angular.module('starter.directives')
.directive('commentCard', function () {
	return {
		restrict: 'E',
		scope: {
			ngModel: '='
		},
		controller: function ($scope) {
			$scope.ngModel.content = $scope.ngModel.content.replace(/\n/g,'<div><\/div>');
		},
		templateUrl: 'templates/comment-card.html',
		replace: true
	};
})
angular.module('starter.directives')
	.directive('moodCard', function () {
		return {
			restrict: 'E',
			scope: {
				ngModel: '='
			},
			templateUrl: 'templates/mood-card.html',
			replace: true,
			link: function (scope) {
				if (scope.ngModel.rich) {
					scope.imgUrl = scope.ngModel.richContent.find(function (content) {
						return content.type === 'picture';
					}).value;
					var content = scope.ngModel.richContent.find(function (content) {
						return content.type === 'text';
					});
					if(content) {
						scope.content = content.value;
					}
				} else {
					scope.imgUrl = scope.ngModel.pictures[0];
					scope.content = scope.ngModel.content;
				}
			}
		};
	})

angular.module('starter.directives')
.directive('shareCard', function () {
	return {
		restrict: 'E',
		scope: {
			ngModel: '='
		},
		templateUrl: 'templates/share-card.html',
		replace: true
	};
})
angular.module('starter.directives')
.directive('richMoodSquare', function () {
	return {
		restrict: 'E',
		scope: {
			ngModel: '='
		},
		templateUrl: 'templates/rich-mood-square.html',
		replace: true
	};
})
angular.module('starter.directives')
.directive('offlineCity', function () {
	return {
		restrict: 'E',
		templateUrl: "templates/offline-city.html",
		replace: true,
		scope: {
			hot: '=',
			all: '=',
			current: '='
		}
	};
})
.directive('offlineCityEntry', function () {
	return {
		restrict: 'E',
		templateUrl: "templates/offline-city-entry.html",
		replace: true
	};
});

angular.module('starter.directives')
.directive('imageArray', function () {
	return {
		restrict: 'E',
		scope: {
			ngModel: '='
		},
		templateUrl: 'templates/image-array.html',
		replace: true,
		compile: function (element, attr) {
			var size = attr.size || 'large';
			var smaller = {
				large: 'medium',
				medium: 'small'
			}[size];
			element.find("div[xx-background]").attr('size', smaller);
			element.find([
				"*[ng-switch-when=\"1\"]>div[xx-background]",
				"*[ng-switch-when=\"2\"]>div[xx-background]",
				"*[ng-switch-when=\"3\"]>div[xx-background]",
				"*[ng-switch-when=\"4\"]>div[xx-background]"
			].join(',')).attr('size', size);
		}
	};
})
angular.module('starter.directives')
.directive('square', function () {
	return {
		restrict: 'A',
		priority: 99,	//equals priority of ng-src
		link: function (scope, element, attr) {
			var ratio = attr.square || 1;
			scope.$watch(function () { return $(element[0]).width() * ratio; }, function (value) {
				if (!value)
					return;
				$(element[0]).height(value);
			});
		}
	};
});
angular.module('starter.directives')
.service('zoomService', function () {
	return function (url, size) {
		var name = url.substr(
			url.lastIndexOf('/') + 1
		);
		var i = name.indexOf('_');
		if (i == -1) return 2;
		name = name.substr(0, i);
		var wh = name.split('x');
		var l = Math.min(wh[0], wh[1]);
		switch (size) {
			case 'large':
				return l / 500;
			case 'medium':
				return l / 240;
			case 'small':
				return l / 80;
		}
	}
})
.directive('xxSrc', function (imgcache, zoomService) {
	return {
		restrict: 'A',
		priority: 99,	//equals priority of ng-src
		link: function (scope, element, attr) {
			attr.$observe('xxSrc', function (value) {
				if (!value)
					return;
				if (value.indexOf("file://") == 0)
					var prefix = "";
				else if (value.indexOf("http://") == 0 || value.indexOf("https://") == 0)
					var prefix = "";
				else if (value.indexOf("img/") == 0)
					var prefix = "";
				else
					var prefix = isEncrypted(value) ?
						environment.imagePrefixEncrypted + '/' :
						attr.size ?
							environment.host + "/imgs/zoom/" + zoomService(value, attr.size) :
							environment.imagePrefix;
				if (prefix)
					src(prefix + value);
				else
					attr.$set('src', value);
			});
			function src(value) {
				if (window.app)
					imgcache.get(value).then(function (url) {
						if (url)
							attr.$set('src', url);
						else {
							attr.$set('src', value);
							imgcache.download(value);
						}
					});
				else
					attr.$set('src', value);
			}
		}
	};
	function isEncrypted(url) {
		url = url.substr(url.lastIndexOf(".") + 1);
		var array = ['png', 'jpg', 'jpeg', 'gif'];
		return !array.includes(url.toLowerCase());
	}
});

angular.module('starter.directives')
.directive('xxHref', function ($location) {
	return {
		restrict: 'A',
		priority: 99,	//equals priority of ng-src
		link: function (scope, element, attr) {
			element.on('click', function () {
				document.location.href = element.attr('xx-href');
			});
		}
	};
});
angular.module('starter.directives')
.directive('bgHref', function ($location) {
	return {
		restrict: 'A',
		priority: 99,	//equals priority of ng-src
		link: function (scope, element, attr) {
			element.on('click', function ($event) {
				if ($event.target == element[0])
					document.location.href = element.attr('bg-href');
			});
		}
	};
});
angular.module('starter.directives')
.service('navService', function ($ionicActionSheet) {
	return function (poi) {
		var hide = $ionicActionSheet.show({
			buttons: [
				{ text: '百度导航' },
				{ text: '高德导航' }
			],
			titleText: '导航',
			buttonClicked: function (index) {
				hide();
				switch (index) {
					case 0:
						window.location.href =
							"baidumap://map/direction?destination=latlng:{{lat}},{{lng}}|name:{{name}}&mode=driving"
								.replace("{{lat}}", poi.location.lat)
								.replace("{{lng}}", poi.location.lon)
								.replace("{{name}}", poi.name);
						break;
					case 1:
						window.location.href =
							"androidamap://navi?sourceApplication=游伴伴&poiname={{name}}&lat={{lat}}&lon={{lon}}&dev=1&style=2"
								.replace("{{lat}}", poi.location.lat)
								.replace("{{lon}}", poi.location.lon)
								.replace("{{name}}", poi.name);
						break;
				}
			}
		});
	};
})
.directive('navHref', function (navService) {
	return {
		restrict: 'A',
		scope: {
			navHref: '='
		},
		link: function (scope, element, attr) {
			element.on('click', function () {
				if (!scope.navHref) return;
				navService(scope.navHref);
			});
		}
	};
});
angular.module('starter.directives')
.directive('xxBackground', function (imgcache, zoomService, imgloading) {
	return {
		restrict: 'A',
		priority: 99,	//equals priority of ng-src
		link: function (scope, element, attr) {
			attr.$observe('xxBackground', function (value) {
				if (!value) {
					element.css('background-image', 'none');
					return;
				}
				if (value.indexOf("file://") == 0)
					var prefix = "";
				else if (value.indexOf("http://") == 0 || value.indexOf("https://") == 0)
					var prefix = "";
				else if (value.indexOf("img/") == 0)
					var prefix = "";
				else
					var prefix = isEncrypted(value) ?
						environment.imagePrefixEncrypted + '/' :
						attr.size ?
							environment.host + "/imgs/zoom/" + zoomService(value, attr.size) :
							environment.imagePrefix;
				element.css('background-color', color);
				if (prefix)
					background(prefix + value);
				else
					element.css('background-image', 'url(' + value + ')');
			});
			var color = imgloading.nextColor();
			function background(value) {
				if (isEncrypted(value)) {
					element.css('background-image', 'url(' + value + ')');
					return;
				}
				if (window.app)
					imgcache.get(value).then(function (url) {
						if (url)
							element.css('background-image', 'url(' + url + ')');
						else {
							var empty = !element.children().length;
							if (empty) {
								element.addClass('loading');
								element.append(angular.element("<div>游伴伴</div>"));
							}
							imgcache.download(value)
								.then(function (file) {
									if (empty) {
										element.removeClass('loading');
										element.empty();
									}
									element.css('background-image', 'url("' + file.toURL() + '")');
								});
						}
					});
				else if(!element.children().length){
					element.addClass('loading');
					element.append(angular.element("<div>游伴伴</div>"));
					setTimeout(function () {
						element.css('background-image', 'url(' + value + ')');
						element.removeClass('loading');
						element.empty();
					}, 1000);
				} else
					element.css('background-image', 'url(' + value + ')');
			}
		}
	};
	function isEncrypted(url) {
		url = url.substr(url.lastIndexOf(".") + 1);
		var array = ['png', 'jpg', 'jpeg', 'gif'];
		return !array.includes(url.toLowerCase());
	}
});

angular.module('starter.directives')
.directive('imgX', function (imgcache, zoomService, imgloading, photoService) {
	return {
		restrict: 'E',
		priority: 99,	//equals priority of ng-src
		template: "<div class=img-x><div ng-if=!small>游伴伴</div><ion-spinner ng-if=small></ion-spinner></div>",
		replace: true,
		scope: true,
		link: function (scope, element, attr) {
			attr.$observe('src', function (value) {
				if (!value)
					return;
				scope.small = element.width() < 60;
				if (value.indexOf("file://") == 0)
					var prefix = "";
				else if (value.indexOf("http://") == 0 || value.indexOf("https://") == 0)
					var prefix = "";
				else if (value.indexOf("img/") == 0)
					var prefix = "";
				else
					var prefix = isEncrypted(value) ?
						environment.imagePrefixEncrypted + '/' :
						attr.size ?
							environment.host + "/imgs/zoom/" + zoomService(value, attr.size) :
							environment.imagePrefix;
				element.css('background-color', color);
				if (prefix)
					background(prefix + value);
				else
					if (value.indexOf("file://") == 0 && attr.localSize)
						photoService.getDimension(value)
							.then(function (size) {
								photoService.compressThumbnail([value])
									.then(function (urls) {
										element.css('background-image', 'url(' + urls[0] + ')');
									});
							});
					else
						element.css('background-image', 'url(' + value + ')');
			});
			var color = imgloading.nextColor();
			var downloading={};
			function background(value) {
				if (isEncrypted(value)) {
					element.css('background-image', 'url(' + value + ')');
					return;
				}
				if (window.app)
					imgcache.get(value).then(function (url) {
						if (url)
							element.css('background-image', 'url(' + url + ')');
						else if (value in downloading)
							downloading[value]
								.then(function (file) {
									element.removeClass('loading');
									element.css('background-image', 'url(' + file.toURL() + ')');
								});
						else {
							element.addClass('loading');
							(downloading[value]=imgcache.download(value))
								.then(function (file) {
									delete downloading[value];
									element.removeClass('loading');
									element.css('background-image', 'url(' + file.toURL() + ')');
								});
						}
					});
				else {
					element.addClass('loading');
					setTimeout(function () {
						element.removeClass('loading');
						element.css('background-image', 'url(' + value + ')');
					}, 1000);
				}
			}
		}
	};
	function isEncrypted(url) {
		url = url.substr(url.lastIndexOf(".") + 1);
		var array = ['png', 'jpg', 'jpeg', 'gif'];
		return !array.includes(url.toLowerCase());
	}
});

angular.module('starter.directives')
.directive('ngClickCloak', function ($parse) {
	return {
		restrict: 'A',
		compile: function (element, attrs) {
			var fn = $parse(attrs.ngClickCloak);
			return function (scope, element, attrs) {
				element[0].addEventListener('click', function (event) {
					if (!attrs.ngClickCloakIf || !scope.$eval(attrs.ngClickCloakIf)) return;
					scope.$apply(function () {
						fn(scope, {
							$event: event
						});
					});
					event.stopPropagation();
					event.stopImmediatePropagation();
				}, true);
			};
		}
	}
});
angular.module('starter.directives')
.directive('actionButton', function ($rest, $ionicLoading, $rootScope,$ionicPopup,loginService) {
	var actions = {
		love: 'loving',
		collect: 'collecting'
	};
	return {
		restrict: 'A',
		scope: {
			actionModel: '='
		},
		link: function (scope, element, attr) {
			element.on('click', function () {
				if (attr.disabled) return;
				if (!scope.actionModel.stats) return;
				if (localStorage['userType'] == 1) {
					$rootScope.NotLoggedIn();
				} else {
					if (localStorage.soundEnabled == 'true')
						Sound.click.play();
					var a = attr.actionButton.split('/');
					var type = a[1];
					var id = a[2];
					var action = a[3];
					$ionicLoading.show({ template: "<ion-spinner/>" });
					var method = scope.actionModel.stats[actions[action]] ? 'delete' : 'put';
					$rest[method](type, id, action)
						.then(function (response) {
							$ionicLoading.hide();
							var stats = scope.actionModel.stats;
							stats[actions[action]] = !stats[actions[action]];
							stats[action + 's'] += stats[actions[action]] ? 1 : -1;
              $rootScope.$broadcast(stats[actions[action]] ? action : 'un'+action, scope.actionModel);
              if (stats[actions[action]])
              	if (localStorage.soundEnabled == 'true')
              		Sound.succeed.play();
            }, function () {
							$ionicLoading.show({ template: "请求失败", duration: 2000 });
						});
				}
			});
		}
	};
});

angular.module('starter.directives')
.directive('shareButton', function (shareService,$rootScope) {
	return {
		restrict: 'A',
		scope: {
			shareModel: '=',
			shareType: '@'
		},
    controller: function($scope, $ionicModal, $ionicLoading,$stateParams, shareService ,$http,$ionicPopup){
      $ionicModal.fromTemplateUrl('templates/social-share.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function (modal) {
        $scope.modal = modal;
      });
      $scope.openModal = function () {
      	$scope.modal.show();
      };
      $scope.closeModal = function () {
        $scope.modal.hide();
      };
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      $scope.shareTo = function(dst, scene){
      	shareService.shareTo(dst, $scope.shareModel, scene)
			.then(function (destination) {
				if(!window.app) return;
				if ($scope.shareModel.id.indexOf('mood')==0) {
					$http({
						method: 'POST',
						url: '/youbanban/mood/'+$stateParams.id+'/share/' + destination
					}).success(function(response){
						$scope.shareModel.stats.shares++;
						$ionicLoading.show({ template: '分享成功', duration: 2000 });
						$scope.modal.hide();
						$rootScope.$broadcast('content.share')
					});
				} else{
					$http({
						method: 'POST',
						url: '/youbanban/poi/'+$stateParams.id+'/share/' + destination
					}).success(function(response){
						$scope.shareModel.stats.shares++;
						$ionicLoading.show({ template: '分享成功', duration: 2000 });
						$scope.modal.hide();
						$rootScope.$broadcast('content.share')
					});
				}
			}, function (reason) {
				if (!(reason.includes('cancel') || reason.includes('取消')))
					$ionicLoading.show({ template: '分享失败：' + reason, duration: 2000 });
				$scope.modal.hide();
			});
      }
    },
		link: function (scope, element, attr) {
			scope.isWebApp = !window.app;
			element.on('click', function () {
				if (attr.disabled) return;
				//shareService[scope.shareType](scope.shareModel);
				scope.openModal();
			});
		}
	};
});

angular.module('starter.directives')
.directive('commentBar', function ($rest,$rootScope) {
	return {
		restrict: 'E',
		scope: {
			ngModel: '='
		},
		controller: function ($scope, $ionicLoading,$request,$ionicPopup) {
			$scope.submit = function () {
				if(localStorage['userType'] == 1) {
					$rootScope.NotLoggedIn();
				} else {
					var id = $scope.ngModel.id;
					var type = id.substr(0, id.indexOf('.'));
					$ionicLoading.show({ template: "<ion-spinner/>" });
					$request.get("user", localStorage.user).then(function (data) {
						$scope.user = data;
					}).then(function(){
						$rest.post(type, id, 'comment', {
							content: $scope.content.replace(/<div>/g, '\n').replace(/<\/div>/g, '').replace(/<br>/g, ''),
						}).then(function (response) {
							$ionicLoading.show({ template: "评论成功", duration: 2000 });
							if($scope.ngModel.comment)
								$scope.ngModel.comment.unshift({
									user:$scope.user,
									content: $scope.content.replace(/<div>/g, '\n').replace(/<\/div>/g, '').replace(/<br>/g, ''),
									createdTime: new Date(),
									stats:{loves:0},
									id:response.data
								})
							$scope.content = "";
							$(".comment-bar .textarea").blur();
						}, function (response) {
							if (response.status == 403) {
								$ionicLoading.show({template: response.data.message, duration: 2000});
							} else {
								$ionicLoading.show({template: "评论失败", duration: 2000});
							}
						});
					})
				}
			};
			$scope.noContent = function () {
				$ionicLoading.show({ template: "您还未写下评论哦" , duration:2000 });
			}
			$scope.clear = function () {
				$scope.content = '';
			}
		},
		templateUrl: 'templates/comment-bar.html',
		replace: true
	};
})

angular.module('starter.directives')
.directive('paging', function ($rest) {
	var pageSize = 20;
	return {
		restrict: 'A',
		scope: {
			ngModel: '='
		},
		controller: function ($scope, $attrs) {
			var $this = this;
			this.page = function (direction) {
				this.paging = direction;
				var number = $scope.ngModel[$scope.field].number;
				direction == 'up' ? number-- : number++;
				$rest.get(
					$scope.type, $scope.id, $scope.relation,
					$scope.subtype,
					number, $attrs.pageSize || pageSize
				).then(function (response) {
					$scope.ngModel[$scope.field] = response.data;
					$this.paging = null;
				});
			};
			this.scope = $scope;
			this.paging;
		},
		compile: function (tElement, tAttrs, tTransclude) {
			tElement.prepend($("<pager direction=up></pager>"));
			tElement.append($("<pager direction=down></pager>"));
			tElement.prepend($("<div name=spinner style=display:flex;justify-content:center;><ion-spinner></ion-spinner></div>").addClass('ng-hide'));
			tElement.prepend($("<div name=empty style=display:flex;justify-content:center;color:lightgray;>没有数据可以显示</div>").addClass('ng-hide'));
			tElement.prepend($("<div name=error style=display:flex;justify-content:center;color:lightgray;>请求错误</div>").addClass('ng-hide'));

			return function (scope, element, attrs) {
				attrs.$observe('paging', function (value) {
					if (!value)
						return;
					var a = attrs.paging.split('/');
					if (a.length >= 4) {
						var type = a[1];
						var id = a[2];
						var relation = attrs.paging.substr(type.length + id.length + 3);
					} else {
						var type, id;
						var relation = a[1];
					}
					var field = attrs.ngField;
					var subtype = attrs.ngType || $rest.type[type][relation];
					var spinner = $(element[0]).children('*[name="spinner"]');
					spinner.removeClass('ng-hide');
					var empty = $(element[0]).children('*[name="empty"]');
					empty.addClass('ng-hide');
					var error = $(element[0]).children('*[name="error"]');
					error.addClass('ng-hide');
					$rest.get(type, id, relation, subtype, 0, attrs.pageSize || pageSize).then(function (response) {
						spinner.addClass('ng-hide');
						scope.ngModel[field] = response.data;
						if (!response.data.totalPages)
							empty.removeClass('ng-hide');
					}, function (e) {
						spinner.addClass('ng-hide');
						error.removeClass('ng-hide');
					});
					scope.type = type;
					scope.id = id;
					scope.relation = relation;
					scope.field = field;
					scope.subtype = subtype;
				});
				//workaround: 处理往空的列表里添加东西的情况，比如用户添加评论
				scope.$watch(function () {
					return scope.field in scope.ngModel ?
						scope.ngModel[scope.field].content.length :
						NaN;
				}, function (value) {
					if (!value) return;
					$(element[0]).children('*[name="empty"]').addClass('ng-hide');
				});
			};
		}
	}
})
.directive('pager', function () {
	return {
		require: '^paging',
		restrict: 'E',
		scope: {
			direction: '@'
		},
		templateUrl: "templates/pager.html",
		replace: true,
		link: function (scope, element, attrs, paging) {
			scope.paging = paging;
			scope.page = function () {
				paging.page(scope.direction);
			};
			scope.isFirst = function () {
				return paging.scope.ngModel[paging.scope.field].number == 0;
			};
			scope.isLast = function () {
				var page = paging.scope.ngModel[paging.scope.field];
				return page.number + 1 >= page.totalPages;
			};
			scope.comment = function () {
				var ngModel = paging.scope.ngModel;
				return ngModel ? ngModel[paging.scope.field] : undefined;
			};
		}
	}
});
angular.module('starter.directives')
.directive('more', function ($http, $rest) {
	var pageSize = 10;
	return {
		restrict: 'E',
		scope: {
			ngModel: '=',
			page: '=?',
			totalPages: '=?',
			controller: '=?'
		},
		controller: function ($scope) {
			$scope.more = function () {
				$scope.page++;
			};
		},
		templateUrl: "templates/more.html",
		link: function (scope, element, attr) {
			attr.$observe('url', function (value) {
				if (!value) return;
				scope.page = 0;
				scope.totalPages = undefined;
				scope.ngModel = [];
				load(0);
			});
			scope.$watch('page', function (value) {
				if (value == undefined) return;
				if (scope.loading) return;
				load(value);
			});
			scope.load = load;
			scope.controller = {
				refresh: function () {
					scope.page = 0;
					scope.totalPages = undefined;
					scope.ngModel = [];
					load(0);
				}
			};
			function load(page) {
				scope.error = undefined;
				scope.loading = true;
				$http.get("/youbanban" + attr.url, {
					params: {
						page: page,
						size: pageSize
					}
				})
				.then(
					attr.type == undefined ?
						$rest.join.any() :
						$rest.join(attr.type)
				)
				.then(
					attr.type == undefined ?
						$rest.embeds('user', 'userId', 'user') :
						angular.identity
				)
				.then(function (response) {
					scope.loading = false;
					scope.$emit('load', response);
					scope.totalPages = response.data.totalPages;
					var content = response.data.content;
					for (var i in content)
						scope.ngModel.push(content[i]);
				})
				.catch(function(e){
					scope.loading = false;
					scope.error = e;
				});
			}
		}
	}
})

angular.module('starter.directives')
.directive('more.external', function ($http, $rest) {
	var pageSize = 10;
	return {
		restrict: 'E',
		scope: {
			ngModel: '=',
			page: '=?',
			totalPages: '=?'
		},
		controller: function ($scope) {
			$scope.more = function () {
				$scope.page++;
			};
		},
		templateUrl: "templates/more.html",
		link: function (scope, element, attr) {
			attr.$observe('url', function (value) {
				if (!value) return;
				scope.page = 0;
				scope.totalPages = undefined;
				scope.ngModel = [];
				scope.$watch('page', function (value) {
					scope.loading = true;
					$http.get('/oyoubanban' + attr.url, {
						params: {
							page: value,
							size: pageSize
						}
					})
					.then(function (response) {
						var response0 = response;
						var ids = response.data.content;
						ids = ids.map(function (v) {
							return encodeURIComponent(v);
						});
						return $http.get('/oyoubanban/es/a?query=' + JSON.stringify(ids))
							.then(function (response) {
								for(var k in response0.data.content) {
									response0.data.content[k] = response.data[response0.data.content[k]];
								}
								return response0;
							});
					})
					.then(function (response) {
						var response0 = response;
						var ids = [];
						for( var k in response.data.content) {
							ids.push(encodeURIComponent(response.data.content[k].userId));
						}
						$http.get('/oyoubanban/es/u?query=' + JSON.stringify(ids))
							.then(function (response) {
								for (var i in response0.data.content)
									response0.data.content[i].user = response.data[response0.data.content[i].userId];
							});
						return response0;
					})
					.then(function (response) {
						scope.loading = false;
						scope.$emit('load', response);
						scope.totalPages = response.data.totalPages;
						var content = response.data.content;
						for (var i in content)
							scope.ngModel.push(content[i]);
					})
					.catch(function(e){
						scope.loading = false;
						scope.error = e;
					});
				});
			});
		}
	}
})

angular.module('starter.directives')
.directive('xxBindHtml', function ($compile) {
	return {
		restrict: 'A',
		replace: true,
		link: function (scope, element, attrs) {
			scope.$watch(attrs.xxBindHtml, function (html) {
				if (html == undefined) return;
				element[0].innerHTML = html;
				$compile(element.contents())(scope);
			});
		}
	};
});
angular.module('starter.directives')
.directive('mediaProgress', function () {
	return {
		restrict: 'E',
		scope: {
			ngModel: '='
		},
		templateUrl: 'templates/media-progress.html',
		replace: true,
    link:function(scope,element){
      element.on('click' , function($event){
        var clickX = $event.clientX;
        var clickObj = $event.target;
        var left;
        var scale;
        if(clickObj.offsetLeft == 0) clickObj = $event.target.offsetParent;
        left = clickX - clickObj.offsetLeft;
        scale = left / clickObj.offsetWidth;
        scope.$emit('seek' , scale);
    });
      scope.ondrag = function ($event) {
      	scope.dragging = ($event.gesture.touches[0].clientX - element[0].offsetLeft) / element[0].offsetWidth;
      	if (scope.dragging < 0)
      		scope.dragging = 0;
      	if (scope.dragging > 1)
      		scope.dragging = 1;
      };
      scope.ondragend = function ($event) {
      	scope.$emit('seek', scope.dragging);
      	scope.dragging = undefined;
      };
      scope.$watch('ngModel', function (ngModel) {
      	scope.currentTime = ngModel.currentTime;
		  ngModel.addEventListener('timeupdate', function () {
      		scope.currentTime = ngModel.currentTime;
      		scope.$apply();
		  }.throttle(100));
		  ngModel.addEventListener('ended', function () {
      		scope.ngModel.stopped = true;
      		scope.ngModel.playing = false;
      		scope.$apply();
		  });
      });
    }
	};
})

angular.module('starter.directives')
.directive('mediaControl', function () {
	return {
		restrict: 'E',
		scope: {
			ngModel: '='
		},
		templateUrl: 'templates/media-control.html',
		replace: true,
		controller: function ($scope, $rootScope, speechService) {
			$scope.$on('togglePlay', function () { });
			$scope.togglePlay = function (poi) {
				if (!window.app && ionic.Platform.isWebView()) {
					$rootScope.requireApp();
					return;
				}
				if ($rootScope.speech.poi && $rootScope.speech.poi.id == poi.id)
					speechService.toggle();
				else
					speechService.play(poi);
			};
			$scope.stop = function () {
				$rootScope.speech.audio.pause();
				$rootScope.speech.audio.stopped = true;
				$rootScope.speech.poi = null;
			};
			$scope.$on('seek', function (event, data) {
				$rootScope.speech.audio.currentTime = data * $rootScope.speech.audio.duration;
			});
		}
	};
})

angular.module('starter.directives')
  .directive('drag' , function(){
    return{
      restrict : 'A',
      link : function(scope, element, attr){
        var oW , oH , timer , timer_hide , flag;
        element.on('touchstart', function (e) {
          flag = true;
          clearTimeout(timer_hide);
          var touch = e.touches[0];
          oW = touch.pageX - element[0].offsetLeft;
          oH = touch.pageY - element[0].offsetTop;
          timer = setTimeout(function(){
              element.css('display' , 'none');
          } , 1000);
        });
        element.on('touchmove', function (e) {
          flag = false;
          clearTimeout(timer);
          var touch = e.touches[0];
          var oLeft = touch.pageX - oW;
          var oTop = touch.pageY - oH;
          if(oLeft <= 0){
            oLeft = 0;
          }else if(oLeft > document.documentElement.clientWidth - element[0].offsetWidth){
            oLeft = document.documentElement.clientWidth - element[0].offsetWidth;
          }
          if(oTop <= 0){
            oTop = 0;
          }else if(oTop > document.documentElement.clientHeight - element[0].offsetHeight){
            oTop = document.documentElement.clientHeight - element[0].offsetHeight;
          }
          element[0].style.left = oLeft + 'px';
          element[0].style.top = oTop + 'px';
        });
        element.on('touchend', function () {
          clearTimeout(timer);
          var left = element[0].offsetLeft + element[0].offsetWidth/2;
          var dis = (left >= document.documentElement.clientWidth/2) ? (document.documentElement.clientWidth - element[0].offsetWidth) + 'px' : 0 + 'px';
          var dis2 = (left >= document.documentElement.clientWidth / 2) ? (document.documentElement.clientWidth - element[0].offsetWidth*0.3) + 'px' : (-element[0].offsetWidth*0.7) + 'px';
          if (!flag || element[0].offsetLeft == 0 || element[0].offsetLeft == document.documentElement.clientWidth - element[0].offsetWidth) {
              $(element[0]).animate({ left: dis }, 400, function () {
                  timer_hide = setTimeout(function () {
                      $(element[0]).animate({ left: dis2 }, 400);
                  }, 2000);
              });
          }
        });
      }
    }
  });

angular.module('starter.directives')
	.directive('elastic', function ($ionicGesture) {
		return {
			link: function (scope, element) {
				element.css('position', 'relative');
				var x = 0;
				var x0 = 120;
				$ionicGesture.on('drag', function ($event) {
					x = atan($event.gesture.deltaX);
					element.css({ left: x + 'px' });
				}, element);
				$ionicGesture.on('dragend', function ($event) {
					animate();
				}, element);
				function atan(x) {
					var a = x0 / (Math.PI / 2);
					return a * Math.atan(x / a);
				}
				function animate() {
					var x0 = x;
					var beta = .2;
					var omega = .6;
					var t0;
					requestAnimationFrame(function a(timestamp) {
						if (!t0)
							t0 = timestamp;
						var t = (timestamp - t0) / 50;
						if (t > Math.log(x0) / beta) return;
						x = x0 * Math.exp(-beta * t) * Math.cos(omega * t);
						element.css({ left: x + 'px' });
						requestAnimationFrame(a);
					});
				}
			}
		};
	})

angular.module('starter.directives')
.directive('playButton', function () {
	return {
		restrict: 'E',
		controller: function ($scope, $rootScope, speechService) {
			$rootScope.speech = {
				poi: null,
				audio: null
			};
		},
		templateUrl: 'templates/play-button.html',
		replace: true
	};
})
angular.module('starter.directives')
.directive('timeline', function () {
	return {
		scope: {
			ngModel: '=',
			selection: '=?'
		},
		templateUrl: "templates/timeline.html"
	};
});
angular.module('starter.directives')
.directive('progressArc', function () {
	return {
		scope: {
			ngModel: '='
		},
		templateUrl: "templates/progress-arc.html",
		controller: function ($scope) {
			$scope.Math = Math;
		}
	};
});
angular.module('starter.directives')
.directive('progressBar', function () {
	return {
		templateUrl: "templates/progress-bar.html"
	};
});

angular.module('starter.directives')
	.directive('bmap', function ($position, $ionicPopup, $ionicLoading) {
		return {
			template: "<div></div>",
			scope: {
				map: '=',
				marker: '=',
				city: '='
			},
			link: function (scope, element) {
				if (!BMap) {
					$ionicPopup.alert({template:"百度地图还没有加载,请稍候再试。"});
					return;
				}

				var map = new BMap.Map(element[0]);
				scope.map = map;

				$ionicLoading.show({ template: "<ion-spinner></ion-spinner>正在获取你的位置" });
				$position().then(function (position) {
					$ionicLoading.hide();
					map.centerAndZoom(new BMap.Point(position.longitude, position.latitude), 16);
				}, function () {
					$ionicLoading.show({ template: "没有获取到你的位置，请自己移动地图。", duration: 4000 });
					map.centerAndZoom('上海', 16);
				}).then(function () {
					var marker = new BMap.Marker(map.getCenter(), { enableDragging: true });
					map.addOverlay(marker);
					scope.marker = marker;
					map.addEventListener('click', function (event) {
						marker.setPosition(event.point);
					});
					geocode();
				});

				var geocoder = new BMap.Geocoder();
				map.addEventListener('moveend', geocode);
				function geocode() {
					geocoder.getLocation(map.getCenter(), function (result) {
						scope.city = result.addressComponents.city;
						scope.$apply();
					});
				}
			}
		};
	})

angular.module('starter.directives')
.directive('vericode', function ($interval) {
	return {
		restrict: 'A',
		templateUrl: "templates/vericode.html",
		replace: true,
		scope: {
			ngDisabled: '=?',
			counting: '=?',
			controller: '=?'
		},
		link: function (scope, element, attr) {
			scope.controller = {
				count: count
			};
			function count() {
				scope.counting = true;
				timePromise = $interval(function () {
					second--;
					if (second <= 0) {
						$interval.cancel(timePromise);
						timePromise = undefined;
						second = 60;
						i++;
						scope.counting = false;
					}
				}, 1000);
			}
			scope.counting = false;
			var i = 0;
			var second = 60, timePromise;
			Object.defineProperty(scope, 'second', {
				get: function () { return second; }
			});
			Object.defineProperty(scope, 'i', {
				get: function () { return i; }
			});
			scope.$on('$destroy', function () {
				if (timePromise)
					$interval.cancel(timePromise);
			});
		}
	};
});

angular.module('starter.directives')
.directive('uiScall', function ($state) {
	return {
		restrict: 'A',
		link: function (scope, element, attrs) {
			element[0].addEventListener('click', function () {
				$state.call(attrs.uiScall);
			});
		}
	}
});
angular.module('starter.directives')
.directive('singleline', function () {
	return {
		restrict: 'A',
		link: function (scope, element, attr) {
			var speaking;
			element.on('keydown', function (event) {
				if (event.keyCode == 13)
					event.preventDefault();
			});
		}
	};
});

angular.module('starter.directives')
.directive('copyButton', function ($ionicPopup, $ionicModal) {
	return {
		restrict: 'A',
		link: function (scope, element, attr) {
			element.on('click', function () {
				if (!window.app && ionic.Platform.isWebView()) {
					return $ionicModal.fromTemplateUrl('templates/external.html', {
						scope: scope,
						animation: 'slide-in-up'
					}).then(function (modal) {
						scope.externalmodal = modal;
						modal.wait();
					});
				}
				cordova.plugins.clipboard.copy(scope.$eval(attr.copyButton));
				$ionicPopup.alert({ template: "已复制到剪贴板" });
			});
		}
	};
});

angular.module('starter.directives')
.directive('speakButton', function ($parse, $ionicPopup, $speak, Speech) {
	return {
		restrict: 'A',
		link: function (scope, element, attr) {
			var speech;
			scope.$watchGroup([attr.speakButton, attr.language], function (value) {
				var text = value[0], language = value[1];
				speech = new Speech(text, language);
			});
			element.on('click', function () {
				$speak(speech);
			});
		}
	};
});

angular.module('starter.directives')
.directive('clickSound', function () {
	return {
		restrict: 'A',
		link: function (scope, element, attr) {
			element.on('click', function () {
				if (localStorage.soundEnabled == 'true')
					Sound.click.play();
			});
		}
	};
});

angular.module('starter.directives')
.directive('elementRef', function ($parse) {
	return {
		restrict: 'A',
		link: function (scope, element, attr) {
			$parse(attr.elementRef).assign(scope, element);
		}
	};
});

angular.module('starter.directives')
.directive('fullscreenTextButton', function ($ionicModal) {
	return {
		restrict: 'A',
		link: function (scope, element, attr) {
			element.on('click', function () {
				var s = scope.$new();
				s.text = scope.$eval(attr.fullscreenTextButton);
				$ionicModal.fromTemplateUrl('templates/translate-fullscreen.html', {
					scope: s,
					animation: 'slide-in-up'
				}).then(function (modal) {
					modal.wait();
				});
			});
		}
	};
});

angular.module('starter.directives')
.directive('selectLanguage', function ($ionicModal, $rootScope) {
	return {
		templateUrl: "templates/select-language.html",
		replace: true,
		scope: {
			ngModel: '='
		},
		link: function (scope, element, attr) {
			scope.select = function () {
				var s = $rootScope.$new();
				s.current = scope.ngModel;
				$ionicModal.fromTemplateUrl('templates/language.html', {
					scope: s,
					animation: 'slide-in-up'
				}).then(function (modal) {
					modal.wait().then(function (value) {
						scope.ngModel = value;
					});
				});
			};
		}
	};
});

angular.module('starter.directives')
.directive('selectLanguagePair', function () {
	return {
		templateUrl: "templates/select-language-pair.html",
		scope: {
			source: '=',
			destination: '='
		},
		link: function (scope, element, attr) {
			scope.swap = function () {
				var t = scope.source;
				scope.source = scope.destination;
				scope.destination = t;
			};
		}
	};
});

angular.module('starter.directives')
	.directive('volumn', function () {
		return {
			templateUrl: "templates/volumn.html",
			scope: {
				amplitude: '='
			},
			link: function (scope) {
				scope.$watch('amplitude', function (value) {
					scope.db = Math.log2(value / 300) / 15 * 100;
				});
			}
		};
	});


angular.module('starter.directives')
	.directive('bottomNav', function ($interval, $state, geobrowseService) {
		var enable = true;	//控制动画效果结束才能开启下一次动画
		var closeBottom;	//控制关闭定时器
		var buttonSwitch = false;	//切换牛助理按钮功
		return {
			restrict: 'E',
			templateUrl: 'templates/bottom-nav.html',
			controller: function ($scope, $element) {
				$scope.move = function () {
					if (!enable) return false;
					if (!buttonSwitch) {
						open();
					} else {
						clearTimeout(closeBottom);
						close();
					}
				};

				function bottomSpread(e) {
					e.stopPropagation();
					$element.find('.move').css({
						"transition": "all .2s linear",
						"-webkit-transition": "all .2s linear",
						"width": "100vw"
					}).on('transitionend', showButtons)
				}
				function showButtons(e) {
					e.stopPropagation();
					$element.find('.move').children().css('display', 'block');
					buttonSwitch = true;
					enable = true;
					if (buttonSwitch) {
						closeBottom = setTimeout(close, 2000);
					}
				}
				function bottomClose() {
					$element.find('.move').children().css('display', 'none');
					$element.find('.move').css({
						"transition": "none",
						"width": "1px"
					});
					buttonSwitch = false;
					enable = true;
				}

				function open() {
					enable = false;
					$element.children('.bottom-animation').off('transitionend', bottomClose).css('top', '-50px').on('transitionend', bottomSpread);

				}

				function close() {
					enable = false;
					clearTimeout(closeBottom);
					$element.find('.move').off('transitionend', showButtons);
					$element.children('.bottom-animation').off('transitionend', bottomSpread).css('top', '0');
					setTimeout(bottomClose, 300);
				}


				$scope.toTranslate = function () {
					clearTimeout(closeBottom);
					$state.call('app.translate').then(function (reason) {
					}, function () {
						back();
					});
				};

				function back() {
					closeBottom = setTimeout(close, 2000)
				}

				//todo: modify to work with introducing #/app/geobrowse
				$scope.toAr = function () {
					clearTimeout(closeBottom);
					if (!window.app && ionic.Platform.isWebView()) {
						$scope.requireApp();
					} else {
						$state.call('app.geobrowse').catch(function () {
							back();
						})
					}
				};

				$scope.toScan = function () {
					clearTimeout(closeBottom);
					if (!window.app && ionic.Platform.isWebView()) {
						$scope.requireApp();
					} else {
						geobrowseService.openScan(back);
					}
				};

				//temporary workaround: prevent duplicate click
				$scope.toAr = $scope.toAr.throttle(1000);
				$scope.toScan = $scope.toScan.throttle(1000);
			}
		};
	})
	.run(function ($state, $rootScope) {
		$rootScope.$on('$ionicView.enter', function () {
			var index = {
				"app.home": 0,
				"app.map": 1,
				"app.moods": 3,
				"app.user": 4
			}[$state.current.name];
			if (index != undefined) {
				$("#bottom-nav").show();
				$("#bottom-nav a").eq(index).addClass("active").siblings().removeClass('active');
				$("#bottom-nav a").find('i').removeClass("active").eq(index).addClass("active");
				setTimeout(function () {
					$("ion-nav-view[name=\"menuContent\"]>ion-view[nav-view='active'] ion-content").css('bottom', '49px');
				}, 50);
			} else {
				$("#bottom-nav").hide();
			}
		});
	})

angular.module('starter.directives')
	.directive('checkLogin', function () {
			return {
				restrict: 'A',
				link: function (scope, element, attrs) {
					element.on('click', function (e) {
						if (localStorage.userType == 1) {
							scope.NotLoggedIn();
							e.preventDefault();
						}
					})
				}
			}
		}
	)

angular.module('starter.directives')
    .directive('vipBadge', function ($state) {
        return {
            restrict: 'A', 
            templateUrl: "templates/vip-badge.svg",
            replace: true,
            link: function(scope, element){
                element.on('click', function (e) {
                    if (localStorage.userType == 1) {
                        scope.NotLoggedIn();
                        e.preventDefault();
                        return;
                    }
                    $state.go("app.vip");
                });
            }
        };
    });

angular.module('starter.filters')
.filter('distance', function () {
	return function (input) {
		if (isNaN(input)) return '?';
		if (input < 1000)
			return Math.floor(input / 10) * 10;
		if (input < 10000)
			return (input / 1000).toFixed(1) + 'k';
		return Math.floor(input / 1000) + 'k';
	};
})
.filter('distanceToUser', function () {
	return function (input) {
		if (!input) return undefined;
		var position = window.positionService.position;
		if (!position) return NaN;
		return haversine(
			{ lat: input.lat, lng: input.lon },
			{ lat: position.latitude, lng: position.longitude }
		);
	};
})

angular.module('starter.filters')
.filter('byteSize', function () {
	return function (input) {
		if (!input)
			return 0;
		if (input < 1000)
			return "<1K";
		if (input < 1000000)
			return (input / 1000).toFixed(1) + 'K';
		return (input / 1000000).toFixed(1) + 'M';
	};
})

angular.module('starter.filters')
  .filter('floor', function () {
    return function (input) {
      return Math.floor(input)
    };
  })

angular.module('starter.filters')
	.filter('strip', function () {
		return function (value) {
			if(value){
				value = value.replace(/<[^p>][^>]*>/g, '');
				value = value.replace(/&nbsp;/ig, '');
				return value;
			}
		};
	});

angular.module('starter.filters')
	.filter('topic', function () {
		return function (topics) {
			return topics.filter(function (topic) {
				return topic.name != '必知';
			})
		}
	});
