angular.module('starter.directives')
	.directive('bmap', function ($position, $ionicPopup, $ionicLoading) {
		return {
			template: "<div></div>",
			scope: {
				map: '=',
				marker: '=',
				city: '='
			},
			link: function (scope, element) {
				if (!BMap) {
					$ionicPopup.alert({template:"百度地图还没有加载,请稍候再试。"});
					return;
				}

				var map = new BMap.Map(element[0]);
				scope.map = map;

				$ionicLoading.show({ template: "<ion-spinner></ion-spinner>正在获取你的位置" });
				$position().then(function (position) {
					$ionicLoading.hide();
					map.centerAndZoom(new BMap.Point(position.longitude, position.latitude), 16);
				}, function () {
					$ionicLoading.show({ template: "没有获取到你的位置，请自己移动地图。", duration: 4000 });
					map.centerAndZoom('上海', 16);
				}).then(function () {
					var marker = new BMap.Marker(map.getCenter(), { enableDragging: true });
					map.addOverlay(marker);
					scope.marker = marker;
					map.addEventListener('click', function (event) {
						marker.setPosition(event.point);
					});
					geocode();
				});

				var geocoder = new BMap.Geocoder();
				map.addEventListener('moveend', geocode);
				function geocode() {
					geocoder.getLocation(map.getCenter(), function (result) {
						scope.city = result.addressComponents.city;
						scope.$apply();
					});
				}
			}
		};
	})
