angular.module('starter.directives')
	.directive('bottomNav', function ($interval, $state, geobrowseService) {
		var enable = true;	//控制动画效果结束才能开启下一次动画
		var closeBottom;	//控制关闭定时器
		var buttonSwitch = false;	//切换牛助理按钮功
		return {
			restrict: 'E',
			templateUrl: 'templates/bottom-nav.html',
			controller: function ($scope, $element) {
				$scope.move = function () {
					if (!enable) return false;
					if (!buttonSwitch) {
						open();
					} else {
						clearTimeout(closeBottom);
						close();
					}
				};

				function bottomSpread(e) {
					e.stopPropagation();
					$element.find('.move').css({
						"transition": "all .2s linear",
						"-webkit-transition": "all .2s linear",
						"width": "100vw"
					}).on('transitionend', showButtons)
				}
				function showButtons(e) {
					e.stopPropagation();
					$element.find('.move').children().css('display', 'block');
					buttonSwitch = true;
					enable = true;
					if (buttonSwitch) {
						closeBottom = setTimeout(close, 2000);
					}
				}
				function bottomClose() {
					$element.find('.move').children().css('display', 'none');
					$element.find('.move').css({
						"transition": "none",
						"width": "1px"
					});
					buttonSwitch = false;
					enable = true;
				}

				function open() {
					enable = false;
					$element.children('.bottom-animation').off('transitionend', bottomClose).css('top', '-50px').on('transitionend', bottomSpread);

				}

				function close() {
					enable = false;
					clearTimeout(closeBottom);
					$element.find('.move').off('transitionend', showButtons);
					$element.children('.bottom-animation').off('transitionend', bottomSpread).css('top', '0');
					setTimeout(bottomClose, 300);
				}


				$scope.toTranslate = function () {
					clearTimeout(closeBottom);
					$state.call('app.translate').then(function (reason) {
					}, function () {
						back();
					});
				};

				function back() {
					closeBottom = setTimeout(close, 2000)
				}

				//todo: modify to work with introducing #/app/geobrowse
				$scope.toAr = function () {
					clearTimeout(closeBottom);
					if (!window.app && ionic.Platform.isWebView()) {
						$scope.requireApp();
					} else {
						$state.call('app.geobrowse').catch(function () {
							back();
						})
					}
				};

				$scope.toScan = function () {
					clearTimeout(closeBottom);
					if (!window.app && ionic.Platform.isWebView()) {
						$scope.requireApp();
					} else {
						geobrowseService.openScan(back);
					}
				};

				//temporary workaround: prevent duplicate click
				$scope.toAr = $scope.toAr.throttle(1000);
				$scope.toScan = $scope.toScan.throttle(1000);
			}
		};
	})
	.run(function ($state, $rootScope) {
		$rootScope.$on('$ionicView.enter', function () {
			var index = {
				"app.home": 0,
				"app.map": 1,
				"app.moods": 3,
				"app.user": 4
			}[$state.current.name];
			if (index != undefined) {
				$("#bottom-nav").show();
				$("#bottom-nav a").eq(index).addClass("active").siblings().removeClass('active');
				$("#bottom-nav a").find('i').removeClass("active").eq(index).addClass("active");
				setTimeout(function () {
					$("ion-nav-view[name=\"menuContent\"]>ion-view[nav-view='active'] ion-content").css('bottom', '49px');
				}, 50);
			} else {
				$("#bottom-nav").hide();
			}
		});
	})
