angular.module('starter.directives')
.directive('commentBar', function ($rest,$rootScope) {
	return {
		restrict: 'E',
		scope: {
			ngModel: '='
		},
		controller: function ($scope, $ionicLoading,$request,$ionicPopup) {
			$scope.submit = function () {
				if(localStorage['userType'] == 1) {
					$rootScope.NotLoggedIn();
				} else {
					var id = $scope.ngModel.id;
					var type = id.substr(0, id.indexOf('.'));
					$ionicLoading.show({ template: "<ion-spinner/>" });
					$request.get("user", localStorage.user).then(function (data) {
						$scope.user = data;
					}).then(function(){
						$rest.post(type, id, 'comment', {
							content: $scope.content.replace(/<div>/g, '\n').replace(/<\/div>/g, '').replace(/<br>/g, ''),
						}).then(function (response) {
							$ionicLoading.show({ template: "评论成功", duration: 2000 });
							if($scope.ngModel.comment)
								$scope.ngModel.comment.unshift({
									user:$scope.user,
									content: $scope.content.replace(/<div>/g, '\n').replace(/<\/div>/g, '').replace(/<br>/g, ''),
									createdTime: new Date(),
									stats:{loves:0},
									id:response.data
								})
							$scope.content = "";
							$(".comment-bar .textarea").blur();
						}, function (response) {
							if (response.status == 403) {
								$ionicLoading.show({template: response.data.message, duration: 2000});
							} else {
								$ionicLoading.show({template: "评论失败", duration: 2000});
							}
						});
					})
				}
			};
			$scope.noContent = function () {
				$ionicLoading.show({ template: "您还未写下评论哦" , duration:2000 });
			}
			$scope.clear = function () {
				$scope.content = '';
			}
		},
		templateUrl: 'templates/comment-bar.html',
		replace: true
	};
})
