angular.module('starter.directives')
  .directive('drag' , function(){
    return{
      restrict : 'A',
      link : function(scope, element, attr){
        var oW , oH , timer , timer_hide , flag;
        element.on('touchstart', function (e) {
          flag = true;
          clearTimeout(timer_hide);
          var touch = e.touches[0];
          oW = touch.pageX - element[0].offsetLeft;
          oH = touch.pageY - element[0].offsetTop;
          timer = setTimeout(function(){
              element.css('display' , 'none');
          } , 1000);
        });
        element.on('touchmove', function (e) {
          flag = false;
          clearTimeout(timer);
          var touch = e.touches[0];
          var oLeft = touch.pageX - oW;
          var oTop = touch.pageY - oH;
          if(oLeft <= 0){
            oLeft = 0;
          }else if(oLeft > document.documentElement.clientWidth - element[0].offsetWidth){
            oLeft = document.documentElement.clientWidth - element[0].offsetWidth;
          }
          if(oTop <= 0){
            oTop = 0;
          }else if(oTop > document.documentElement.clientHeight - element[0].offsetHeight){
            oTop = document.documentElement.clientHeight - element[0].offsetHeight;
          }
          element[0].style.left = oLeft + 'px';
          element[0].style.top = oTop + 'px';
        });
        element.on('touchend', function () {
          clearTimeout(timer);
          var left = element[0].offsetLeft + element[0].offsetWidth/2;
          var dis = (left >= document.documentElement.clientWidth/2) ? (document.documentElement.clientWidth - element[0].offsetWidth) + 'px' : 0 + 'px';
          var dis2 = (left >= document.documentElement.clientWidth / 2) ? (document.documentElement.clientWidth - element[0].offsetWidth*0.3) + 'px' : (-element[0].offsetWidth*0.7) + 'px';
          if (!flag || element[0].offsetLeft == 0 || element[0].offsetLeft == document.documentElement.clientWidth - element[0].offsetWidth) {
              $(element[0]).animate({ left: dis }, 400, function () {
                  timer_hide = setTimeout(function () {
                      $(element[0]).animate({ left: dis2 }, 400);
                  }, 2000);
              });
          }
        });
      }
    }
  });
