angular.module('starter.directives')
	.directive('elastic', function ($ionicGesture) {
		return {
			link: function (scope, element) {
				element.css('position', 'relative');
				var x = 0;
				var x0 = 120;
				$ionicGesture.on('drag', function ($event) {
					x = atan($event.gesture.deltaX);
					element.css({ left: x + 'px' });
				}, element);
				$ionicGesture.on('dragend', function ($event) {
					animate();
				}, element);
				function atan(x) {
					var a = x0 / (Math.PI / 2);
					return a * Math.atan(x / a);
				}
				function animate() {
					var x0 = x;
					var beta = .2;
					var omega = .6;
					var t0;
					requestAnimationFrame(function a(timestamp) {
						if (!t0)
							t0 = timestamp;
						var t = (timestamp - t0) / 50;
						if (t > Math.log(x0) / beta) return;
						x = x0 * Math.exp(-beta * t) * Math.cos(omega * t);
						element.css({ left: x + 'px' });
						requestAnimationFrame(a);
					});
				}
			}
		};
	})
