angular.module('starter.directives')
.directive('imgX', function (imgcache, zoomService, imgloading, photoService) {
	return {
		restrict: 'E',
		priority: 99,	//equals priority of ng-src
		template: "<div class=img-x><div ng-if=!small>游伴伴</div><ion-spinner ng-if=small></ion-spinner></div>",
		replace: true,
		scope: true,
		link: function (scope, element, attr) {
			attr.$observe('src', function (value) {
				if (!value)
					return;
				scope.small = element.width() < 60;
				if (value.indexOf("file://") == 0)
					var prefix = "";
				else if (value.indexOf("http://") == 0 || value.indexOf("https://") == 0)
					var prefix = "";
				else if (value.indexOf("img/") == 0)
					var prefix = "";
				else
					var prefix = isEncrypted(value) ?
						environment.imagePrefixEncrypted + '/' :
						attr.size ?
							environment.host + "/imgs/zoom/" + zoomService(value, attr.size) :
							environment.imagePrefix;
				element.css('background-color', color);
				if (prefix)
					background(prefix + value);
				else
					if (value.indexOf("file://") == 0 && attr.localSize)
						photoService.getDimension(value)
							.then(function (size) {
								photoService.compressThumbnail([value])
									.then(function (urls) {
										element.css('background-image', 'url(' + urls[0] + ')');
									});
							});
					else
						element.css('background-image', 'url(' + value + ')');
			});
			var color = imgloading.nextColor();
			var downloading={};
			function background(value) {
				if (isEncrypted(value)) {
					element.css('background-image', 'url(' + value + ')');
					return;
				}
				if (window.app)
					imgcache.get(value).then(function (url) {
						if (url)
							element.css('background-image', 'url(' + url + ')');
						else if (value in downloading)
							downloading[value]
								.then(function (file) {
									element.removeClass('loading');
									element.css('background-image', 'url(' + file.toURL() + ')');
								});
						else {
							element.addClass('loading');
							(downloading[value]=imgcache.download(value))
								.then(function (file) {
									delete downloading[value];
									element.removeClass('loading');
									element.css('background-image', 'url(' + file.toURL() + ')');
								});
						}
					});
				else {
					element.addClass('loading');
					setTimeout(function () {
						element.removeClass('loading');
						element.css('background-image', 'url(' + value + ')');
					}, 1000);
				}
			}
		}
	};
	function isEncrypted(url) {
		url = url.substr(url.lastIndexOf(".") + 1);
		var array = ['png', 'jpg', 'jpeg', 'gif'];
		return !array.includes(url.toLowerCase());
	}
});
