angular.module('starter.directives')
.directive('mediaControl', function () {
	return {
		restrict: 'E',
		scope: {
			ngModel: '='
		},
		templateUrl: 'templates/media-control.html',
		replace: true,
		controller: function ($scope, $rootScope, speechService) {
			$scope.$on('togglePlay', function () { });
			$scope.togglePlay = function (poi) {
				if (!window.app && ionic.Platform.isWebView()) {
					$rootScope.requireApp();
					return;
				}
				if ($rootScope.speech.poi && $rootScope.speech.poi.id == poi.id)
					speechService.toggle();
				else
					speechService.play(poi);
			};
			$scope.stop = function () {
				$rootScope.speech.audio.pause();
				$rootScope.speech.audio.stopped = true;
				$rootScope.speech.poi = null;
			};
			$scope.$on('seek', function (event, data) {
				$rootScope.speech.audio.currentTime = data * $rootScope.speech.audio.duration;
			});
		}
	};
})
