angular.module('starter.directives')
.directive('mediaProgress', function () {
	return {
		restrict: 'E',
		scope: {
			ngModel: '='
		},
		templateUrl: 'templates/media-progress.html',
		replace: true,
    link:function(scope,element){
      element.on('click' , function($event){
        var clickX = $event.clientX;
        var clickObj = $event.target;
        var left;
        var scale;
        if(clickObj.offsetLeft == 0) clickObj = $event.target.offsetParent;
        left = clickX - clickObj.offsetLeft;
        scale = left / clickObj.offsetWidth;
        scope.$emit('seek' , scale);
    });
      scope.ondrag = function ($event) {
      	scope.dragging = ($event.gesture.touches[0].clientX - element[0].offsetLeft) / element[0].offsetWidth;
      	if (scope.dragging < 0)
      		scope.dragging = 0;
      	if (scope.dragging > 1)
      		scope.dragging = 1;
      };
      scope.ondragend = function ($event) {
      	scope.$emit('seek', scope.dragging);
      	scope.dragging = undefined;
      };
      scope.$watch('ngModel', function (ngModel) {
      	scope.currentTime = ngModel.currentTime;
		  ngModel.addEventListener('timeupdate', function () {
      		scope.currentTime = ngModel.currentTime;
      		scope.$apply();
		  }.throttle(100));
		  ngModel.addEventListener('ended', function () {
      		scope.ngModel.stopped = true;
      		scope.ngModel.playing = false;
      		scope.$apply();
		  });
      });
    }
	};
})
