angular.module('starter.directives')
.directive('more.external', function ($http, $rest) {
	var pageSize = 10;
	return {
		restrict: 'E',
		scope: {
			ngModel: '=',
			page: '=?',
			totalPages: '=?'
		},
		controller: function ($scope) {
			$scope.more = function () {
				$scope.page++;
			};
		},
		templateUrl: "templates/more.html",
		link: function (scope, element, attr) {
			attr.$observe('url', function (value) {
				if (!value) return;
				scope.page = 0;
				scope.totalPages = undefined;
				scope.ngModel = [];
				scope.$watch('page', function (value) {
					scope.loading = true;
					$http.get('/oyoubanban' + attr.url, {
						params: {
							page: value,
							size: pageSize
						}
					})
					.then(function (response) {
						var response0 = response;
						var ids = response.data.content;
						ids = ids.map(function (v) {
							return encodeURIComponent(v);
						});
						return $http.get('/oyoubanban/es/a?query=' + JSON.stringify(ids))
							.then(function (response) {
								for(var k in response0.data.content) {
									response0.data.content[k] = response.data[response0.data.content[k]];
								}
								return response0;
							});
					})
					.then(function (response) {
						var response0 = response;
						var ids = [];
						for( var k in response.data.content) {
							ids.push(encodeURIComponent(response.data.content[k].userId));
						}
						$http.get('/oyoubanban/es/u?query=' + JSON.stringify(ids))
							.then(function (response) {
								for (var i in response0.data.content)
									response0.data.content[i].user = response.data[response0.data.content[i].userId];
							});
						return response0;
					})
					.then(function (response) {
						scope.loading = false;
						scope.$emit('load', response);
						scope.totalPages = response.data.totalPages;
						var content = response.data.content;
						for (var i in content)
							scope.ngModel.push(content[i]);
					})
					.catch(function(e){
						scope.loading = false;
						scope.error = e;
					});
				});
			});
		}
	}
})
