angular.module('starter.directives')
.directive('more', function ($http, $rest) {
	var pageSize = 10;
	return {
		restrict: 'E',
		scope: {
			ngModel: '=',
			page: '=?',
			totalPages: '=?',
			controller: '=?'
		},
		controller: function ($scope) {
			$scope.more = function () {
				$scope.page++;
			};
		},
		templateUrl: "templates/more.html",
		link: function (scope, element, attr) {
			attr.$observe('url', function (value) {
				if (!value) return;
				scope.page = 0;
				scope.totalPages = undefined;
				scope.ngModel = [];
				load(0);
			});
			scope.$watch('page', function (value) {
				if (value == undefined) return;
				if (scope.loading) return;
				load(value);
			});
			scope.load = load;
			scope.controller = {
				refresh: function () {
					scope.page = 0;
					scope.totalPages = undefined;
					scope.ngModel = [];
					load(0);
				}
			};
			function load(page) {
				scope.error = undefined;
				scope.loading = true;
				$http.get("/youbanban" + attr.url, {
					params: {
						page: page,
						size: pageSize
					}
				})
				.then(
					attr.type == undefined ?
						$rest.join.any() :
						$rest.join(attr.type)
				)
				.then(
					attr.type == undefined ?
						$rest.embeds('user', 'userId', 'user') :
						angular.identity
				)
				.then(function (response) {
					scope.loading = false;
					scope.$emit('load', response);
					scope.totalPages = response.data.totalPages;
					var content = response.data.content;
					for (var i in content)
						scope.ngModel.push(content[i]);
				})
				.catch(function(e){
					scope.loading = false;
					scope.error = e;
				});
			}
		}
	}
})
