angular.module('starter.directives')
.directive('shareButton', function (shareService,$rootScope) {
	return {
		restrict: 'A',
		scope: {
			shareModel: '=',
			shareType: '@'
		},
    controller: function($scope, $ionicModal, $ionicLoading,$stateParams, shareService ,$http,$ionicPopup){
      $ionicModal.fromTemplateUrl('templates/social-share.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function (modal) {
        $scope.modal = modal;
      });
      $scope.openModal = function () {
      	$scope.modal.show();
      };
      $scope.closeModal = function () {
        $scope.modal.hide();
      };
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      $scope.shareTo = function(dst, scene){
      	shareService.shareTo(dst, $scope.shareModel, scene)
			.then(function (destination) {
				if(!window.app) return;
				if ($scope.shareModel.id.indexOf('mood')==0) {
					$http({
						method: 'POST',
						url: '/youbanban/mood/'+$stateParams.id+'/share/' + destination
					}).success(function(response){
						$scope.shareModel.stats.shares++;
						$ionicLoading.show({ template: '分享成功', duration: 2000 });
						$scope.modal.hide();
						$rootScope.$broadcast('content.share')
					});
				} else{
					$http({
						method: 'POST',
						url: '/youbanban/poi/'+$stateParams.id+'/share/' + destination
					}).success(function(response){
						$scope.shareModel.stats.shares++;
						$ionicLoading.show({ template: '分享成功', duration: 2000 });
						$scope.modal.hide();
						$rootScope.$broadcast('content.share')
					});
				}
			}, function (reason) {
				if (!(reason.includes('cancel') || reason.includes('取消')))
					$ionicLoading.show({ template: '分享失败：' + reason, duration: 2000 });
				$scope.modal.hide();
			});
      }
    },
		link: function (scope, element, attr) {
			scope.isWebApp = !window.app;
			element.on('click', function () {
				if (attr.disabled) return;
				//shareService[scope.shareType](scope.shareModel);
				scope.openModal();
			});
		}
	};
});
