angular.module('starter.directives')
.directive('xxBackground', function (imgcache, zoomService, imgloading) {
	return {
		restrict: 'A',
		priority: 99,	//equals priority of ng-src
		link: function (scope, element, attr) {
			attr.$observe('xxBackground', function (value) {
				if (!value) {
					element.css('background-image', 'none');
					return;
				}
				if (value.indexOf("file://") == 0)
					var prefix = "";
				else if (value.indexOf("http://") == 0 || value.indexOf("https://") == 0)
					var prefix = "";
				else if (value.indexOf("img/") == 0)
					var prefix = "";
				else
					var prefix = isEncrypted(value) ?
						environment.imagePrefixEncrypted + '/' :
						attr.size ?
							environment.host + "/imgs/zoom/" + zoomService(value, attr.size) :
							environment.imagePrefix;
				element.css('background-color', color);
				if (prefix)
					background(prefix + value);
				else
					element.css('background-image', 'url(' + value + ')');
			});
			var color = imgloading.nextColor();
			function background(value) {
				if (isEncrypted(value)) {
					element.css('background-image', 'url(' + value + ')');
					return;
				}
				if (window.app)
					imgcache.get(value).then(function (url) {
						if (url)
							element.css('background-image', 'url(' + url + ')');
						else {
							var empty = !element.children().length;
							if (empty) {
								element.addClass('loading');
								element.append(angular.element("<div>游伴伴</div>"));
							}
							imgcache.download(value)
								.then(function (file) {
									if (empty) {
										element.removeClass('loading');
										element.empty();
									}
									element.css('background-image', 'url("' + file.toURL() + '")');
								});
						}
					});
				else if(!element.children().length){
					element.addClass('loading');
					element.append(angular.element("<div>游伴伴</div>"));
					setTimeout(function () {
						element.css('background-image', 'url(' + value + ')');
						element.removeClass('loading');
						element.empty();
					}, 1000);
				} else
					element.css('background-image', 'url(' + value + ')');
			}
		}
	};
	function isEncrypted(url) {
		url = url.substr(url.lastIndexOf(".") + 1);
		var array = ['png', 'jpg', 'jpeg', 'gif'];
		return !array.includes(url.toLowerCase());
	}
});
