angular.module('starter.directives')
.service('zoomService', function () {
	return function (url, size) {
		var name = url.substr(
			url.lastIndexOf('/') + 1
		);
		var i = name.indexOf('_');
		if (i == -1) return 2;
		name = name.substr(0, i);
		var wh = name.split('x');
		var l = Math.min(wh[0], wh[1]);
		switch (size) {
			case 'large':
				return l / 500;
			case 'medium':
				return l / 240;
			case 'small':
				return l / 80;
		}
	}
})
.directive('xxSrc', function (imgcache, zoomService) {
	return {
		restrict: 'A',
		priority: 99,	//equals priority of ng-src
		link: function (scope, element, attr) {
			attr.$observe('xxSrc', function (value) {
				if (!value)
					return;
				if (value.indexOf("file://") == 0)
					var prefix = "";
				else if (value.indexOf("http://") == 0 || value.indexOf("https://") == 0)
					var prefix = "";
				else if (value.indexOf("img/") == 0)
					var prefix = "";
				else
					var prefix = isEncrypted(value) ?
						environment.imagePrefixEncrypted + '/' :
						attr.size ?
							environment.host + "/imgs/zoom/" + zoomService(value, attr.size) :
							environment.imagePrefix;
				if (prefix)
					src(prefix + value);
				else
					attr.$set('src', value);
			});
			function src(value) {
				if (window.app)
					imgcache.get(value).then(function (url) {
						if (url)
							attr.$set('src', url);
						else {
							attr.$set('src', value);
							imgcache.download(value);
						}
					});
				else
					attr.$set('src', value);
			}
		}
	};
	function isEncrypted(url) {
		url = url.substr(url.lastIndexOf(".") + 1);
		var array = ['png', 'jpg', 'jpeg', 'gif'];
		return !array.includes(url.toLowerCase());
	}
});
