angular.module('starter.filters')
.filter('distance', function () {
	return function (input) {
		if (isNaN(input)) return '?';
		if (input < 1000)
			return Math.floor(input / 10) * 10;
		if (input < 10000)
			return (input / 1000).toFixed(1) + 'k';
		return Math.floor(input / 1000) + 'k';
	};
})
.filter('distanceToUser', function () {
	return function (input) {
		if (!input) return undefined;
		var position = window.positionService.position;
		if (!position) return NaN;
		return haversine(
			{ lat: input.lat, lng: input.lon },
			{ lat: position.latitude, lng: position.longitude }
		);
	};
})
