//from https://stackoverflow.com/a/27943/4127811
function haversine(p, q) {
	var lat1 = p.lat, lon1 = p.lng,
		lat2 = q.lat, lon2 = q.lng;
	var R = 6371; // Radius of the earth in km
	var dLat = deg2rad(lat2 - lat1);  // deg2rad below
	var dLon = deg2rad(lon2 - lon1);
	var a =
	  Math.sin(dLat / 2) * Math.sin(dLat / 2) +
	  Math.cos(deg2rad(lat1)) * Math.cos(deg2rad(lat2)) *
	  Math.sin(dLon / 2) * Math.sin(dLon / 2)
	;
	var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
	var d = R * c; // Distance in km
	return d * 1000;
}

function deg2rad(deg) {
	return deg * (Math.PI / 180)
}
