angular.module('starter.services')
	.service('$file', function ($q) {
		return {
			readAsArrayBuffer: function (path) {
				var q = $q.defer();

				window.resolveLocalFileSystemURL(path, function (entry) {
					entry.file(function (file) {
						var reader = new FileReader();
						reader.onloadend = function () {
							if (this.result != null)
								q.resolve(this.result);
							else
								q.reject(this.error);
						};
						reader.readAsArrayBuffer(file);
					});
				}, function (error) {
					q.reject(error);
				});

				return q.promise;
			},
			getSize: function (path) {
				var q = $q.defer();

				window.resolveLocalFileSystemURL(path, function (entry) {
					entry.getMetadata(
						function (metadata) {
							q.resolve(metadata.size);
						},
						function (error) {
							q.reject(error);
						}
					);
				}, function (e) {
					q.reject(e);
				});

				return q.promise;
			},
			getMetadata: function (path) {
				var q = $q.defer();

				window.resolveLocalFileSystemURL(path, function (entry) {
					entry.getMetadata(
						function (metadata) {
							q.resolve(metadata);
						},
						function (error) {
							q.reject(error);
						}
					);
				}, function (e) {
					q.reject(e);
				});

				return q.promise;
			},
			getFiles: function (path) {
				var q = $q.defer();

				window.resolveLocalFileSystemURL(path, function (entry) {
					var reader = entry.createReader();
					reader.readEntries(function (entries) {
						q.resolve(entries);
					}, function (error) {
						q.reject(error);
					});
				});

				return q.promise;
			}
		};
	});
