angular.module('ionic')
.config(function ($provide) {
	$provide.decorator('$ionicLoading', function ($delegate, $rootScope) {
		//inject $ionicLoading.show to show pictures for succeed and fail messages.
		//succeed and fail messages are implicitly specified by message content, so that we do not need to update all existing $ionicLoading.show calls.
		var show = $delegate.show;
		$delegate.show = function (options) {
			if (options.template == '<ion-spinner></ion-spinner>' || options.template == '<ion-spinner/>') {
				angular.element('.loading-container').find('.loading').css('background-color', 'rgba(0, 0, 0, 0)');
			} else {
				angular.element('.loading-container').find('.loading').css('background-color', 'rgba(0, 0, 0, .7)');
			}
			if (options.template.includes("成功"))
				var type = "succeed";
			else if (options.template.includes("失败") || options.template.includes("超时"))
				var type = "fail";
			if (type) {
				options.template = "<div style=text-align:center;>{{icon}}<div>".replace("{{icon}}", "<img src=img/" + type + ".png style=width:8em;>") + options.template;
				options.duration = 2000;
				if (localStorage.soundEnabled == 'true')
					Sound[type].play();
			}
			options.scope = $rootScope.$new();
			return show(options);
		};
		return $delegate;
	})
});
