angular.module('ionic')
.config(function ($provide) {
	$provide.decorator('$ionicModal', function ($delegate, $q, $ionicPlatform, IONIC_BACK_PRIORITY) {
		var ModalView = $delegate.fromTemplate("").constructor;
		ModalView.prototype.wait = function () {
			var $this = this;
			var deferred = $q.defer();
			var $offResolve = this.scope.$on("modal.resolve", function (event, value) {
				$this.hide();
				deferred.resolve(value);
				$offResolve();
				$offReject();
				$offNotify();
				$offShown();
				$offHidden();
				event.stopPropagation();
			});
			var $offReject = this.scope.$on("modal.reject", function (event, value) {
				$this.hide();
				deferred.reject(value);
				$offResolve();
				$offReject();
				$offNotify();
				$offShown();
				$offHidden();
				event.stopPropagation();
			});
			var $offNotify = this.scope.$on("modal.notify", function (event, value) {
				deferred.notify(value);
				event.stopPropagation();
			});
			var $offBackButton;
			var $offShown = this.scope.$on('modal.shown', function (event, modal) {
				if (modal != $this) return;
				$offBackButton = $ionicPlatform.registerBackButtonAction(
				  function () { $this.scope.$emit("modal.reject"); },
				  IONIC_BACK_PRIORITY.modal
				);
			});
			var $offHidden = this.scope.$on('modal.hidden', function (event, modal) {
				if (modal != $this) return;
				$offBackButton();
			});
			this.show();
			return deferred.promise;
		};
		return $delegate;
	})
})
.config(function ($provide) {
	$provide.decorator('$ionicModal', function ($delegate) {
		var ModalView = $delegate.fromTemplate("").constructor;
		var show = ModalView.prototype.show;
		ModalView.prototype.show = function () {
			if (localStorage.soundEnabled == 'true')
				Sound.transit.play();
			return show.call(this);
		};
		return $delegate;
	})
});
