angular.module('starter.services')
.service('$relay', function ($q, $request) {
	var queue = {};
	this.queue = queue;
	var emit = {};
	this.get = function (id) {
		var deferred = $q.defer();
		if (!queue[id]) queue[id] = [];
		queue[id].push(deferred);
		return deferred.promise;
	};
	var $this = this;
	this.query = function (object, schema) {
		var promise = [];
		query(object, schema);
		this.flush();
		return $q.all(promise);
		function query(object, schema) {
			if (angular.isArray(schema)) {
				var schema = schema[0];
				object.map(function (element, i) {
					if (schema === '')
						promise.push($this.get(element).then(setter(object, i)));
					else
						query(element, schema);
				});
			} else if (angular.isObject(schema)) {
				angular.forEach(schema, function (value, key) {
					if (value === '')
						promise.push($this.get(object[key]).then(setter(object, key)));
					else
						query(object[key], value);
				});
			}
		}
	};
	function setter(object, key) {
		return function (value) {
			object[key] = value;
			return value;
		};
	}
	this.flush = function () {
		var ids = [];
		for (var i in queue) {
			emit[i] = queue[i];
			delete queue[i];
			ids.push(i);
		}
		$request.get.s.any(ids)
			.then(function (data) {
				for (var id in data)
					for (var i in emit[id])
						emit[id][i].resolve(data[id]);
			});
	};
});
