angular.module('starter.services')
	.service('$rest', function ($http, $remote, $request) {
		var $this = {
			get: function (type, id, path, post, index, size) {	//post: 'poi'
				if (path == 'fan')
					path = 'fans';
				if (type) {
					var url = "/youbanban/" + type + '/' + id;
					if (path)
						url += '/' + path;
				} else
					url = "/youbanban/" + path;
				var $return = $http.get(url, {
					params: {
						page: index,
						size: size
					}
				});
				if (post) {
					$return = $return.then($this.join(post));
					if (post == 'comment' || post == 'mood')
						$return = $return.then($this.embeds('user', 'userId', 'user'));
				} else
					if (!path)
						if (type == 'comment' || type == 'mood') {
							$return = $return.then($this.embed('user'));
						}
				return $return;
			},
			post: function (type, id, path, body) {	//rest: 'collect'
				var url = "/youbanban/" + type + '/' + id;
				if (path)
					url += '/' + path;
				return $http.post(url, body);
			},
			put: function (type, id, path, body) {	//rest: 'collect'
				var url = "/youbanban/" + type + '/' + id;
				if (path)
					url += '/' + path;
				return $http.put(url, body);
			},
			delete: function (type, id, path) {
				var url = "/youbanban/" + type + '/' + id;
				if (path)
					url += '/' + path;
				return $http.delete(url);
			},
			join: function (type) {
				return function (response) {
					var response0 = response;
					var data = response.data;
					var array =
						data.totalPages != undefined ?
							data.content :
							data;
					return $remote.gets(type, array)
						.then(function (response) {
							for (var i in array)
								array[i] = response.data[array[i]];
							return response0;
						});
				};
			},
			embeds: function (type, source, destination) {
				return function (response) {
					var response0 = response;
					var data = response.data;
					var array =
						data.totalPages != undefined ?
							data.content :
							data;
					var ids = array.map(function (object) { return object[source]; })
					return $remote.gets(type, ids)
						.then(function (response) {
							for (var i in array) {
								var object = array[i];
								object[destination] = response.data[object[source]];
							}
							return response0;
						});
				};
			},
			embed: function (type) {
				return function (response) {
					var response0 = response;
					return $this.get(type, response.data[type + 'Id'])
						.then(function (response) {
							response0.data[type] = response.data;
							return response0;
						});
				}
			},
			getType: function (id) {
				var index = id.indexOf('.');
				var type = id.substring(0, index);
				return type;
			}
		};
		$this.join.any = function () {
			return function (response) {
				var response0 = response;
				var data = response.data;
				var array =
					data.totalPages != undefined ?
						data.content :
						data;
				return $request.get.s.any(array)
					.then(function (response) {
						for (var i in array)
							array[i] = response[array[i]];
						return response0;
					});
			};
		};
		$this.embeds.stats = function () {
			return function (response) {
				var response0 = response;
				var data = response.data;
				var array =
					data.totalPages != undefined ?
						data.content :
						data;
				//embed stats asynchronously and return response immediately
				return $http.get("/youbanban/any/stats", {
					params: {
						query: JSON.stringify(array.map(function (object) { return object.id; }))
					}
				}).then(function (response) {
					for (var i in array) {
						var object = array[i];
						object.stats = response.data[object.id];
					}
					return response0;
				});
			};
		};
		$this.type = {
			poi: {
				comment: 'comment',
				mood: 'mood'
			},
			kn_card: {
				comment: 'comment'
			},
			mood: {
				comment: 'comment'
			}
		}
		return $this;
	});
