angular.module('ionic')
.config(function ($provide) {
	$provide.decorator('$state', function ($delegate, $q, $rootScope, $injector) {
		var stack = [];
		$delegate.call = function (name, params) {
			var $ionicHistory = $injector.get('$ionicHistory');
			var deferred = $q.defer();
			stack.unshift(deferred);
			var view = $ionicHistory.currentView();
			var leave = $rootScope.$on('$ionicView.leave', function () {
				setTimeout(function () {	//hack: ensure $ionicHistory.currentView() is the entering view
				if ($ionicHistory.currentView() == view) {
					leave();
					var deferred = stack.shift();
					($method || deferred.reject).call(deferred, $value);
					$method = undefined;
					deferred.leave();
				}
				}, 0);
			});
			deferred.leave = leave;
			deferred.view = view;
			if ($delegate.get(name).call == 'event') {
				$delegate.go(name).then(function(){
					$rootScope.$broadcast("$state.call", params);
				});
			} else
				$delegate.go(name, params);
			return deferred.promise;
		};
		var $method;
		var $value;
		$delegate.resolve = function (value) {
			var $ionicHistory = $injector.get('$ionicHistory');
			var deferred = stack[0];
			$method = deferred.resolve;
			$value = value;
			$ionicHistory.goBack(deferred.view.index - $ionicHistory.currentView().index);
		};
		$delegate.reject = function (value) {
			var $ionicHistory = $injector.get('$ionicHistory');
			var deferred = stack[0];
			$method = deferred.reject;
			$value = value;
			$ionicHistory.goBack(deferred.view.index - $ionicHistory.currentView().index);
		};
		return $delegate;
	})
});
