angular.module('starter.services')
	.service('Db', function ($db) {
		return function (name, stores) {
			function Db() {
				var $this = this;
				this.promise = $db.open(name, function (e) {
					var db = e.target.result;
					for (var i in stores)
						if (!db.objectStoreNames.contains(stores[i]))
							db.createObjectStore(stores[i]);
				}).then(function (db) {
					$this.db = db;
				});
			}
			Db.prototype.get = function (store, id) {
				return $db.get(this.db, store, id);
			};
			Db.prototype.put = function (store, id, value) {
				return $db.set(this.db, store, id, value);
			};
			Db.prototype.remove = function (store, id) {
				return $db.remove(this.db, store, id);
			};
			Db.prototype.getAll = function (store) {
				return $db.getAll(this.db, store);
			};
			Db.prototype.clear = function (store) {
				return $db.clear(this.db, store);
			};
			Db.prototype.foreach = function (store, f) {
				$db.foreach(this.db, store, f);
			};
			angular.forEach(['get', 'put', 'remove', 'getAll', 'clear', 'foreach'], function (method) {
				var f = Db.prototype[method];
				Db.prototype[method] = function () {
					var $this = this;
					var $arguments = arguments;
					return this.db ?
						f.apply(this, arguments) :
						this.promise.then(function(){
							return f.apply($this, $arguments);
						});
				};
			});
			return Db;
		};
	});
