angular.module('starter.services')
	.service('MediaCache', function ($cordovaFileTransfer, Db, $cordovaFile) {
		return function (name) {
			var db = new (Db(name, ['.']))();
			this.get = get;
			this.download = download;
			this.request = request;
			function get(url) {
				return db.get('.', url)
					.then(function (path) {
						return $cordovaFile.checkFile(path, "")
							.then(function () {
								return path;
							}, function (e) {
								return undefined;
							});
					});
			}
			function download(url) {
				var h = hash();
				return $cordovaFileTransfer.download(
					url,
					cordova.file.cacheDirectory + name + '/' + h,
					undefined,
					true
				).then(function (entry) {
					db.put('.', url, entry.toURL());
					return entry;
				});
			}
			function request(url) {
				return get(url)
					.then(function (path) {
						return path ||
							download(url)
								.then(function (entry) {
									return entry.toURL();
								});
					});
			}
			function hash() {
				return new Date().valueOf() + ',' + Math.random();
			}
		}
	})
	.service('imgcache', function (MediaCache) {
		return new MediaCache('img');
	})
	.service('audiocache', function (MediaCache) {
		return new MediaCache('audio');
	});
