angular.module('starter.services')
	.service('Speech', function ($q, voiceRss) {
		function Speech(text, language) {
			this.text = text;
			this.language = language;
		}
		Speech.prototype.play = function () {
			var $this = this;
			this.deferred = $q.defer();
			delete this.cancelled;
			var audio = this.audio ? $q.resolve(this.audio) :
				this.get().then(Audio)
					.then(function (audio) {
						$this.audio = audio;
						return audio;
					});
			return audio.then(function (audio) {
				if ($this.cancelled) return;
				$this.audio.currentTime = 0;
				$this.audio.play();
				return $this.deferred.promise;
			});
			function Audio(src) {
				var audio = document.createElement('audio');
				audio.src = src;
				audio.addEventListener('ended', function () {
					$this.deferred.resolve();
				});
				return audio;
			};
		};
		Speech.prototype.stop = function () {
			this.cancelled = true;
			if (this.audio)
				this.audio.pause();
			this.deferred.resolve();
		};
		Speech.prototype.get = function () {
			return voiceRss(this.text, this.language);
		};
		return Speech;
	});
