angular.module('starter.services')
	.factory('activity', function ($http, $ionicModal, $rootScope, $rest, $state) {
		var now = new Date().getTime();
		function sortActivityList(list) {
			/*活动列表按重要性，时间排序,需要优先显示的活动排在前面*/
			list.sort(function (a, b) {
				if (a.level == b.level) {
					if (Math.abs(now - a.showStartTime) >= Math.abs(now - b.showStartTime)) {
						return -1;
					} else {
						return 1;
					}
				} else {
					return b.level - a.level;
				}
			});
		}

		function updateActivityList(list) {
			/*更新localStorage的活动列表*/
			var activity = JSON.parse(localStorage.getItem('shownActivity')) || [];
			var ids = list.map(function (activity) {
				return activity.id
			});
			activity = activity.filter(function (a) {
				return ids.includes(a);
			});
			localStorage.setItem('shownActivity', JSON.stringify(activity));
		}

		function chooseActivity(list) {
			/*选出没显示过的活动*/
			var activity = JSON.parse(localStorage.getItem('shownActivity')) || [];
			return list.find(function (v) {
				if (!activity.includes(v.id) && v.showEndTime > now && v.hot) {
					activity.push(v.id);
					localStorage.setItem('shownActivity' , JSON.stringify(activity));
					return v;
				}
			})
		}

		function getActivities() {
			/*批量获取活动详情*/
			return $http.get('/youbanban/event/events')
				.then($rest.join('event'))
		}

		function dealWithCallBack(result) {
			switch (result.name) {
				case 'create-mood':
					$state.call('app.mood-create');
					break;
				case 'bind-weixin':
				case 'finish-user-info':
					$state.call('app.userdata', {id: localStorage.user});
					break;
				case 'exchange':
					$ionicModal.fromTemplateUrl('templates/exchange.html').then(function (modal) {
						modal.wait();
					});
					break;
				case 'go':
					var type = result.argument.indexOf('mood') == 0 ? 'mood' : 'poi';
					$state.go('app.' + type, {id: result.argument});
					break;
			}
		}

		return {
			showActivity: function () {
				//活动页面
				getActivities()
					.then(function (result) {
						sortActivityList(result.data);
						return result.data;
					})
					.then(function (list) {
						updateActivityList(list);
						return list;
					})
					.then(function (list) {
						return chooseActivity(list);
					})
					.then(function (result) {
						if (result) {
							var scope = $rootScope.$new();
							scope.activity = result;
							$ionicModal.fromTemplateUrl('templates/activityPost.html', {
								scope: scope
							}).then(function (modal) {
								modal.wait();
							});
						}
					});
			},
			getActivities: function () {
				return getActivities()
			},
			dealWithCallBack: function (result) {
				return dealWithCallBack(result)
			}
		};
	})
