angular.module('starter.services')
	.service('cacheService', function ($db, $q, $cordovaFile, $file) {
		this.clearCache = function () {
			var storage =
				$db.open('storage')
					.then(function (db) {
						return $q.all([].map.call(db.objectStoreNames, function (store) {
							return $db.clear(db, store);
						}));
					});
			var collection =
				$db.open('collection')
					.then(function (db) {
						return $q.all([].map.call(db.objectStoreNames, function (store) {
							return $db.clear(db, store);
						}));
					});
			var img =
				$db.open('img')
					.then(function (db) {
						return $q.all([].map.call(db.objectStoreNames, function (store) {
							return $db.clear(db, store);
						}));
					});
			var audio =
				$db.open('audio')
					.then(function (db) {
						return $q.all([].map.call(db.objectStoreNames, function (store) {
							return $db.clear(db, store);
						}));
					});
			var removeImg = $cordovaFile.removeRecursively(cordova.file.cacheDirectory, "img")
				.catch(function (e) { if (e.message != 'NOT_FOUND_ERR') throw e; });
			var removeAudio = $cordovaFile.removeRecursively(cordova.file.cacheDirectory, "audio")
				.catch(function (e) { if (e.message != 'NOT_FOUND_ERR') throw e; });
			return $q.all([storage, collection, img, removeImg, audio, removeAudio]);
		};
		this.getSize = getSize;
		this.getDbSize = getDbSize;
		this.getMediaSize = getMediaSize;
		function getSize() {
			return $q.all({
				db: getDbSize('storage'),
				collection: getDbSize('collection'),
				img: getMediaSize('img'),
				audio: getMediaSize('audio')
			}).then(function (size) {
				return size.db + size.collection + size.img + size.audio;
			});
		}
		function getDbSize(name) {
			return $db.open(name)
				.then(function (db) {
					var stores = db.objectStoreNames;
					var sizes = [].map.call(stores, getStoreSize);
					return $q.all(sizes)
						.then(function (sizes) {
							return sizes.reduce(function (a, b) { return a + b; }, 0);
						});
					function getStoreSize(name) {
						return $db.getAll(db, name)
							.then(function (objects) {
								return objects.map(JSON.stringify)
									.map(function (s) { return s.length; })
									.reduce(function (a, b) { return a + b; }, 0);
							});
					}
				});
		}
		function getMediaSize(name) {
			return $cordovaFile.checkDir(cordova.file.cacheDirectory, name)
				.then(function (x) {
					return x;
				}, function (e) {
					return $cordovaFile.createDir(cordova.file.cacheDirectory, name, false);
				}).then(function (entry) {
					return $file.getFiles(entry.toURL());
				}).then(function (entries) {
					return $q.all(entries.map(function (entry) {
						return $file.getSize(entry.toURL());
					})).then(function (sizes) {
						return sizes.reduce(function (a, b) { return a + b; }, 0);
					});
				});
		}
	});
