angular.module('starter.services')
	.service('eventNotification', function ($http, $db) {
		var db;
		var promise = $db.open('event-notification', function (e) {
			var db = e.target.result;
			var stores = ['.'];
			for (var i in stores)
				if (!db.objectStoreNames.contains(stores[i]))
					db.createObjectStore(stores[i]);
		}).then(function (_db) {
			db = _db;
		});
		var $this = {
			get: function (id) {
				return $db.get(db, '.', id);
			},
			getAll: function () {
				return $db.getAll(db, '.');
			},
			set: function (id, event) {
				return $db.set(db, '.', id, event);
			},
			remove: function (id) {
				return $db.remove(db, '.', id);
			},
			clear: function () {
				return $db.clear(db, '.');
			}
		};
		angular.forEach(['get', 'getAll', 'set'], function (method) {
			var f = $this[method];
			$this[method] = function () {
				return db ?
					f.apply($this, arguments) :
					promise.then(function () {
						return f.apply($this, arguments);
					});
			};
		});
		return $this;
	});
