angular.module('starter.services')
.service('geobrowseService', function ($rootScope, $q, $http, $relay, $state, $ionicHistory) {
	function open() {
		var config = {
			token: localStorage.token,
			userType: +localStorage.userType,
			baseUrl: environment.host,
			world: "file:///android_asset/www/geobrowse/index.html"
		};
		var ar = cordova.require('cordova-plugin-youbanban-ar.Ar');
		ar.initialize({
			getPoi: function(arg, onsucceed, onerror){
				$http.get("/youbanban/poi/search/ar",{params:arg})
				.then(function(response){
					$relay.query(response.data,[{poiId:'',arItemId:['']}])
						.then(function(){
							var data=response.data;
							data.splice(360);
							for(var i in data){
								data[i].poi=data[i].poiId;
								delete data[i].poiId;
								data[i].arItem=data[i].arItemId[0]||null;
								delete data[i].arItemId;
							}
							onsucceed(response.data);
						},onerror);
				},onerror);
			}
		}, {
			goto: function (arg) {
				console.log(arg);
				$state.call("app.poi", { id: arg });
			},
			back: function () {
				$ionicHistory.goBack();
				setTimeout(function () {
				$this.close();
				}, 1000);
			}
		});
		ar.setOnUrlInvokeCallback({
			takePicture: function (argument, onsucceed, onerror) {
				ar.takePicture(onsucceed, onerror);
			},
			createMood: function (argument, onsucceed, onerror) {
				(localStorage.userType == '1' ?
					$rootScope.requireLogin() :
					$q.resolve()
				).then(function () {
					var url = argument;
					if (url[0] == '/')
						url = "file://" + url;
					$state.call("app.mood-create", { url: url })
						.then(onsucceed, onerror);
				});
			}
		});
		ar.open(function () {
			$this.isOpen = true;
		}, undefined, config);
	}
	function close() {
		var ar = cordova.require('cordova-plugin-youbanban-ar.Ar');
		ar.close();
		$this.isOpen = false;
	}
	function show() {
		var ar = cordova.require('cordova-plugin-youbanban-ar.Ar');
		ar.show();
	}
	function hide() {
		var ar = cordova.require('cordova-plugin-youbanban-ar.Ar');
		ar.hide();
	}
	function openScan(callback) {
		var jsonStr = {
			token: localStorage.token,
			baseUrl: environment.host,
			userType: +localStorage.userType
		};

		setTimeout(function () {
			var scan = cordova.require('cordova-plugin-recognize-image.RecognizeImage');
			scan.open(function (message) {
				if (message.type == 'back') {
					callback();
				}
				else if (/^goto/.test(message.type)) {
					$state.go("app.poi", { id: message.argument });
					callback();
				}
			}, function (message) {
			}, jsonStr);
		}, 0)
	}
	var $this;
	return $this = {
		open: open,
		show: show,
		hide: hide,
		close: close,
		openScan: openScan
	};
})
