angular.module('starter.services')
  .service('loginService', function($http, $window, $rootScope){
    return {
      login: function(argument){
      	if (argument.userType == undefined) argument.userType = 0;
        var url = '/oyoubanban/auth/login'
        return $http.post(url, argument).then(function(response){
          var data = response.data;
          $window.localStorage['user'] = data.userId;
          $window.localStorage['token'] = data.token;
          $window.localStorage['token.expiry'] = data.expiry;
          $window.localStorage['userType'] = argument.userType;
          $rootScope.user = $window.localStorage['user'];
          $rootScope.userType = $window.localStorage['userType'];
          $rootScope.$broadcast('login');
          return data;
        });
      },
      	anonymousLogin: function() {
      		var user = window.app?device.uuid:'857a3ab2fd98abcd',
      			password = Base64.encode(sha256(user));
      		return this.login({
      			user: user,
      			password: password,
      			userType: 1
      		});
      	},
      	sendmsg:function(phone,countryCode){
        var url="/oyoubanban/send_vericode";
        var data={
          user:phone,
          countryCode:countryCode
        };
        return $http.post(url,data);
      },
      checkUserName:function(phone){
          var url = "/oyoubanban/auth/check_user";
          var data = {
              user:phone
          };
          return $http.get(url, {params: data});
      },
      register:function(argument){
        return $http.post("/oyoubanban/auth/register", argument);
      },
      checkVericode:function(argument){
        return $http.post("/oyoubanban/check_vericode", argument);
      },
      update:function(user,password,vericode){
        var url="/oyoubanban/auth/update_password";
        var data={
          user:user,
          password:password,
          vericode:vericode
        };
        return $http.post(url,data);
      },
      logout:function(){
      	$window.localStorage.removeItem('user');
      	$window.localStorage.removeItem('token');
      	$window.localStorage.removeItem('token.expiry');
      	$window.localStorage.removeItem('userType');
      	$rootScope.$broadcast('logout');
      },
	    checkPassword:function(data){
		    var lengthValid = data.length >= 6 && data.length<= 16;
		    var formatValid = /[0-9a-zA-Z~!@#$%^&*()_+{}:"|<>?`\-=[\];'\,./]+$/.test(data);
      	     return  (lengthValid && formatValid)
	    }
    }
  })
