angular.module('starter.services')
	.service('messageService', function ($http, $rest, Db) {
		var db = new (Db('message', ['message', 'notif']))();
		this.db = db;
		this.pull = function () {
			var since = +localStorage['message.time'];
			var now = new Date().valueOf();
			if (!since) since = now - 1000 * 60 * 60 * 24 * 7;
			var user = $http.get('/youbanban/message/user', {
				params: {
					since: since
				}
			})
			.then($rest.embeds('user', 'userId', 'user'))
			.then(function (response) {
				for (var i in response.data.content) {
					var message = response.data.content[i];
					message.unread = true;
					db.put('message', message.id, message);
				}
				localStorage['message.time'] = now;
			});

			var position = window.positionService.position || { latitude: 0, longitude: 0 };
			var system = $http.get('/youbanban/message/system', {
				params: {
					lat: position.latitude,
					lon: position.longitude,
					since: since
				}
			})
			.then($rest.embeds('user', 'userId', 'user'))
			.then(function (response) {
				for (var i in response.data.content) {
					var message = response.data.content[i];
					message.unread = true;
					db.put('notif', message.id, message);
				}
				localStorage['message.time'] = now;
			});
			return {
				message: user,
				notif: system
			};
		};
		this.read = function (type) {
			db.foreach(type, function (message, id) {
				if (message.unread) {
					delete message.unread;
					db.put(type, id, message);
				}
			})
		};
	});
angular.module('starter')
.run(function ($rootScope, messageService) {
	$rootScope.$on('logout', function () {
		delete localStorage['message.time'];
		messageService.db.clear('message');
		messageService.db.clear('notif');
	});
});
