angular.module('starter.services')
	.service('offlineService', function ($cordovaFile, $file, Db,$rootScope,$ionicModal,$q) {
		this.db = new (Db('offline', ['poi']))();
		this.getFiles = getFiles;
		this.getCities = getCities;
		this.getModal = getModal;
		var offlineCityModal;
		function getFiles() {
			return $cordovaFile.checkDir(cordova.file.cacheDirectory, "poi")
				.then(function (x) {
					return x;
				}, function (e) {
					return $cordovaFile.createDir(cordova.file.cacheDirectory, "poi", false);
				}).then(function (entry) {
					return $file.getFiles(entry.toURL());
				});
		}
		function getCities() {
			return getFiles()
				.then(function (files) {
					return files.map(getCityName);
				});
		}
		function getCityName(file) {
			return file.isDirectory ?
				file.name :
				getFileNameWithoutExtension(file.name);
		}
		function getModal(){
			return (offlineCityModal?
					$q.resolve(offlineCityModal) :
					OfflineModal()
					).then(function (modal) {
						 offlineCityModal = modal;
						 return modal;
					})
		}
		function OfflineModal() {
			var scope  = $rootScope.$new();
			return $ionicModal.fromTemplateUrl("templates/offline.html", {
				scope: scope,	//needed for $ionicScrollDelegate.$getByHandle to work in modals, see https://github.com/driftyco/ionic/issues/4795
			});
		}
	});
