angular.module('starter.services')
.service('photoService', function ($q, $ionicActionSheet, $cordovaFile) {
	this.ImageInfo = function (url) {
		return $q(function (resolve, reject) {
			window.resolveLocalFileSystemURL(url, function (entry) {
				md5chksum.file(entry, function (md5) {
					CordovaExif.readData(url, function (exif) {
						resolve({ src: url, md5: md5, exif: exif });
					});
				}, function (e) {
					reject(e);
				});
			}, function (e) {
				reject(e);
			});
		});
	}
	this.getPhoto = function (multi,number) {
		return $q(function (resolve, reject) {
			var hide = $ionicActionSheet.show({
				buttons: [
					{ text: '选择照片' },
					{ text: '拍照' }
				],
				buttonClicked: function (index) {
					hide();
					if (multi && index == 0) {
						var ChooseImages = cordova.require('cordova-plugin-youbanban-chooseimages.chooseimages');
						ChooseImages.getPhotos(resolve, reject, [number]);
					}
					else
						navigator.camera.getPicture(function (imageUrl) {
							if (index ==1) {
								move(imageUrl).then(resolve);
							} else {
								resolve(imageUrl);
							}
						}, function (e) {
							reject(e);
						}, {
							sourceType: index,
							destinationType: Camera.DestinationType.FILE_URI,
							correctOrientation: true,
							saveToPhotoAlbum: true
						});
				}
			});
		}).then(function (url) {
			if (multi) {
				for (var i in url)
					if (url[i][0] == '/')
						url[i] = "file://" + url[i];
			}
			else
				if (url[0] == '/')
					url = "file://" + url;
			return url;
		}, function (e) {
			console.log(e);
		});
	};
	function move(url) {
		if (url[0] == '/') url = "file://" + url;
		var dir = url.substr(0, url.lastIndexOf('/') + 1);
		var name = url.substr(url.lastIndexOf('/') + 1);
		return $cordovaFile.createDir(cordova.file.externalRootDirectory + "Pictures/", "jsqy")
			.then(function () {
				return $cordovaFile.moveFile(dir, name, cordova.file.externalRootDirectory, "Pictures/jsqy/" + name);
			}, function () {
				return $cordovaFile.moveFile(dir, name, cordova.file.externalRootDirectory, "Pictures/jsqy/" + name);
			}).then(function () {
				return cordova.file.externalRootDirectory + "Pictures/jsqy/" + name;
			});
	}
	this.getMd5 = getMd5;
	function getMd5(url) {
		return $q(function (resolve, reject) {
			window.resolveLocalFileSystemURL(url, function (entry) {
				md5chksum.file(entry, function (md5) {
					resolve(md5);
				}, function (e) {
					reject(e);
				});
			}, function (e) {
				reject(e);
			});
		});
	}
	this.compress = compress;
	function compress(urls) {
		return $q.all(urls.map(getDimension))
			.then(function (dimensions) {
				return dimensions.map(function (dimension, i) {
					var height = Math.floor(dimension.height / dimension.width * 750);
					return {
						width: 750,
						height: height,
						url: urls[i].slice("file://".length)
					};
				});
			}).then(ngCompress);
	}
	this.compressThumbnail = compressThumbnail;
	function compressThumbnail(urls) {
		return $q.all(urls.map(getDimension))
			.then(function (dimensions) {
				return dimensions.map(function (dimension, i) {
					var height = Math.floor(dimension.height / dimension.width * 240);
					return {
						width: 240,
						height: height,
						url: urls[i].slice("file://".length)
					};
				});
			}).then(ngCompress);
	}
	function ngCompress(images) {
		return $q(function (resolve, reject) {
			var compress = cordova.require('cordova-plugin-youbanban-compress.compress');
			compress.compress(function (message) {
				var urls = message ? message.split(",") : [];	//"".split(',')=[""]
				for (var i in urls)
					if (urls[i][0] == '/')
						urls[i] = "file://" + urls[i]
				resolve(urls);
			}, function (message) {
				reject(message);
			}, images);
		});
	}
	this.getDimension = getDimension;
	function getDimension(url) {
		return $q(function (resolve, reject) {
			var image = new Image();
			image.onload = function () {
				resolve({ width: this.width, height: this.height });
			};
			image.onerror = reject;
			image.src = url;
		});
	}

	this.getDataUrl = getDataUrl;
	function getDataUrl(url) {
		if (url[0] == '/') url = "file://" + url;
		var dir = url.substr(0, url.lastIndexOf('/') + 1);
		var name = url.substr(url.lastIndexOf('/') + 1);
		return $cordovaFile.readAsDataURL(dir, name);
	}

	this.writeImg = writeImg;
	function writeImg(dataurl, url) {
		if (url[0] == '/') url = "file://" + url;
		var dir = url.substr(0, url.lastIndexOf('/') + 1);
		var name = url.substr(url.lastIndexOf('/') + 1);
		var blob = toBlob(dataurl);
		return $cordovaFile.writeFile(dir, name, blob, true);
	}

	function toBlob(dataurl) {
		var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1],
			bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
		while(n--){
			u8arr[n] = bstr.charCodeAt(n);
		}
		return new Blob([u8arr], {type:mime});
	}

	this.rotateImg = rotateImg;
	function rotateImg(info) {
		var deferred = $q.defer();
		var orientation = info.exif.Orientation;
		var src = info.src;
		var exifObj = {};
		var wait = getDataUrl(src).then(function (originalDataurl) {
			exifObj = piexif.load(originalDataurl);
			exifObj['0th']['274'] = 1;	//修改orientation
		});
		var image = new Image();
		image.onload = function () {
			var canvas = document.createElement("canvas");
			canvas.width = image.width;
			canvas.height = image.height;
			var ctx = canvas.getContext("2d");
			var x = 0;
			var y = 0;
			if (orientation == 2) {
				x = -canvas.width;
				ctx.scale(-1, 1);
			} else if (orientation == 3) {
				x = -canvas.width;
				y = -canvas.height;
				ctx.scale(-1, -1);
			} else if (orientation == 4) {
				y = -canvas.height;
				ctx.scale(1, -1);
			} else if (orientation == 5) {
				canvas.width = image.height;
				canvas.height = image.width;
				ctx.translate(canvas.width, canvas.height / canvas.width);
				ctx.rotate(Math.PI / 2);
				y = -canvas.width;
				ctx.scale(1, -1);
			} else if (orientation == 6) {
				canvas.width = image.height;
				canvas.height = image.width;
				ctx.translate(canvas.width, canvas.height / canvas.width);
				ctx.rotate(Math.PI / 2);
			} else if (orientation == 7) {
				canvas.width = image.height;
				canvas.height = image.width;
				ctx.translate(canvas.width, canvas.height / canvas.width);
				ctx.rotate(Math.PI / 2);
				x = -canvas.height;
				ctx.scale(-1, 1);
			} else if (orientation == 8) {
				canvas.width = image.height;
				canvas.height = image.width;
				ctx.translate(canvas.width, canvas.height / canvas.width);
				ctx.rotate(Math.PI / 2);
				x = -canvas.height;
				y = -canvas.width;
				ctx.scale(-1, -1);
			}
			ctx.drawImage(image, x, y);
			ctx.restore();
			var dataurl = canvas.toDataURL("image/jpeg", .8);
			wait.then(function () {
				var exifStr = piexif.dump(exifObj);
				var blob = toBlob(piexif.insert(exifStr, dataurl));
				var name = src.substr(src.lastIndexOf('/') + 1);
				$cordovaFile.writeFile(cordova.file.cacheDirectory + 'img/', name, blob, true)
					.then(function (success) {
						resolveLocalFileSystemURL(success.target.localURL, function (entry) {
							deferred.resolve(entry.toURL());
						})
					});
			})
		};
		image.src = src;
		return deferred.promise;
	}
})
