angular.module('starter.services')
  .service('poiService', function ($http, $rest, $remote, $cache, $request, $q, collectionCache, $cordovaFile, offlineService, $log) {
  	var categories = collectionCache.category();
  	function getType(category) {
  		return categories.then(function(categories){
  			for (var i in categories) {
  				var c = categories[i];
  				if (c.name == category)
  					return category;
				var d = c.children.find(function (child) {
					return child == category;
				});
				if (d) return c.name;
			}
  		});
  	}
  	var levels = {
  		"国家符号": 0,
  		"城市符号": 0,
  		"人文脉络": 1,
  		"品质物产": 1,
  		"风味美食": 2,
  		"风物特产": 2,
  		"风光美景": 2,
  		"风俗节庆": 2,
  		"风情典故": 2,
  		"饕餮之食": 3,
  		"耳目之娱": 3,
  		"游乐之玩": 3,
  		"愉悦之购": 3,
  		"怡情养性": 3
  	};
  	return {
  		get: function (id) {
  			return offlineService.db.get('poi', id)
				.then(function (city) {
					return city ?
						$cordovaFile.readAsText(
							"cdvfile://localhost/cache/poi/" + city + '/offlinedata/poi/',
							id + ".json"
						).then(JSON.parse)
						.then(function (poi) {
							poi.picture = cordova.file.cacheDirectory + 'poi/' + city + '/offlinedata/images' + poi.picture;
							$log.debug("offline picture: " + poi.picture);
							return poi;
						}):
						$request.get($rest.getType(id), id);
				});
  		},
      search: function (center, radius, zoom) {
      	var params = {
      		lat: center.lat,
      		lon: center.lng,
      		radius: Math.floor(radius)
      	};
      	if (zoom)
      		params.level = zoom;
      	return $http.get("/youbanban/poi/search/map", {
      		params: params
      	})
		.then($rest.join('poi'))
		.then(function (response) {
      		var pois = response.data;
      		for (var i in pois) {
      			var poi = pois[i];
      			if (poi.categories[0])
      				poi.level = getLevel(poi.categories[0]);
      			poi.location.lng = poi.location.lon;
      		}
      		return $q.all(
				pois.map(function (poi) {
					return getType(poi.categories[0])
						.then(function(type){
							poi.type = type;
						});
				})
			).then(function () {
				return response;
			});
      	});
      },
      searchByKeyword: function (keyword, city, country, category, page) {
      	return $http.get("/youbanban/poi/search/keyword", {
      		params: {
      			city: city,
				country: country,
      			keyword: keyword,
      			category: category.join(','),
      			page: page,
      			size: 10
      		}
      	})
		.then($rest.join('poi'))
		.then($rest.embeds('user', 'userId', 'user'));
      }
    }
  	function getLevel(category){
  		return levels[category];
  	}
  });
