angular.module('starter.services')
.service('pullingService', function ($http, $rest, eventNotification, messageService, $q, $rootScope) {
	return {
		pull: function () {
			$q.all(messageService.pull())
				.then(function () {
					$rootScope.$broadcast("pull");
				});
		},
		start: function () {
			this.pull();
			this.timer = setTimeout(angular.bind(this, this.start), 5 * 60 * 1000);
		},
		stop: function(){
			clearTimeout(this.timer);
		}
	};
});
angular.module('starter')
.run(function ($rootScope, pullingService) {
	$rootScope.$on('login', function () {
		if (localStorage.userType == 1) return;
		pullingService.start();
	});
	$rootScope.$on('logout', function () {
		pullingService.stop();
	});
});
