angular.module('starter.services')
.service('$remote', function ($q, $http, $cache, $request) {
	return {
		get: function (name, id) {
			var cached = $cache.$get(name, id);
			var url = "/youbanban/" + name;
			if (id != undefined) url += '/' + id;
			var now = new Date();
			return $http.get(url, {
				headers: {
					'If-Modified-Since':
						cached != undefined ? new Date(cached.$time) : undefined
				}
			})
				.then(function (response) {
					var data = response.data;
					data.$time = now;
					$cache.$set(name, id, data);
					return data;
				}, function (response) {
					if (response.status == 304) {
						cached.$time = now;
						return $q.resolve(cached);
					} else
						return $q.reject(response);
				});
		},
		gets: function (name, ids) {
			return $request.get.s(name, ids)
				.then(function (data) {
					return { data: data };
				});
		}
	};
});
