angular.module('starter.services')
.service('shareService', function ($http, $q, zoomService, $ionicLoading, $ionicModal) {

  this.shareTo = function(dst, data, scene){
    if(dst === 'QQ'){
      return shareToQQ(data, scene)
    } else if(dst === 'WeChat'){
      return shareToWeChat(data, scene);
    } else if(dst === 'Weibo'){
      return shareToWeibo(data);
    } else {
      console.err("unkonwn target: ", dst);
    }
  }
	//workaround: poi.picture可能已经被转换成离线数据包里的图片路径（本地文件系统路径）了
  function relativePath(path) {
  	return path.substr(path.indexOf("/goldenkiwi"));
  }
  function strip(text) {
  	text = '<p>' + text + '</p>';
  	return $(text).text();
  }
  function thumbnail(url) {
  	var path = relativePath(url);
  	return environment.host + "/imgs/zoom/" + zoomService(path, 'small') + path;
  }
  function shareToQQ(data, scene) {
  	if (scene == undefined)
  		scene = 'friend';
	  var destination = 'qq';
	var method =
		scene == 'friend' ?
			'shareToQQ' :
		scene == 'qzone' ?
			'shareToQzone' :
			undefined;
  	if (data.id.indexOf('poi')==0||data.id.indexOf('kn_card')==0) {
  		return encode(data.id).then(function (id) {
			var args = {
			  url: environment.host+'/mobile/app/#/app/poi-external/' + encodeURIComponent(id),
			  title: data.name,
			  description: strip(data.text).substr(0, 100),
			  imageUrl: environment.imagePrefix + relativePath(data.picture), //"http://imglf0.ph.126.net/LblalhmTkzfxH_lSqMARMw==/6597708582913268808.jpg",
			  appName: "游伴伴"
			};
			if (scene == 'qzone')
				args.imageUrl = [args.imageUrl];

			if (!window.app) {
				//webapp qq分享
				if (scene == 'qzone') {
					var url = 'http://sns.qzone.qq.com/cgi-bin/qzshare/cgi_qzshare_onekey?url=' + encodeURIComponent(args.url) + '&title=' + args.title + '&summary=' + args.description + '&pics=' + encodeURIComponent(args.imageUrl[0]);
				} else if (scene == 'friend') {
					var url = 'http://connect.qq.com/widget/shareqq/index.html?url=' + encodeURIComponent(args.url) + '&title=' + args.title + '&summary=' + args.description + '&pics=' + encodeURIComponent(args.imageUrl);
				}
				window.location.href = url;
			} else {
				return $q(function (resolve, reject) {
					YCQQ[method](function () {
						resolve(destination);
					}, function (reason) {
						reject(reason);
					}, args);
				});
			}
	  	});
  	} else if (data.id.indexOf('mood')==0){
  		return encode(data.id).then(function (id) {
  			var text = data.richContent.find(function (component) { return component.type == 'text'; });
			var args = {
			  url: environment.host+'/mobile/app/#/app/mood-external/' + encodeURIComponent(id),
			  title: data.rich ? data.title : "足迹",
			  description: data.rich ? (text ? text.value : "") : data.content,
			  imageUrl: environment.imagePrefix + (data.rich ? data.richContent.find(function (component) { return component.type == 'picture'; }).value : data.pictures[0]), //"http://imglf0.ph.126.net/LblalhmTkzfxH_lSqMARMw==/6597708582913268808.jpg",
			  appName: "游伴伴"
			};
			if (scene == 'qzone')
				args.imageUrl = [args.imageUrl];

			if (!window.app) {
				//webapp qq分享
				if (scene == 'qzone') {
					var url = 'http://sns.qzone.qq.com/cgi-bin/qzshare/cgi_qzshare_onekey?url=' + encodeURIComponent(args.url) + '&title=' + args.title + '&summary=' + args.description + '&pics=' + encodeURIComponent(args.imageUrl[0]);
				} else if (scene == 'friend') {
					var url = 'http://connect.qq.com/widget/shareqq/index.html?url=' + encodeURIComponent(args.url) + '&title=' + args.title + '&summary=' + args.description + '&pics=' + encodeURIComponent(args.imageUrl);
				}
				window.location.href = url;
			} else {
				return $q(function (resolve, reject) {
					YCQQ[method](function () {
						resolve(destination);
					}, function (reason) {
						reject(reason);
					}, args);
				});
			}
	  	});
  	}
  }

  function shareToWeChat(data, scene) {
  	if (scene == undefined)
  		scene = Wechat.Scene.TIMELINE;
  	var destination = 'wechat';
  	if (data.id.indexOf('poi')==0||data.id.indexOf('kn_card')==0) {
	  	return encode(data.id).then(function (id) {
	  		return $q(function (resolve, reject) {
	  			Wechat.share({
	  				message: {
	  					title: data.name,
	  					description: strip(data.text).substr(0, 100),
	  					thumb: thumbnail(data.picture),
	  					media: {
	  						type: Wechat.Type.WEBPAGE,
	  						webpageUrl: environment.host+'/mobile/app/#/app/poi-external/' + encodeURIComponent(id)
	  					}
	  				},
	  				scene: scene
	  			}, function () {
	  				resolve(destination);
	  			}, function (reason) {
	  				reject(reason);
	  			});
	  		});
	  	});
  	} else if (data.id.indexOf('mood')==0){
  		return encode(data.id).then(function (id) {
	  		return $q(function (resolve, reject) {
	  			var text = data.richContent.find(function (component) { return component.type == 'text'; });
	  			Wechat.share({
	  				message: {
	  					title: data.rich ? data.title : "足迹",
	  					description: data.rich ? (text ? text.value : "") : data.content,
	  					thumb:thumbnail(data.rich ? data.richContent.find(function (component) { return component.type == 'picture'; }).value : data.pictures[0]),
	  					media: {
	  						type: Wechat.Type.WEBPAGE,
	  						webpageUrl: environment.host+'/mobile/app/#/app/mood-external/' + encodeURIComponent(id)
	  					}
	  				},
	  				scene: scene
	  			}, function () {
	  				resolve(destination);
	  			}, function (reason) {
	  				reject(reason);
	  			});
	  		});
	  	});
  	}
  }

  function shareToWeibo(data){
  	if (data.id.indexOf('poi')==0||data.id.indexOf('kn_card')==0) {
	  	return encode(data.id).then(function (id) {
	  		var args = {
	  			url: environment.host + '/mobile/app/#/app/poi-external/' + encodeURIComponent(id),
	  			title: data.name,
	  			description: strip(data.text).substr(0, 100),
	  			imageUrl: environment.imagePrefix + relativePath(data.picture),//if you don't have imageUrl,for android http://www.sinaimg.cn/blog/developer/wiki/LOGO_64x64.png will be the defualt one
	  			defaultText: data.name
	  		};


			if (!window.app) {
				//webapp weibo分享
				var url = 'http://service.weibo.com/share/mobile.php?url=' + encodeURIComponent(args.url) + '&title=' + args.title + '&pic=' + encodeURIComponent(args.imageUrl[0]) + '&appkey=1749520627';
				window.location.href = url;
			} else {
				return $q(function (resolve, reject) {
					YCWeibo.shareToWeibo(function () {
						resolve('weibo');
					}, function (reason) {
						reject(reason);
					}, args);
				});
			}
	  	});
  	} else if (data.id.indexOf('mood')==0){
	  	return encode(data.id).then(function (id) {
  			var text = data.richContent.find(function (component) { return component.type == 'text'; });
	  		var args = {
	  			url: environment.host + '/mobile/app/#/app/mood-external/' + encodeURIComponent(id),
	  			title: data.rich ? data.title : "足迹",
	  			description: data.rich ? (text ? text.value : "") : data.content,
	  			imageUrl: thumbnail(data.rich ? data.richContent.find(function (component) { return component.type == 'picture'; }).value : data.pictures[0]),//if you don't have imageUrl,for android http://www.sinaimg.cn/blog/developer/wiki/LOGO_64x64.png will be the defualt one
	  		};

			if (!window.app) {
				//webapp weibo分享
				var url = 'http://service.weibo.com/share/mobile.php?url=' + encodeURIComponent(args.url) + '&title=' + args.title + '&pic=' + encodeURIComponent(args.imageUrl[0]) + '&appkey=1749520627';
				window.location.href = url;
			} else {
				return $q(function (resolve, reject) {
					YCWeibo.shareToWeibo(function () {
						resolve(5);
					}, function (reason) {
						reject(reason);
					}, args);
				});
			}
	  	});
  	}
  }

  function encode(id) {
  	return $http.get("/youbanban/poi/" + id + "/encode")
  		.then(function (response) {
  			return response.data;
  		});
  }

});
