angular.module('starter.services')
.service('speechService', function ($rootScope, offlineService, $filter, $q, audiocache) {
	return {
		play: function (poi) {
			if ($rootScope.speech.audio) {
				$rootScope.speech.audio.pause();
				if ($rootScope.speech.audio instanceof Element)	//workaround: Tts auto plays when currentTime is set
				$rootScope.speech.audio.currentTime = 0;
			}
			(poi.voice ?
				offlineService.db.get('poi', poi.id)
					.then(function (city) {
						return city ?
							cordova.file.cacheDirectory + "poi/" + city + '/offlinedata/voices' + poi.voice :
							ionic.Platform.isWebView() ?
								audiocache.request(environment.imagePrefix + poi.voice) :
								environment.imagePrefix + poi.voice;
					}).then(function (src) {
						var audio = document.createElement('audio');
						audio.setAttribute("src", src);
						audio.setAttribute("autoplay", "autoplay");
						return audio;
					}) :
					$q.resolve(function () {
						var text = $("<p>" + poi.text + "</p>").text();
						var audio = Tts(text);
						return audio;
					}())
			).then(function (audio) {
				audio.play();
				audio.addEventListener('ended', function () {
					audio.playing = false;
					$rootScope.speech.poi = null;
				});
				$rootScope.speech.poi = poi;
				$rootScope.speech.audio = audio;
				$rootScope.speech.audio.playing = true;
			});
		},
		pause:function(){
		},
		toggle: function () {
			var audio = $rootScope.speech.audio;
			if (audio.playing)
				audio.pause();
			else
				audio.play();
			audio.playing = !audio.playing;
		}
	};
});
