angular.module('starter.services')
.service('$storage', function ($resource, $db, $q) {
	var db;
	var promise = $db.open('storage', function (e) {
		db = e.target.result;
		for (var resource in $resource)
			if (!db.objectStoreNames.contains(resource))
				db.createObjectStore(resource);
	}).then(function (_db) {
		db = _db;
	});
	this.get = function (type, id) {
		return $db.get(db, type, id);
	};
	this.set = function (name, id, data) {
		var d = $q.defer();
		var tx = db.transaction([name], 'readwrite');
		var request = tx.objectStore(name).put(data, id);
		request.onsuccess = function () {
			d.resolve();
			var request = tx.objectStore(name).count();
			request.onsuccess = function (e) {
				//随机淘汰算法
				var count = e.target.result;
				if (count > $resource[name].capacity) {
					var i = Math.floor(count * Math.random());
					var cursor;
					var request = tx.objectStore(name).openCursor();
					request.onsuccess = function (e) {
						if (cursor != undefined)
							cursor.delete();
						else {
							cursor = e.target.result;
							if (i > 0)
								cursor.advance(i);
							else
								cursor.delete();
						}
					}
				}
			};
		};
		request.onerror = function () { d.reject(request.error); };
		return d.promise;
	};
	this.remove = function (type, id) {
		return $db.remove(db, type, id);
	};
	var $this = this;
	//get, set被调用时可能db还没打开
	angular.forEach(['get', 'set', 'remove'], function (method) {
		var f = $this[method];
		$this[method] = function () {
			var $arguments = arguments;
			return db ?
				f.apply($this, arguments) :
				promise.then(function () {
					return f.apply($this, $arguments);
				});
		};
	});
});
