angular.module('starter.services')
	.service('translateService', function (Db, $http) {
		var db = new (Db('translate', ['history']))();
		this.db = db;
		var $this = this;
		this.historyPromise = db.getAll('history').then(function (translation) {
			$this.history = translation;
		});
		var language = localStorage['translate.language'];
		language = language ? JSON.parse(language) : {
			source: { code: 'zh', name: "中文(简体)", nativeName: "中文(简体)", pinyin: "zhongwen(jianti)" },
			destination: { code: 'en', name: "英语", nativeName: "English", pinyin: "yingyu" }
		};
		this.language = { };
		Object.defineProperty(this.language, 'source', {
			get: function () { return language.source; },
			set: function (value) {
				language.source = value;
				localStorage['translate.language']= JSON.stringify(language);
			}
		});
		Object.defineProperty(this.language, 'destination', {
			get: function () { return language.destination; },
			set: function (value) {
				language.destination = value;
				localStorage['translate.language'] = JSON.stringify(language);
			}
		});
		this.translate = function (text, target) {
			return $http.get("/youbanban/batman/translation/text", {
				params: { text: text, target: target }
			}).then(function (response) {
				var data = response.data;
				data.list[0].translatedText =
					decode(data.list[0].translatedText);
				return data.list[0];
			})
		};
		this.translateAudio = function (audio, language, target) {
			return $http.post("/youbanban/batman/translation/audio", {
				audioCode: audio,
				encoding: "AMR_WB",
				rate: 16000,
				language: language,
				target: target
			}, {
				timeout: 20000
			}).then(function (response) {
				var data = response.data;
				if (data.status != "success")
					throw data.msg;
				data.list[0].translatedText =
					decode(data.list[0].translatedText);
				return data.list[0];
			})
		};
		function decode(text) {
			return text.replace("&#39;", '\'');
		}
	});
