angular.module('starter.services')
	.service('voiceRss', function ($q, $http) {
		function get(text, language) {
			var component = language.split('-');
			if (component.length == 2) language = component[0];
			var l = languages[language];
			if (!l) return $q.reject("language-not-supported");
			var l = l.last;
			if (l == 'no-nb') l = 'nb-no';
			return $http.get("https://api.voicerss.org", {
				params: {
					key: "f217fb8e592749c399a0069e1276703d",
					src: text,
					hl: l,
					r: "",
					c: 'mp3',
					f: '16khz_16bit_mono',
					ssml: '',
					b64: true
				},
				timeout: 20000
			}).then(function (response) {
				if (!response.data.match(/^data:/))
					throw response.data;
				return response.data;
			});
		};
		var languages = [
			"ca-es",
			"zh-hk",
			"zh-tw",
			"zh-cn",
			"da-dk",
			"nl-nl",
			"en-au",
			"en-ca",
			"en-gb",
			"en-in",
			"en-us",
			"fi-fi",
			"fr-ca",
			"fr-fr",
			"de-de",
			"it-it",
			"ja-jp",
			"ko-kr",
			"no-nb",
			"pl-pl",
			"pt-br",
			"pt-pt",
			"ru-ru",
			"es-mx",
			"es-es",
			"sv-se"
		];
		languages = languages.groupBy(function (l) { return l.split('-')[0]; });
		return get;
	});
