angular.module('starter')
.config(function($stateProvider, $urlRouterProvider, loginServiceProvider) {
  $stateProvider

    .state('app', {
        url: '/app',
        abstract: true,
        templateUrl: 'templates/menu.html',
        controller: 'AppCtrl'
    })

  .state('app.login', {
      url: '/login',
      views: {
          'menuContent': {
              templateUrl: 'templates/login.html',
              controller: 'LoginCtrl'
          }
      }
  })

  .state('app.forget', {
      url: '/forget',
      views: {
          'menuContent': {
              templateUrl: 'templates/forget.html',
              controller: 'forgetCtrl'
          }
      }
  })

  .state('app.home', {
      url: '/home',
      views: {
          'menuContent': {
              templateUrl: 'templates/home.html',
              controller: 'HomeCtrl'
          }
      }
  })

  .state('app.feedback', {
      url: '/feedback/:id',
      views: {
          'menuContent': {
              templateUrl: 'templates/feedback.html',
              controller: 'FeedbackCtrl'
          }
      }
  })

  .state('app.message', {
      url: '/message',
      views: {
          'menuContent': {
              templateUrl: 'templates/message.html',
              controller: 'MessageCtrl'
          }
      }
  })

  .state('app.collection', {
      url: '/user/:id/collection',
      views: {
          'menuContent': {
              templateUrl: 'templates/collection.html',
              controller: 'CollectionCtrl'
          }
      }
  })

  .state('app.poi', {
      url: '/poi/:id',
      views: {
          'menuContent': {
              templateUrl: 'templates/poi.html',
              controller: 'PoiCtrl'
          }
      }
  })

  .state('app.poi-external', {
      url: '/poi-external/{id:.*}',
      views: {
          'menuContent': {
              templateUrl: 'templates/poi.html',
              controller: 'PoiExternalCtrl'
          }
      }
  })

  .state('app.map', {
      url: '/map',
      views: {
          'menuContent': {
              templateUrl: 'templates/map.html',
              controller: 'MapCtrl'
          }
      }
  })

  .state('app.moods', {
      url: '/moods',
      views: {
          'menuContent': {
              templateUrl: 'templates/moods.html',
              controller: 'MoodsCtrl'
          }
      }
  })

  .state('app.user', {
      url: '/user/:id',
      views: {
          'menuContent': {
              templateUrl: 'templates/user.html',
              controller: 'UserCtrl'
          }
      }
  })

  .state('app.user-moods', {
      url: '/user/:id/user-moods',
      views: {
          'menuContent': {
              templateUrl: 'templates/user-moods.html',
              controller: 'UserMoodsCtrl'
          }
      }
  })

  .state('app.mood-draft', {
      url: '/user/:id/mood-draft',
      views: {
          'menuContent': {
              templateUrl: 'templates/mood-draft.html',
              controller: 'MoodDraftCtrl'
          }
      }
  })

  .state('app.mood', {
      url: '/mood/:id',
      views: {
          'menuContent': {
              templateUrl: 'templates/mood.html',
              controller: 'MoodCtrl'
          }
      }
  })

  .state('app.mood-external', {
      url: '/mood-external/{id:.*}',
      views: {
          'menuContent': {
              templateUrl: 'templates/mood.html',
              controller: 'ShareExternalCtrl'
          }
      }
  })

  .state('app.userdata', {
      url: '/userdata/:id',
      views: {
          'menuContent': {
              templateUrl: 'templates/userdata.html',
              controller: 'UserdataCtrl'
          }
      }
  })

  .state('app.nickname', {
      url: '/nickname',
      views: {
          'menuContent': {
              templateUrl: 'templates/nickname.html',
              controller: 'NicknameCtrl'
          }
      }
  })

  .state('app.signature', {
      url: '/signature',
      views: {
          'menuContent': {
              templateUrl: 'templates/signature.html',
              controller: 'SignatureCtrl'
          }
      }
  })

  .state('app.guide-video', {
      url: '/guide-video',
      cache: false,
      views: {
          'menuContent': {
              templateUrl: 'templates/guide-video.html',
              controller: 'GuideVideoCtrl'
          }
      }
  })

  .state('app.poi-search', {
      url: '/poi-search',
      views: {
          'menuContent': {
              templateUrl: 'templates/poi-search.html',
              controller: 'PoiSearchCtrl'
          }
      }
  })

  .state('app.creations', {
      url: '/user/:id/creations',
      views: {
          'menuContent': {
              templateUrl: 'templates/creations.html',
              controller: 'CreationsCtrl'
          }
      }
  })

  .state('app.browsehistory', {
      url: '/browsehistory',
      views: {
          'menuContent': {
              templateUrl: 'templates/browsehistory.html',
              controller: 'BrowseHistoryCtrl'
          }
      }
  })

	.state('app.bind-phone', {
      url: '/bind-phone',
      views: {
          'menuContent': {
              templateUrl: 'templates/bind-phone.html',
				controller: 'bindPhoneCtrl'
          }
      }
  })
  .state('app.translate', {
	  url: '/translate',
	  views: {
		  'menuContent': {
			  templateUrl: 'templates/translate.html',
			  controller: 'translateCtrl'
		  }
	  }
  })
  .state('app.translate-text', {
	  url: '/translate-text',
	  cache: false,
	  views: {
		  'menuContent': {
			  templateUrl: 'templates/translate-text.html',
			  controller: 'translateTextCtrl'
		  }
	  }
  })
  .state('app.translate-speech', {
	  url: '/translate-speech',
	  cache: false,
	  views: {
		  'menuContent': {
			  templateUrl: 'templates/translate-speech.html',
			  controller: 'translateTextCtrl'
		  }
	  }
  })
  .state('app.translation', {
	  url: '/translation/:id',
	  views: {
		  'menuContent': {
			  templateUrl: 'templates/translation.html',
			  controller: 'translationCtrl'
		  }
	  }
  })
  .state('app.share-create', {
	url: '/share-create?url',
	views: {
		'menuContent': {
			templateUrl: 'templates/share-create.html',
			controller: 'ShareCreateCtrl'
		}
	},
	cache: false
  })
  .state('app.mood-create', {
		url: '/mood-create?url',
		views: {
			'menuContent': {
				templateUrl: 'templates/mood-create.html',
				controller: 'MoodCreateCtrl'
			}
		}
  })
  .state('app.mood-edit', {
		url: '/mood-edit',
		params: { mood: null },
		abstract: true,
		views: {
			'menuContent': {
				template: '<div><ion-nav-view id=mood-edit-view></ion-nav-view></div>',	//see https://github.com/ionic-team/ionic/issues/4218#issuecomment-249892297
				controller: 'MoodEditCtrl'
			}
		}
  })
  .state('app.mood-edit.title', {
		url: '/title',
		templateUrl: 'templates/mood-edit/title.html',
		controller: 'MoodEditTitleCtrl',
		call: 'event'
  })
  .state('app.mood-edit.content', {
		url: '/content',
		templateUrl: 'templates/mood-edit/content.html',
		call: 'event'
  })
  .state('app.mood-edit.sort', {
	  url: '/sort',
	  templateUrl: 'templates/mood-edit/sort.html'
  })
  .state('app.mood-edit.draft', {
	  url: '/draft',
	  templateUrl: 'templates/mood-draft.html',
	  controller: 'MoodEditDraftCtrl'
  })
  .state('app.chainstore', {
  	  url: '/poi/:id/chainstore',
  	  views: {
  		  'menuContent': {
  			  templateUrl: 'templates/chainstore.html',
  			  controller: 'chainstoreCtrl'
  		  }
  	  }
  })
	.state('app.geobrowse', {
		url: '/geobrowse',
		onEnter: function ($q, $until, geobrowseService, $rootScope, $ionicHistory, $ionicPlatform, IONIC_BACK_PRIORITY) {
			if (!geobrowseService.isOpen) geobrowseService.open();
			$until(function () { return geobrowseService.isOpen; }, 100)
				.then(function () { geobrowseService.show(); });
		},
		onExit: function ($rootScope, geobrowseService) {
			geobrowseService.hide();
		},
		views: {
			'menuContent': {
				controller: 'GeobrowseCtrl',
				template:'<ion-view id=geobrowse-view hide-nav-bar="true"></ion-view>'
			}
		}
	})

	.state('app.event', {
		url: '/event/:id?url',
		onEnter: function ($state, $stateParams, $ionicHistory) {
			var url = environment.host + ($stateParams.url || "/funfair/event/" + $stateParams.id + '/intro');
			var eventactivity = cordova.require('cordova-plugin-event-activity.eventactivity');
			//delay 200ms before start event activity to workaround back navigation failure
			setTimeout(function () {
			eventactivity.start(url, localStorage.token, environment.version, $state.resolve, $state.reject);
			}, 200);
		},
		views: {
			'menuContent': {
				template:'<ion-view id=event-view hide-nav-bar="true"></ion-view>'
			}
		}
	})

	.state('testability', {
		url: '/testability',
		onEnter: function ($ionicModal, $rootScope, $ionicHistory, $ionicPlatform, IONIC_BACK_PRIORITY) {
			$ionicModal.fromTemplateUrl("templates/testability.html")
				.then(function (modal) {
					$rootScope.testabilityModal = modal;
					modal.show().then(function(){
						$rootScope.deregisterBackButtonAction = $ionicPlatform.registerBackButtonAction(function () {
							$ionicHistory.goBack();
						}, IONIC_BACK_PRIORITY.modal);
					});
				});
		},
		onExit: function ($rootScope) {
			$rootScope.deregisterBackButtonAction();
			$rootScope.testabilityModal.remove();
		},
		views: {
			'testability': {
				template: '<div><ion-nav-view></ion-nav-view></div>',
				controller: 'TestabilityCtrl'
			}
		}
	})

	.state('testability.home', {
		url: '/home',
		templateUrl: 'templates/testability/home.html'
	})

	.state('testability.storage', {
		url: '/storage',
		templateUrl: 'templates/testability/storage.html',
		controller: 'TestabilityStorageCtrl'
    })
    .state('app.vip', {
        url: '/vip',
        views: {
            'menuContent': {
                controller: 'VipCtrl',
                templateUrl: 'templates/vip.html'
            }
        }
    })
  // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/app/home');
});
